/*
 Program Name: accountInfoBean.java
 Author : Nandeesh
 Date : Feb, 2001
 Purpose:  To implement the functionality of accountInfo interface
*/


package portal.base;

import java.util.*;
import java.io.*;
import java.sql.*;
import java.text.SimpleDateFormat;

import portal.base.*;
import portal.bean.*;
import XMLParser;
import Document;
import Element;

public class AccountInfoBean implements AccountInfo
{

	static Calendar dCalendar = Calendar.getInstance();
	static SimpleDateFormat dFormat = new SimpleDateFormat ("MM/dd/yyyy");

	private DbUtil _myDbUtil;

	/* Initialise all necessary steps in the constructor */

	public AccountInfoBean()
	{
		_myDbUtil = new DbUtil();
	}

	/* Returns the vector having AccountId,FirstName,LastName,Company,AccountNumber..
	   for a given ispvnId  */
	public Vector getAccountlistbyIsp(String _pIsp)
	{
		StringBuffer _sqlFetch= new StringBuffer("");
		Vector _vSelected;

		_sqlFetch = _sqlFetch.append("SELECT a.id,a.FirstName,a.surName,a.company,a.account_no, ");
		_sqlFetch = _sqlFetch.append("a.CREDITCARD_NO, a.CREDITCARD_TYPE, a.PREPAID, b.amount ");
		_sqlFetch = _sqlFetch.append(" FROM account a,billing_balance b WHERE (a.ispvn_id =" + _pIsp );
		_sqlFetch = _sqlFetch.append( ") and (a.id = b.account_id)" );

		 System.out.println("value of sqlFetch = " + _sqlFetch);

		_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 9);

		return _vSelected;
	}


	/* Returns the vector having AccountId,FirstName,LastName,Company,AccountNumber..
		for a given criteria  */
	public Vector getAccountlistbyCriteria(String _pCriteria)
	{
		StringBuffer _sqlFetch= new StringBuffer("");
		Vector _vSelected;

		_sqlFetch = _sqlFetch.append("SELECT b.username, a.id, a.FirstName, a.surName, a.company, ");
		_sqlFetch = _sqlFetch.append("a.address1, a.address2, a.city, a.country_state, a.zip, ");
		_sqlFetch = _sqlFetch.append("a.country, a.phone, a.email, a.PREPAID, a.order_id ");
		_sqlFetch = _sqlFetch.append("  FROM account a, access_ b  " + _pCriteria);

		 System.out.println(" value of sqlFetch = " + _sqlFetch);

		_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 15);

		return _vSelected;
	}

	public String getAccountBalance(String OrderId)
	{	String sBal=null;
		Connection tConn=null;

		try {
		tConn = ConnectionPool.getConnection();
		Statement stmt = tConn.createStatement();
		ResultSet rset = stmt.executeQuery("select sum(total) from order_line where order_id="+OrderId);
		if(rset.next()) sBal = rset.getString(1);
		rset.close(); stmt.close();
		ConnectionPool.releaseConnection(tConn);
		} catch(Exception e) { ConnectionPool.releaseConnection(tConn); }
		if(sBal == null) sBal="0.00";
		return sBal;
	}

	public void getAccountInfo(Document inDoc, Document outDoc)
	{
		String sBal=null, sQuery;
		Connection tConn=null;
		Statement stmt;
		ResultSet rset;

		Element inRoot  = inDoc.getDocumentElement();
		Element outRoot = outDoc.getDocumentElement();

		try {
		String AccountId = inRoot.getAttribute("AccountId");
		String OrderId = inRoot.getAttribute("OrderId");
		//get Balance from order_line
		tConn = ConnectionPool.getConnection();
		stmt = tConn.createStatement();
		sQuery = "select sum(total) from order_line where order_id="+OrderId;
		rset = stmt.executeQuery(sQuery);
		if(rset.next()) sBal = rset.getString(1);
		rset.close(); stmt.close();
		if(sBal == null) sBal="0.00";
		outRoot.setAttribute("Balance", sBal);

		//get Calls from voip_cdr
		dCalendar = Calendar.getInstance();
		dCalendar.add(Calendar.DATE, -60);
		String cutoffDate = dFormat.format(dCalendar.getTime());
		cutoffDate = "to_date('"+cutoffDate+"', 'mm/dd/yyyy')";
		stmt = tConn.createStatement();
		stmt.setMaxRows(10);
		sQuery = "select to_char(timestamp, 'DD-MON-YY HH24:MI:SS'), called_id, calling_id, disconnect_cause, "+
				 "round(duration/60,0)||':'||MOD(duration,60), round(amount,2) "+
				 "from voip_cdr where timestamp > "+cutoffDate+" And account_id="+AccountId+" Order by timestamp desc";

		//check oracle index-- this query should be used if indexing is correct
		/*sQuery = "select to_char(timestamp, 'DD-MON-YY HH24:MI:SS'), called_id, calling_id, disconnect_cause, "+
				 "round(duration/60,0)||':'||MOD(duration,60), round(amount,2) "+
				 "from voip_cdr where account_id="+AccountId+" Order by timestamp desc";
		*/
		System.out.println("The Query is:\n"+sQuery+"\n");
		long stime = System.currentTimeMillis();
		rset = stmt.executeQuery(sQuery);
		System.out.println("Time Taken: "+(System.currentTimeMillis()-stime)+"\n");
		int count=0;
		while(rset.next() && count < 10)
		{	Element te = outDoc.createElement("CDR");
			outRoot.appendChild(te);
			te.setAttribute("Time", rset.getString(1));
			te.setAttribute("CalledId", rset.getString(2));
			te.setAttribute("CallingId", rset.getString(3));
			te.setAttribute("DiscCause", rset.getString(4));
			te.setAttribute("Duration", rset.getString(5));
			te.setAttribute("Amt", rset.getString(6));
			count++;
		}
		rset.close(); stmt.close();

		ConnectionPool.releaseConnection(tConn);
		}
		catch(Exception e) { ConnectionPool.releaseConnection(tConn); }
	}

	/*public void blockAccount(Document inDoc)
	{	String sBal=null;
		Connection tConn=null;

		try {
		tConn = ConnectionPool.getConnection();
		Element root = inDoc.getDocumentElement();
		String ActNo  = root.getAttribute("AccountId");
		String Action = root.getAttribute("Action");
		Statement stmt = tConn.createStatement();
		//String sQuery
		ResultSet rset = stmt.executeQuery("select sum(total) from order_line where order_id="+OrderId);
		if(rset.next()) sBal = rset.getString(1);
		rset.close(); stmt.close();
		ConnectionPool.releaseConnection(tConn);
		} catch(Exception e) { ConnectionPool.releaseConnection(tConn); }
		if(sBal == null) sBal="0.00";
		return sBal;
	}*/

	public static void main(String[] args)
	{
		AccountInfoBean tb = new AccountInfoBean();
		//System.out.println("Balance: "+tb.getAccountBalance(args[0]));
		XMLParser parser = new XMLParser();
		Document inDoc = parser.createDocument("Request");
		Document outDoc = parser.createDocument("Response");
		Element root = inDoc.getDocumentElement();
		root.setAttribute("AccountId", args[0]);
		root.setAttribute("OrderId", args[1]);
		tb.getAccountInfo(inDoc, outDoc);
		//System.out.println(parser.getXML(outDoc));
	}
}
