package portal.base;


import java.util.*;

import portal.bean.*;


/**
	* This class basically facilitates in setting and getting the values of transaction
	* object which logically maps to Transaction table and  all setX() and getX() methods
	*  are self explanatory.
 */

public class BillingTransaction {

  private String _id="";
  private String _transType="";
  private String _accountId="";
  private String _ispvnId="";
  private String _amount="";
  private String _note="";
  private String _status="";
  private String _operatorId="";
  private String _referenceId="";
  private String _description="";
  private String _ccType="";
  private String _checkNo="";
  private String _creditType="";
  private String _timeStamp="";
  private String _balance="";  //balance for the account of transaction
  private String _transTerms="";
  private String _ccNum="";
  private String _ccExpMonth="";
  private String _ccExpYear="";
  private String _checkDate="";
  private String 	_checkBank="";
  private int _SuccessFailureNumber = 0;
  private String _startBillPeriod="";
  private String _endBillPeriod="";



  private DbUtil _myDbUtil;

	public BillingTransaction () {
		_myDbUtil = new DbUtil();
	}



  public void setTransId(String _pTransId) throws Exception{
	  _id=_pTransId;
   }

  public String getTransId( ) { return _id; }

  public void setTransType(String _pTtransType) throws Exception{
  	  _transType=_pTtransType;
     }

   public String getTransType() {
  	  return _transType;
   }

  public void setAccount(String _pAccountId) throws Exception{
  	_accountId = _pAccountId;
  }

  public String getAccount() {
  	 return _accountId ;
  }

  public void setIspvn(String _pIspvnId) throws Exception{
  	_ispvnId = _pIspvnId;
  }

  public String getIspvn() {
  	 return _ispvnId ;
  }

  public void setAmount(String _pAmount) throws Exception{
  	_amount = _pAmount;
  }

  public String getAmount() {
  	return _amount ;
  }

  public void setNote(String _pNote) throws Exception{
  	_note = _pNote;
  }

  public String getNote() {
  	return _note;
  }

  public void setStatus(String _pStatus) throws Exception {
  	_status = _pStatus;
  }

  public String getStatus() {
  	return _status ;
  }


  public void setOperator(String _pOperatorId) throws Exception{
  	_operatorId = _pOperatorId;
  }

  public String getOperator() {
  	return _operatorId ;
  }

  public void setReference(String _pReference) throws Exception{
  	_referenceId = _pReference;
  }

  public String getReference() {
  	return _referenceId ;
  }

  public void setDescription(String _pDescription) throws Exception{
  	_description = _pDescription;
  }

  public String getDescription() {
  	return _description ;
  }

  public void setCCType(String _pCCType) throws Exception{
  	_ccType = _pCCType;
  }

  public String getCCType() {
  	 return _ccType ;
  }

  public void setCheckNo(String _pCheckNo) throws Exception{
  	_checkNo = _pCheckNo;
  }

  public String getCheckNo() {
  	 return _checkNo ;
  }

 public void setCreditType(String _pCreditType) {
	 _creditType = _pCreditType;}

 public String getCreditType() { return _creditType;}

 public void setTimeStamp(String _pTimeStamp) throws Exception{
 	  _timeStamp=_pTimeStamp;
    }

 public String getTimeStamp( ) { return _timeStamp; }

 public void setBalance(String _pBalance) throws Exception{
  	  _balance=_pBalance;
    }

 public String getBalance( ) { return _balance;}



 public void setCheckBank(String _pCheckBank) throws Exception{
 	  _checkBank = _pCheckBank;
    }

 public String getCheckBank( ) { return _checkBank; }

 public void setCheckDate(String _pCheckDate) throws Exception{
 	  _checkDate = _pCheckDate;
    }

 public String getCheckDate( ) { return _checkDate; }

 public void setExpYear(String _pCcExpYear) throws Exception{
 	  _ccExpYear = _pCcExpYear;
    }

 public String getExpYear( ) { return _ccExpYear; }


 public void setExpMonth(String _pCcExpMonth) throws Exception{
 	  _ccExpMonth = _pCcExpMonth;
    }

 public String getExpMonth( ) { return _ccExpMonth; }


 public void setCcNum(String _pCcNum) throws Exception{
 	  _ccNum = _pCcNum;
    }

 public String getCcNum( ) { return _ccNum; }


 public void setTransTerms(String _pTransTerms) throws Exception{
 	  _transTerms=_pTransTerms;
    }

  public String getTransTerms( ) { return _transTerms; }


 public void setStartBillPeriod(String _pStartBillPeriod) throws Exception{
   _startBillPeriod = _pStartBillPeriod;
  }

 public String getStartBillPeriod() throws Exception{
   return _startBillPeriod ;
  }

 public void setEndBillPeriod(String _pEndBillPeriod) throws Exception{
   _endBillPeriod = _pEndBillPeriod;
  }

 public String getEndBillPeriod() throws Exception{
   return _endBillPeriod ;
  }


    // gets the next Transaction id in the sequence

	private String getNextTransactionId() {

		 StringBuffer _sqlFetch= new StringBuffer("");
		 Vector _vTransId;

		 // Fetch the next transaction Id from the sequence.
		_sqlFetch = _sqlFetch.append("SELECT transaction_seq.nextval FROM dual");

		_vTransId = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 1);
		String[] _returned = (String[]) (_vTransId.firstElement());
		System.out.println("the next transaction Id from vector --" + _returned[0]);
		return _returned[0];  // the transId
	}


	/**
		* This method inserts a record into the transaction table. Necessary values of
		* transaction table must be set by respective setX() methods. Along with insertion,
		* a Billing_balance record will be updated. All these operations are part of database
		* transaction.
		* @return   String If success,new transaction Id will returned; otherwise 0(zero) will be returned

		* @param    Nothing  setting implicitly appropriate values of transaction object values is assumed.
	 */

public String InsertTransaction() {

	  // This inserts the transaction record into the transaction table.

	  // All the nesseary values should be set using Set methods...before calling this


	/* String accountId, String ispvnId, String amount,
       String operatorId, String referenceId,
	   String description, String ccType, String chequeNo */

		String _status = "\'A\'";
		StringBuffer _sqlInsert= new StringBuffer("");

		String _TransactionTime;
		int _insertSuccess;

		_id = getNextTransactionId();   //get the next Transaction Id


			// boolean validValues = true;

//startDate.equals("*")
			if (_accountId.equals("")) _accountId = "0";
			if (_ispvnId.equals("")) _ispvnId = "0";
			if (_amount.equals("")) _amount = "0";
			if (_referenceId.equals("")) _referenceId = "0";
			if (_checkNo.equals("")) _checkNo = "0";
			if (_ccExpMonth.equals("")) _ccExpMonth = "0";
			if (_ccExpYear.equals("")) _ccExpYear = "0";
			if (_operatorId.equals("")) _operatorId = "0";


			// build the sql

			_sqlInsert = _sqlInsert.append("INSERT INTO Transaction (id,trans_type,account_id,ispvn_id,amount,");
			_sqlInsert = _sqlInsert.append("note,status,reference_id,operator,description,cc_type,check_no,timestamp, " );
			_sqlInsert = _sqlInsert.append("trans_terms,cc_num,cc_expmonth,cc_expyear,check_date,check_bank, " );
			_sqlInsert = _sqlInsert.append(" start_billperiod, end_billperiod) " );

			_sqlInsert = _sqlInsert.append("VALUES (" + _id + ",");
			_sqlInsert = _sqlInsert.append("upper('" + _transType +"'),");
			_sqlInsert = _sqlInsert.append(_accountId + ",");
			_sqlInsert = _sqlInsert.append(_ispvnId + ",");

			_sqlInsert = _sqlInsert.append(_amount + ",");

			if (_note.equals("")) _sqlInsert = _sqlInsert.append("null,");
			   else _sqlInsert = _sqlInsert.append("\'" + _note + "\',");
			_sqlInsert = _sqlInsert.append(_status + ",");
			_sqlInsert = _sqlInsert.append(_referenceId + ",");
			_sqlInsert = _sqlInsert.append(_operatorId + ",");
			if (_description.equals("")) _sqlInsert = _sqlInsert.append("null,");
				else _sqlInsert = _sqlInsert.append("\'" + _description + "\',");
			if (_ccType.equals("")) _sqlInsert = _sqlInsert.append("null,");
				else _sqlInsert = _sqlInsert.append("\'" + _ccType + "\',");
			if (_checkNo.equals("0")) { //_sqlInsert.setLength(_sqlInsert.length()-1);
								   _sqlInsert = _sqlInsert.append("null,"); }
				else _sqlInsert = _sqlInsert.append("\'" + _checkNo + "\',");
			_sqlInsert = _sqlInsert.append(" new_time(sysdate,'EST','GMT'),");

			if (_transTerms.equals(""))
				_sqlInsert = _sqlInsert.append("null,");
			else
				_sqlInsert = _sqlInsert.append("'" + _transTerms + "',");

			if (_ccNum.equals(""))
				_sqlInsert = _sqlInsert.append("null,");
			else
				_sqlInsert = _sqlInsert.append("'" + _ccNum + "',");

			_sqlInsert = _sqlInsert.append(_ccExpMonth + ",");
			_sqlInsert = _sqlInsert.append(_ccExpYear + ",");
			_sqlInsert = _sqlInsert.append(" to_date('" + _checkDate + "','MM/DD/YYYY')" );
			_sqlInsert = _sqlInsert.append(",'" + _checkBank + "',");

			if (_startBillPeriod.equals("sysdate"))
				_sqlInsert = _sqlInsert.append("sysdate,");
			else
				_sqlInsert = _sqlInsert.append("to_date('" + _startBillPeriod + "','mm/dd/yyyy'),");

			if (_endBillPeriod.equals("sysdate"))
				_sqlInsert = _sqlInsert.append("sysdate)");
			else
				_sqlInsert = _sqlInsert.append("to_date('" + _endBillPeriod + "','mm/dd/yyyy'))");

			System.out.println("Before inserting the value of _sqlInsert .... ");

			_myDbUtil.beginTrans();

			_SuccessFailureNumber =_myDbUtil.ExecuteUpdateQuery(_sqlInsert.toString());
				//_SuccessFailureNumber =1;
				if (_SuccessFailureNumber > 0 ) {
						_sqlInsert.setLength(0);
						//System.out.println(" value of _SuccessFailureNumber after insert " + _SuccessFailureNumber);
						//if (_creditType.equals("CREDIT")) _amount = "-" + _amount;

						_sqlInsert = _sqlInsert.append("UPDATE billing_balance set amount = amount + " + _amount );
						_sqlInsert = _sqlInsert.append(" WHERE  account_id = " + _accountId);

						//System.out.println("\n Trying to update-->" + _sqlInsert.toString());
						_SuccessFailureNumber = _myDbUtil.ExecuteUpdateQuery(_sqlInsert.toString());
						if (_SuccessFailureNumber > 0 ) {
							//System.out.println("\n commit ... _SuccessFailureNumber -->" + _SuccessFailureNumber );
							_myDbUtil.commitTrans();
							 return _id;
				   		    }
				   		else {
								//System.out.println("\n roll back ... _SuccessFailureNumber --> " + _SuccessFailureNumber);
								_myDbUtil.rollback();
								return "0";
						     }
                     }
				else {
					_myDbUtil.rollback();
					return "0";
				    }
	}

	/**
		* This cancels the current transaction record (so call setTransId before calling this method)
		* This cancel operation makes a new entry in the Transaction table with proper
		* value of TRANS_TYPE  (eg., CADJ for canceling Adjustments, CINV for
		* canceling Invoice etc.,) , REFERENCE_ID will have the ID of transaction to which
		* this cancellation applies; Amount need not be mentioned and the cancelled Transaction's record will be updated
		* with STATUS value set to A.
		* @return   String  If success,new transaction Id will be returned; otherwise 0(zero) will be returned

		* @param    Nothing  call to setTransId() is assumed before invoking this method.
	 */

	  // This cancels the current transaction record (so call setTransId before
		  // calling tis method..
		  // Returns the new Transaction Id if the operation is successful or 0 if failed.

		  public String cancelTransaction() {

		   // get account_Id and ispvn_Id for given transaction from table.

			StringBuffer _sqlFetch= new StringBuffer("");
			StringBuffer _sqlInsert= new StringBuffer("");

			Vector _vSelected;


			_sqlFetch = _sqlFetch.append("SELECT account_id,ispvn_id FROM transaction ");
			_sqlFetch = _sqlFetch.append(" WHERE id = " + _id);
			_sqlFetch = _sqlFetch.append(" AND trans_type = '" + _transType + "'");
			_sqlFetch = _sqlFetch.append(" AND status = 'A'");

			_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 2);

			if (_vSelected.size() == 0) {
				_vSelected = null;
				return "0";  }  // no such transaction exist

			String[] _returned = (String[]) (_vSelected.firstElement());
			System.out.println("the account Id from vector --" + _returned[0]);
			System.out.println("the ispvn Id from vector --" + _returned[1]);

			_accountId=_returned[0];
			_ispvnId=_returned[1];
			_vSelected = null;

			// Update the given transaction subject to cancellation.

			_sqlInsert = _sqlInsert.append("UPDATE transaction SET status = 'C' WHERE id = '" + _id + "'");


			_myDbUtil.beginTrans();
					if (_myDbUtil.ExecuteUpdateQuery(_sqlInsert.toString()) == 0 ) {
						_myDbUtil.rollback();
					  		return "0";
					    }

					_sqlInsert.setLength(0);

					// Insert the new Cancel transaction record
					_referenceId = _id;  // save the Transaction number
					_id = getNextTransactionId();  // get the next transaction number.

					_sqlInsert = _sqlInsert.append("INSERT INTO Transaction (id,trans_type,account_id,ispvn_id");
					_sqlInsert = _sqlInsert.append(",status,reference_id,operator,timestamp) ");

					_sqlInsert = _sqlInsert.append("VALUES (" + _id + ",");
					_sqlInsert = _sqlInsert.append("'" + _transType + "',");
					_sqlInsert = _sqlInsert.append(_accountId + ",");
					_sqlInsert = _sqlInsert.append(_ispvnId + ",");

					_sqlInsert = _sqlInsert.append( "'A',");   //_status
					_sqlInsert = _sqlInsert.append(_referenceId + ",");
					_sqlInsert = _sqlInsert.append(_operatorId + ",");

					//_sqlInsert = _sqlInsert.append("\'" + _myDate.toString() + "\')");
					_sqlInsert = _sqlInsert.append("sysdate)");

					System.out.println("Before inserting the value of _sqlInsert .... ");
					//System.out.println(_sqlInsert);

					if (_myDbUtil.ExecuteUpdateQuery(_sqlInsert.toString()) > 0 ) {
						_myDbUtil.commitTrans();
						return _id;}
					else {
						_myDbUtil.rollback();
						return "0"; }
		}


}



