

package portal.bean;

import java.sql.*;


public class ConnectionPool
{
	private static final String dbName  = "ims.moe";
	//private static final String dbName  = "imsbackup";
	private static final String userID  = "ims";
	private static final String userPwd = "ims";
	private static final String dbURL   = "jdbc:oracle:oci8:@"+dbName;

	private static final int MAX_CONNECTIONS = 10;
	private static final int WAIT_LOCKMILLIS = 2;

	private static Connection[] connList = new Connection[MAX_CONNECTIONS];
	private static boolean[] connUnavailable = new boolean[MAX_CONNECTIONS];
	private static boolean   isUnregistered  = true;

	public static Connection getConnection() throws Exception
	{
		if(isUnregistered)
		{	DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());
			isUnregistered = false;
		}

		synchronized(connUnavailable)
		{
		while(true)
		{	for(int i=0; i < MAX_CONNECTIONS; i++)
			{
				if(connUnavailable[i]) continue;
				//if(connList[i] == null || connList[i].isClosed())
					connList[i] = DriverManager.getConnection(dbURL, userID, userPwd);
				connUnavailable[i] = true;
				return connList[i];
			}
			connUnavailable.wait(WAIT_LOCKMILLIS);
		}
		}
	}

	public static void releaseConnection(Connection tConn)
	{
		synchronized(connUnavailable)
		{	for(int i=0; i < MAX_CONNECTIONS; i++)
				if(connList[i] == tConn)
				{
					try { tConn.close();	} catch (Exception e) { } //latest hack
					connUnavailable[i] = false;
					break;
				}
		}
	}

	protected void finalize() throws Throwable
	{
		for(int i=0; i < MAX_CONNECTIONS; i++)
		{	if(connList[i] == null || connList[i].isClosed()) continue;
			//connList[i].close();	//latest hack
		}
	}
}
