/***************************************************************************************/
// File: DbBean.java
// Date: 02/07/2001
//
// Author: Amelia M. Chan
/***************************************************************************************/

package portal.bean;


import java.sql.*;
import java.io.*;
import java.util.*;
import java.sql.Date;


public class DbBean extends ConManager
{
  private String myQuery ;
  private int noColumns ;
  ResultSet myResultSet = null;
  Statement stmt = null;

  public DbBean() {
      super();
  	  myQuery = "";
  	  myResultSet = null;
      noColumns = 0;
      stmt = null;
  }


/********************************************************************
* Method:   setMyQuery(String s)
*
* Purpose:  This method sets myquery.
*********************************************************************/

public void initResultSet(){
	myResultSet = null;
}



/********************************************************************
* Method:   setMyQuery(String s)
*
* Purpose:  This method sets myquery.
*********************************************************************/

 public void setMyQuery(String s){
	myQuery = s;
  }


/********************************************************************
* Method:   getNextRecord()
*
* Purpose:  This method gets next record.
*********************************************************************/

  public boolean getNextRecord() throws Exception
  {
//System.out.println("in_out DbBean.getNextRecord");

    return myResultSet.next();
  }



/********************************************************************
* Method:   String getColumn( String inCol)
*
* Purpose:  This method gets field(String) by field's name in a record.
*********************************************************************/

  public String getColumn( String inCol) throws Exception
  {
    return myResultSet.getString(inCol);
  }

/********************************************************************
* Method:  String getColumn( int inCol)
*
* Purpose:  This method gets field(String) by column's index in a record.
*********************************************************************/

 public String getColumn( int inCol) throws Exception
  {
    return myResultSet.getString(inCol);
  }


/********************************************************************
* Method:  int getColumn( String inCol)
*
* Purpose:  This method gets field(int) by column's name in a record.
*********************************************************************/

  public int getColumnInt( String inCol) throws Exception
  {
    return myResultSet.getInt(inCol);
  }


/********************************************************************
* Method:  long getColumn( String inCol)
*
* Purpose:  This method gets field(int) by column's name in a record.
*********************************************************************/

  public long getColumnLong( int inCol) throws Exception
  {
    return myResultSet.getLong(inCol);
  }



/********************************************************************
* Method:  int getColumnInt( int inCol)
*
* Purpose:  This method gets field(int) by column's index in a record.
********************************************************************

  public int getColumnInt(int inCol) throws Exception
  {
    return myResultSet.getInt(inCol);
  }


/********************************************************************
* Method:  double getColumnDouble( String inCol)
*
* Purpose:  This method gets field(int) by column's index in a record.
*********************************************************************/

  public double getColumnDouble(String inCol) throws Exception
  {
    return myResultSet.getDouble(inCol);
  }



/********************************************************************
* Method:  double getColumnDouble( int inCol)
*
* Purpose:  This method gets field(int) by column's index in a record.
*********************************************************************/

  public double getColumnDouble(int inCol) throws Exception
  {
    return myResultSet.getDouble(inCol);
  }

/********************************************************************
* Method:  double getColumnDouble( int inCol)
*
* Purpose:  This method gets field(int) by column's index in a record.
*********************************************************************/

  public Date getColumnDate(String inCol) throws Exception
  {
    return myResultSet.getDate(inCol);
  }


/********************************************************************
* Method:  double getColumnDouble( int inCol)
*
* Purpose:  This method gets field(int) by column's index in a record.
*********************************************************************/

  public Date getColumnDate(int inCol) throws Exception
  {
    return myResultSet.getDate(inCol);
  }

/********************************************************************
* Method:  boolean getRecords()
*
* Purpose:  This method executes query.
*********************************************************************/

  public boolean getRecords()     throws Exception
  {
   // String myQuery = myEmpSQL;
       stmt = myConn.createStatement();
// 3/19/2001 needs to initialize each time before execute Query.
     myResultSet = null;
     myResultSet = stmt.executeQuery(myQuery);
     return (myResultSet != null);
   }


/********************************************************************
* Method: boolean execute_sql(String sqlString)
*
* Purpose:  This method executes query.
* 3/15/2001 achan. moved makeConnection from IMSInvoice.java here.
*                  moved catch Exception from IMSInvoice.java.
*********************************************************************/

   public void execute_sql(String sqlString)     throws Exception
  {
     myQuery = sqlString;
     // 3/19/2001 needs to initialize each time before execute Query.
     myResultSet = null;

     try{
         makeConnection();
         stmt = myConn.createStatement();
         myResultSet = stmt.executeQuery(myQuery);
	 }
	 catch (Exception ex)
	 {
		 System.out.println("Error Connection - 1:    "+ex);
     }

     //return (myResultSet != null);
   }

/********************************************************************
* Method: boolean loadData()
*
* Purpose:  This method executes query.
*********************************************************************/

   public boolean loadData()     throws Exception
  {
     return (myResultSet != null);
   }


/********************************************************************
* Method: int getNoColumn()
*
* Purpose:  This method returns the number of collumns in the result
*           set.
*********************************************************************/

   public int getNoColumn()  throws Exception
   {
     ResultSetMetaData metaData = myResultSet.getMetaData();
     noColumns =  metaData.getColumnCount();
     return noColumns;
   }


/********************************************************************
* Method: void cleanup()
*
* Purpose:  This method closes stmt.
*********************************************************************/
  public void cleanup() throws Exception
   {
    stmt.close();
   }

}
