// DebugWriter.java
/***************************************************************************************/
// Program Name: DebugWriter.java
//
//
//
// Date Written: November, 2000
//
// Author: H. Huang
//
// Purpose: This class can be used for writing something to a file .
//          It is used for debugging purpose.
//
//
// Update(s):
/**************************************************************************************/


package portal.bean;

import java.io.*;
import java.util.Date;
/***********************
 * This class can be used for writing error and logging output to a
 * log file. The default file name for output is 'errors.log'.

 ***********************************/

public class DebugWriter{

	/************
     * Overloaded method to write string to
     * pre-defined debug file.
	 * @param String the name of the string to write
	**********************/

	public void writeDebug(String s){
		writeDebug(s, debugFile);
   	}



	/************
     * Overloaded method to write string to
     * pre-defined debug file.
	 * @param String s: the name of the String to write
	 * @param String sFile: the name of the file to write to
	 **********************/
	public void writeDebug(String s, String sFile ){

	   try{

           File dir = new File(dirName);  // File object for directory

           if(!dir.exists()) {             // If directory does not exist
             dir.mkdir();
	      }
            File aFile = new File(dirName, sFile  );

            PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));
            out.println(new Date( System.currentTimeMillis() ).toString() + "\n\n"+s);
            out.close();


	    }
	    catch(Exception ex){
		 System.out.println("Error writing debug log in writeDebug : "+ex);
          }

	}

	/***************************
     * Sets the name of the  debug file name
     * @param String s: the file name
     ***************/
	public void setDebugFileName(String s){
		debugFile = s;
	}

 //   String dirName = "C:/jws/servlets/ibasis/logs";
	String dirName = "D:/Temp/Debug";

	/** Default debug file name is errors.log */
	private String debugFile = "debugtxt";
}