// FilePageWriter.java
/***************************************************************************************/
// Program Name: FilePageWriter.java
//
//
//
// Date Written: November, 2000
//
// Author: H. Huang
//
// Purpose: This class can be used for writing sql result into a page.
//
//
//
// Update(s):  May 2001
/**************************************************************************************/

package portal.bean;


import java.io.*;
import java.util.*;


public class FilePageWriter{
  // private static final String xmlDirName = "/usr/local/jakarta/jakarta-tomcat/webapps/ROOT/portal/logs/";
  // private static final String  dirName = "/usr/local/jakarta/jakarta-tomcat/webapps/ROOT/portal/logs/";

   private static final String xmlDirName = "/jws/public_html/portal/logs/";
   private static final String  dirName = "/jws/public_html/portal/logs/";

   private String  exportURL ;

   private String fileName ;
   private String title ;
   private String paramList  ;

   private String headLine ;
   private String provider ;
   private int recordNum ;
   private  Vector resultSetV ;

   public FilePageWriter() {
     fileName = "temp.txt";
     title = "" ;
     headLine = "" ;
     provider = "";
     recordNum = 0 ;
  }


/********************************************************************
* Method:  void getExportURL()
*
* Purpose:  This method returns the prefix of a link to an export file.
*
*********************************************************************/

 public String getExportURL() {
		try {
			java.net.Socket ts = new java.net.Socket("www.yahoo.com", 80);
		//	String IpAddr = ts.getLocalAddress().getHostAddress() + ":8080";
			String IpAddr = ts.getLocalAddress().getHostAddress();
			ts.close();
			exportURL = IpAddr+"/portal/logs/";
			System.out.println("Added Portal Servlet on "+IpAddr);
		}
				catch(Exception e)
		{
			System.out.println("Error in FilepageWriter: opening TCP/IPsocket for exportURL: "+e.toString());

		}
    return  exportURL ;
 }


/********************************************************************
* Method:  void getXmlDirName()
*
* Purpose:  This method returns the XML file directory name
*
*********************************************************************/

 public String getXmlDirName() {
    return  xmlDirName  ;
 }


/********************************************************************
* Method:  void getXmlfileName()
*
* Purpose:  This method returns the XML file name
*
* parameter:
*********************************************************************/

 public String getXmlFileName() {
    return  xmlDirName + fileName + ".xml";
 }

/********************************************************************
* Method:  void getCSVDirName()
*
* Purpose:  This method returns the csv file directory name
*
*********************************************************************/

 public String getCSVDirName() {
    return  dirName   ;
 }



/********************************************************************
* Method:  void getCSVFileName()
*
* Purpose:  This method returns the csv file name
*
* parameter:
*********************************************************************/

 public String getCSVFileName() {
    return  dirName + fileName + ".csv" ;
 }

/********************************************************************
* Method:   setFileName(String s)
*
* Purpose:  This method sets fileName.
*********************************************************************/

  public void setFileName(String s){
	fileName = s;
  }


/********************************************************************
* Method:  setTitle(String s)
*
* Purpose:  This method sets title.
*********************************************************************/

  public void setTitle(String s){
	title = s;
  }


/********************************************************************
* Method:  setTitle(String s)
*
* Purpose:  This method sets title.
*********************************************************************/

  public void setParamList(String s){
	paramList = s;
  }


/********************************************************************
* Method:  setHeadLine(String s)
*
* Purpose:  This method sets header.
*********************************************************************/

  public void setHeader(String s){
	headLine = s;
  }

/********************************************************************
* Method:  setProvider(String s)
*
* Purpose:  This method sets provider.
*********************************************************************/

  public void setProvider(String s){
	provider = s;
  }

/********************************************************************
* Method:  setRecordNum(int i)
*
* Purpose:  This method sets recordNum.
*********************************************************************/

  public void setRecordNum(int i){
	recordNum = i;
  }

/********************************************************************
* Method:  getRecordNum()
*
* Purpose:  This method return recordNum.
*********************************************************************/

  public int getRecordNum(){
	 return recordNum ;
  }

/********************************************************************
* Method:   setResultSetV (Vector  v)
*
* Purpose:  This method sets resultSetV  .
*********************************************************************/

  public void setResultSetV(Vector  v){
	resultSetV  = v;
  }



/********************************************************************
* Method:   getResultSetV ()
*
* Purpose:  This method returns resultSetV  .
*********************************************************************/

  public Vector getResultSetV( ){
	 return  resultSetV ;
  }

/********************************************************************
* Method:  writePageTable(DBApp db_App, PrintWriter out)
*
* Purpose:  This method writes sql results into a HTML page.
*********************************************************************/


 public void writePageTable(DBApp db_App, PrintWriter out)  throws Exception{
     int i, beginCol, noColumn, no;
     noColumn = no = 0;
     noColumn = db_App.getNoColumn();

     if (db_App.loadData()){
        if( provider.equals("ALL") )
             {  beginCol = 1;          }
        else {  beginCol = 2; }

        while (db_App.getNextRecord()){
           no++;
           out.println("<tr>" );
           for(i=beginCol; i<= noColumn; i++){
             String column = db_App.getColumn(i);
             out.print("<td>" + column + "</td>" );
           }
           out.println("</tr>" );

         } // end of while
       } //end of if
     db_App.takeDown();

     recordNum = no ;
     out.println("<tr><center><font face=geneva,arial size=-1>The total records = " +
                 + no + "</font></center></tr>");

 }


/********************************************************************
* Method:  writePageList(DBApp db_App, PrintWriter out)
*
* Purpose:  This method writes sql results into a page lin a list format.
*********************************************************************/

 public void writePageList(DBApp db_App, PrintWriter out)  throws Exception{
     int i, beginCol, noColumn, no;
     noColumn = no = 0;
     noColumn = db_App.getNoColumn();

     if (db_App.loadData()){
        if( provider.equals("ALL") )
             {  beginCol = 1;          }
        else {  beginCol = 2; }

        while (db_App.getNextRecord()){
           no++;
        // for(i=1; i<= noColumn; i++){
           for(i=beginCol; i<= noColumn; i++){
             String column = db_App.getColumn(i);
               out.print("   " + column + "---" );
           }
           out.println("BR");

         } // end of while
       } //end of if
     db_App.takeDown();

     recordNum = no ;
     out.println("<tr><center><font face=geneva,arial size=-1>The total records = " +
                 + no + "</font></center></tr>");

 }


/********************************************************************
* Method:  writePageFile(DBApp db_App, PrintWriter out)
*
* Purpose:  This method writes sql results into a HTML page and a file.
*********************************************************************/


 public void writePageFile(DBApp db_App, PrintWriter out)  throws Exception{
      int i, beginCol;
      int no =0;
      int noColumn = db_App.getNoColumn();
      String header = provider + " " + title
                        +"query result: (Record number = " + recordNum + ")";

      try{
        File dir = new File(dirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(dirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter fileout = new PrintWriter(new  FileOutputStream(aFile ));

     if (db_App.loadData()){
        fileout.println(header);
        fileout.println();
        fileout.println(headLine);

        if( provider.equals("ALL") )
             {  beginCol = 1;          }
        else {  beginCol = 2; }

        while (db_App.getNextRecord()){
          no++;
          out.println("<tr>" );
          for(i=beginCol; i< noColumn; i++){
             String column = db_App.getColumn(i);
             fileout.print(column );
             fileout.print("| " );
            out.print("<td>" + column + "</td>" );
          }


          // print the last column with a new line
          String column = db_App.getColumn(i);
          out.print("<td>" + column + "</td></tr>" );

          fileout.println(column );

        } // end of while
      } //end of if
      db_App.takeDown();

     recordNum = no ;
     out.println("<tr><center><font face=geneva,arial size=-1>The total records = " +
                 + no + "</font></center></tr>");


      out.close();
      fileout.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);
         System.exit(1);
      }
 }



/********************************************************************
* Method:  writeFile(DBApp db_App)
*
* Purpose:  This method writes sql results into a file.
*********************************************************************/

  public void writeFile(DBApp db_App) throws Exception{

      int i, beginCol;
      int no =0;
      int noColumn = db_App.getNoColumn();
      String header = provider + " " + title
                        +"query result: (Record number = " + recordNum + ")";

      try{
        File dir = new File(dirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(dirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

     if (db_App.loadData()){
        out.println(header);
        out.println();
        out.println(headLine);

        if( provider.equals("ALL") )
             {  beginCol = 1;          }
        else {  beginCol = 2; }

        while (db_App.getNextRecord()){
          no++;
          for(i=beginCol; i< noColumn; i++){
             String column = db_App.getColumn(i);
             out.print(column );
             out.print("| " );
          }
          // print the last column with a new line
          String column = db_App.getColumn(i);
          out.println(column );

        } // end of while
      } //end of if
      db_App.takeDown();

      out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);
        // System.exit(1);
      }
 }


/********************************************************************
* Method:  writeXMLFile(DBApp db_App)
*
* Purpose:  This method writes sql results into a XML file.
*********************************************************************/

  public void writeXMLFile(DBApp db_App) throws Exception{

      int i, beginCol;
      int no =0;
      int noColumn = db_App.getNoColumn();
      String header = provider + " " + title
                        +"query result: (Record number = " + recordNum + ")";

      try{
        File dir = new File(xmlDirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(xmlDirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

     if (db_App.loadData()){
     //   out.println(header);
        out.println();
        out.println(headLine);

        if( provider.equals("ALL") )
             {  beginCol = 1;          }
        else {  beginCol = 2; }

        out.print("<TR><TD> " );
        while (db_App.getNextRecord()){
          no++;
          for(i=beginCol; i< noColumn; i++){
             String column = db_App.getColumn(i);
             out.print(column );
             out.print("</TD> " );
          }
          // print the last column with a new line
          String column = db_App.getColumn(i);
          out.print(column );
          out.println("</TR>" );


        } // end of while
      } //end of if
      db_App.takeDown();


      out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);
        // System.exit(1);
      }
 }



/********************************************************************
* Method:  putResultInVector()
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

public void putResultInVector(DBApp db_App, String[] fieldList)  throws Exception {

     int i, beginCol, noColumn, no;
     noColumn = no = 0;
     noColumn = db_App.getNoColumn();

     resultSetV = new Vector();

     resultSetV.addElement(fieldList);


     if (db_App.loadData()){
/*
        if( ISP_Name.equals("ALL") )
             {  beginCol = 1;  noColumnV = noColumn ;        }
        else {  beginCol = 2;  noColumnV = noColumn-1; }
*/
        beginCol = 1;
        while (db_App.getNextRecord()){
           int k =0;
           no++;
           String[] recordS = new String[noColumn]  ;
           for(i=beginCol; i<= noColumn; i++){
             String column = db_App.getColumn(i);
             //  recordS[k++] = new String(column) ;       it will cause problem if column=null
             recordS[k++] = column ;

           }
           resultSetV.addElement(recordS);

         } // end of while
       } //end of if
          System.out.println("RecordNum = " + no); //huang

      setRecordNum(no);
      db_App.takeDown();

}


/********************************************************************
* Method:  writePageTableV( PrintWriter out)
*
* Purpose:  This method writes results stored in a vector into a html page.
*
* parameter:
*********************************************************************/

 public void writePageTableV( PrintWriter out)  throws Exception{
      int i,k, beginCol;
       beginCol = 0;

       for (i=1; i < resultSetV.size(); i++ ) {
           String[] record = (String[]) ((resultSetV.elementAt(i)) ) ;
           out.println("<tr>" );

           for ( k=beginCol; k < record.length ; k++ ) {
             String column = record[k];
            out.print("<td>" + column + "</td>" );
          }
          out.println("</tr>" );
       }

      out.println("<tr><center><font face=geneva,arial size=-1>The total records = " +
                 + recordNum + "</font></center></tr>");

      out.close();

 }



/********************************************************************
* Method:  writeFileV(Vector resultSetV)
*
* Purpose:  This method writes results stored in a vector into a file.
*
* parameter:
*********************************************************************/

  public void writeFileV(Vector resultSetV) throws Exception{

      int i,k, beginCol;
      String header = provider + " " + title
                      +"query result: (Record number = " + recordNum + ")";


      try{
        File dir = new File(dirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(dirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

        out.println(header);
        out.println();
        out.println(headLine);


        if( provider.equals("ALL") )
             {  beginCol = 0;          }
        else {  beginCol = 1; }


       for (i=0; i < resultSetV.size(); i++ ) {
           String[] record = (String[]) ((resultSetV.elementAt(i)) ) ;
           for ( k=beginCol; k < record.length -1; k++ ) {
             String column = record[k];
             out.print(column );
             out.print("| " );
          }
          // print the last column with a new line
          String column = record[k];
          out.println(column );
       }

       out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);

      }
 }


/********************************************************************
* Method:  writeFileV(String fileName)
*
* Purpose:  This method writes results stored in a vector into a file.
*
* parameter:
*********************************************************************/

  public void writeFileV(String fileName) throws Exception{
      int i,k, beginCol;
      String header = provider + " " + title
                      +" query result: (Record number = " + recordNum + ")\n"
                      + paramList ;


      try{
        File dir = new File(dirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(dirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

        out.println(header);
        out.println();

     //   out.println(headLine);

       beginCol = 0;

       for (i=0; i < resultSetV.size(); i++ ) {
           String[] record = (String[]) ((resultSetV.elementAt(i)) ) ;
           for ( k=beginCol; k < record.length; k++ ) {
             String column = record[k];
             out.print("\"" + column + "\",");
           //  out.print(column );
           //  out.print("| " );
          }
          out.println();

       }

       out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);

      }
 }




/********************************************************************
* Method:  writeXMLFileV( String fileName)
*
* Purpose:  This method writes results stored in a vector into a XML file.
*
* parameter:
*********************************************************************/

  public void writeXMLFileV( String fileName) throws Exception{

      int i,k, beginCol;
      String header = provider + " " + title
                      +"query result: (Record number = " + recordNum + ")";


      try{
        File dir = new File(xmlDirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(xmlDirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

      // out.println(header);
      // out.println();
      //  out.println(headLine);

       beginCol = 0;

       out.println("<REPORT NAME=\"" + title +  "\"" + paramList +">");


       /*****************************************************************
       * The first row is header, so write <TH> -- </TH>                *
       ******************************************************************/
           String[] record = (String[]) ((resultSetV.elementAt(0)) ) ;
           out.print("<TR>");
           for ( k=beginCol; k < record.length ; k++ ) {
             String column = record[k];
             out.print("<TH>" + column + "</TH>" );
           }
           out.println("</TR>");


       for (i=1; i < resultSetV.size(); i++ ) {
           record = (String[]) ((resultSetV.elementAt(i)) ) ;
           out.print("<TR>");
           for ( k=beginCol; k < record.length ; k++ ) {
             String column = record[k];
             out.print("<TD>" + column + "</TD>" );
           }
           out.println("</TR>");
       }
       out.print("</REPORT>");

       out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);

      }
 }

 ///////////////////new



/********************************************************************
* Method:  getResultInVector(DBApp db_App, String[] fieldList)
*
* Purpose:  Put the query result into a vector.
*
* parameter:  DBApp db_App, String[] fieldList
*********************************************************************/

public Vector getResultVector(DBApp db_App, String[] fieldList)  throws Exception {

     int i, beginCol, noColumn, no;
     noColumn = no = 0;
     noColumn = db_App.getNoColumn();

     Vector resultSetV  = new Vector();

     resultSetV.addElement(fieldList);


     if (db_App.loadData()){

/*
        if( ISP_Name.equals("ALL") )
             {  beginCol = 1;  noColumnV = noColumn ;        }
        else {  beginCol = 2;  noColumnV = noColumn-1; }
*/
        beginCol = 1;
        while (db_App.getNextRecord()){
           int k =0;
           no++;
           String[] recordS = new String[noColumn]  ;
           for(i=beginCol; i<= noColumn; i++){
             String column = db_App.getColumn(i);
             //  recordS[k++] = new String(column) ;       it will cause problem if column=null
             recordS[k++] = column ;

           }
           resultSetV.addElement(recordS);

         } // end of while
       } //end of if
      setRecordNum(no);
      db_App.takeDown();

      return resultSetV ;
}



/********************************************************************
* Method:  getResultInVector(DBApp db_App, String[] fieldList, int row)
*
* Purpose:  Put the query result into a vector.
*
* parameter:  DBApp db_App,
*             String[] fieldList
*             int row:  up to "row" rows will be put into the vector.
*********************************************************************/

public Vector getResultVector(DBApp db_App, String[] fieldList, int row)  throws Exception {

     int i, beginCol, noColumn, no;
     noColumn = no = 0;
     noColumn = db_App.getNoColumn();

     Vector resultSetV  = new Vector();

     resultSetV.addElement(fieldList);


     if (db_App.loadData()){

/*
        if( ISP_Name.equals("ALL") )
             {  beginCol = 1;  noColumnV = noColumn ;        }
        else {  beginCol = 2;  noColumnV = noColumn-1; }
*/
        beginCol = 1;
        while (db_App.getNextRecord() && no < row){
           int k =0;
           no++;
           String[] recordS = new String[noColumn]  ;
           for(i=beginCol; i<= noColumn; i++){
             String column = db_App.getColumn(i);
             //  recordS[k++] = new String(column) ;       it will cause problem if column=null
             recordS[k++] = column ;

           }
           resultSetV.addElement(recordS);

         } // end of while
       } //end of if
      setRecordNum(no);
      db_App.takeDown();

      return resultSetV ;
}


/********************************************************************
* Method:  writePageTableV( PrintWriter out, Vector resultSetV, int beginRow)
*
* Purpose:  This method writes results stored in a vector into a html page from beginRow.
*
* parameter:  PrintWriter out,
*             Vector resultSetV,
*             int beginRow,  beginRow-0 is header.
*********************************************************************/

 public void writePageTableV(PrintWriter out, Vector resultSetV, int beginRow)  throws Exception{
      int i,k, beginCol;
       beginCol = 0;

       for (i=beginRow; i < resultSetV.size(); i++ ) {
           String[] record = (String[]) ((resultSetV.elementAt(i)) ) ;
           out.println("<tr>" );

           for ( k=beginCol; k < record.length ; k++ ) {
             String column = record[k];
             out.print("<td>" + column + "</td>" );
          }
          out.println("</tr>" );
       }

      out.println("<tr><center><font face=geneva,arial size=-1>The total records = "
                 + recordNum + "</font></center></tr>");

 }



/********************************************************************
* Method:  writeFileV(String fileName, Vector resultSetV,)
*
* Purpose:  This method writes results stored in a vector into a file.
*
* parameter:  String fileName, Vector resultSetV
*********************************************************************/

  public void writeFileV(String fileName, Vector resultSetV) throws Exception{
      int i,k, beginCol;
      String header = provider + " " + title
                      +" query result: (Record number = " + recordNum + ")\n"
                      + paramList ;


      try{
        File dir = new File(dirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(dirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

        out.println(header);
        out.println();

     //   out.println(headLine);

       beginCol = 0;

       for (i=0; i < resultSetV.size(); i++ ) {
           String[] record = (String[]) ((resultSetV.elementAt(i)) ) ;
           for ( k=beginCol; k < record.length -1 ; k++ ) {
             String column = record[k];
             out.print("\"" + column + "\",");
           }
           // print the last column without ","
           String column = record[k];
           out.println("\"" + column  + "\"");
       }

      out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);

      }
 }



/********************************************************************
* Method:  writeXMLFileV( String fileName, Vector resultSetV)
*
* Purpose:  This method writes results stored in a vector into a XML file.
*
* parameter:  String fileName, Vector resultSetV
*********************************************************************/

  public void writeXMLFileV( String fileName, Vector resultSetV) throws Exception{

      int i,k, beginCol;
      String header = provider + " " + title
                      +"query result: (Record number = " + recordNum + ")";


      try{
        File dir = new File(xmlDirName);  // File object for directory

        if(!dir.exists()) {             // If directory does not exist
          dir.mkdir();
	  }
        File aFile = new File(xmlDirName, fileName);
       // aFile.createNewFile();         // Now create a new file if necessary

        PrintWriter out = new PrintWriter(new  FileOutputStream(aFile ));

      // out.println(header);
      // out.println();
      //  out.println(headLine);

       beginCol = 0;

       out.println("<REPORT NAME=\"" + title +  "\"" + paramList +">");


       /*****************************************************************
       * The first row is header, so write <TH> -- </TH>                *
       ******************************************************************/
           String[] record = (String[]) ((resultSetV.elementAt(0)) ) ;
           out.print("<TR>");
           for ( k=beginCol; k < record.length ; k++ ) {
             String column = record[k];
             out.print("<TH>" + column + "</TH>" );
           }
           out.println("</TR>");


       for (i=1; i < resultSetV.size(); i++ ) {
           record = (String[]) ((resultSetV.elementAt(i)) ) ;
           out.print("<TR>");
           for ( k=beginCol; k < record.length ; k++ ) {
             String column = record[k];
             out.print("<TD>" + column + "</TD>" );
           }
           out.println("</TR>");
       }
       out.print("</REPORT>");

       out.close();
      }
      catch(IOException e)
      {  System.out.print("Error: " + e);

      }
 }


/********************************************************************
* Method:  void printError(PrintWriter out)
*
* Purpose:  This method returns an error message to the user
*********************************************************************/

  public void printError(PrintWriter out)  throws Exception{

     String title = " There is an error, please contact web administrator.";

     out.println( "<HTML><HEAD><TITLE></TITLE></HEAD><BODY bgcolor='#c0c0f0'>\n" );
     out.println( "<P><center><H2>Error Message</H2></center></P>" );
     out.println( "<P><center>" + title+ "</center></P>" );

     out.println( "</table></form></BODY></HTML>" );

  }


 /********************************************************************
* Method:  void printExport(PrintWriter out)
*
* Purpose:  This method returns a page to the user
*********************************************************************/

  public void printExport(PrintWriter out, String fileName)  throws Exception{
     //int recordNum =  fpWrite.getRecordNum();
     String title = "Click on Export to continue!";

     out.println( "<HTML><HEAD><TITLE></TITLE></HEAD><BODY bgcolor='#c0c0f0'>\n" );

     out.println("<P><center><font face=geneva,arial size=-1>The total records = "
                + recordNum + "</font></center></P>");

     if(recordNum == 0){
        out.println( "<P><center><H2> The file contains no data. </H2></center></P>");
     }
     else{
       out.println( "<P><center><H2>" + title+ "</H2></center></P>" );
       out.println("<P><center><A target='bottom' href='/ibasis/logs/"+fileName+".csv'><H2>Export</H2></A><center></P>");
     }
     out.println( "</BODY></HTML>" );
     out.close();    // close PrintWriter stream

}


}	//end of class

