
/*
 Program Name: invoiceBean.java
 Author : Nandeesh , Huiqiong
 Date : Feb, 2001
 Purpose:  To implement the functionality of InvoiceInterface interface
*/

//package ibasis.billingPortal;
//import ibasis.bean.*;

package portal.invoice;

import java.util.*;
import java.io.*;

import portal.base.*;
import portal.bean.*;
import portal.servletbeans.*;

		/**
			* This class facilitates in invoice related activities like invoicing,
			* re-invoicing, hot bill, retrieving such similar information for
			* given Account(s) and Isp(s).
		 */


public class invoiceBean implements InvoiceInterface {

   	private DbUtil _myDbUtil;
   	private BillingTransaction _myTrans;

	/* Initialise all necessary steps in the constructor */

	public invoiceBean() {
			_myDbUtil = new DbUtil();
			_myTrans = new BillingTransaction();
		  }

		/**
		 * Gets Invoice/ReInvoice details
		 * @return   Vector with similar data as returned by getAccountActivities of
	   		         the paymentAdjustment. Here for trans_Type = INV or RINV
		 * @param    _pIspvn Isp
		 * @param	 _pStartDate  beginning of date range
		 * @param	 _pEndDate  end date range
		 */

	public Vector getInvoicesByIsp(String _pIspvn, String _pStartDate, String _pEndDate) {

		StringBuffer _sqlFetch= new StringBuffer("");
		Vector _vSelected;


		_sqlFetch = _sqlFetch.append("SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0), note, status, reference_id,");
		_sqlFetch = _sqlFetch.append("operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no ");
		_sqlFetch = _sqlFetch.append("  FROM Transaction  WHERE ");
		_sqlFetch = _sqlFetch.append(" ispvn_id = " + _pIspvn );
		_sqlFetch = _sqlFetch.append(" AND (trans_type = 'INV'");
		_sqlFetch = _sqlFetch.append(" OR trans_type = 'RINV')");
		_sqlFetch = _sqlFetch.append(" AND status <> 'C' ");


		if (!_pStartDate.equals("*"))
			_sqlFetch = _sqlFetch.append(" AND timestamp  >= TO_DATE('" + _pStartDate + "', 'MM/DD/YYYY')");
		if (!_pEndDate.equals("*"))
			_sqlFetch = _sqlFetch.append(" AND timestamp  < TO_DATE('" + _pEndDate + "', 'MM/DD/YYYY') + 1");

		_sqlFetch = _sqlFetch.append(" order by account_id,id desc");

		System.out.println("sql fetch --> " + _sqlFetch.toString());

		_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 13);

		 return _vSelected;
	}

		/**
		 * Gets Invoice/ReInvoice details
		 * @return   Vector with similar data as returned by getAccountActivities of
	   		         the paymentAdjustment. Here for trans_Type = INV or RINV
		 * @param    _pAccounts[] array of Accounts
		 * @param    _pStartDate beginning of date range
		 * @param    _pEndDate  end date range
		 */

	public  Vector getInvoicesByAccounts(String[] _pAccounts, String _pStartDate, String _pEndDate) {

		StringBuffer _sqlFetch= new StringBuffer("");
		int _numAccountId = _pAccounts.length;
		String _listAccountId = "" ;
		Vector _vSelected;

			_listAccountId = _pAccounts[0];
			for(int i=1; i < _numAccountId; i++) {
					_listAccountId = _listAccountId + "," + _pAccounts[i];
			   }

			_sqlFetch = _sqlFetch.append("SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0), note, status, reference_id,");
			_sqlFetch = _sqlFetch.append("operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no, ");
			_sqlFetch = _sqlFetch.append(" start_billperiod,end_billperiod ");
			_sqlFetch = _sqlFetch.append("  FROM Transaction  WHERE ");
			_sqlFetch = _sqlFetch.append(" account_id IN ( " + _listAccountId + ")");
			_sqlFetch = _sqlFetch.append(" AND (trans_type = 'INV'");
			_sqlFetch = _sqlFetch.append(" OR trans_type = 'RINV')");
			_sqlFetch = _sqlFetch.append(" AND status <> 'C' ");

			if (!_pStartDate.equals("*"))
				_sqlFetch = _sqlFetch.append(" AND timestamp  >= TO_DATE('" + _pStartDate + "', 'MM/DD/YYYY')");
			if (!_pEndDate.equals("*"))
				_sqlFetch = _sqlFetch.append(" AND timestamp  < TO_DATE('" + _pEndDate + "', 'MM/DD/YYYY') + 1");

			_sqlFetch = _sqlFetch.append(" order by account_id,id desc");

			System.out.println("sql fetch --> " + _sqlFetch.toString());

			_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 15);

			 return _vSelected;

	}

		/**
		 * Gets Invoice/ReInvoice details
		 * @return   Vector with similar data as returned by getAccountActivities of
	   		         the paymentAdjustment. Here for trans_Type = INV or RINV
		 * @param    _pStartAccount start of account  range
		 * @param    _pEndAccount end account range
		 * @param    _pStartDate start of date range
		 * @param    _pEndDate end of  date range
		 */

  	public  Vector getInvoicesByAccounts(String _pStartAccount, String _pEndAccount,
	                                      String _pStartDate, String _pEndDate) {

		StringBuffer _sqlFetch= new StringBuffer("");
		Vector _vSelected;


		_sqlFetch = _sqlFetch.append("SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0), note, status, reference_id,");
		_sqlFetch = _sqlFetch.append("operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no, ");
		_sqlFetch = _sqlFetch.append(" start_billperiod,end_billperiod ");
		_sqlFetch = _sqlFetch.append("  FROM Transaction  WHERE ");
		_sqlFetch = _sqlFetch.append(" account_id BETWEEN " +  _pStartAccount + " AND "  + _pEndAccount );
		_sqlFetch = _sqlFetch.append(" AND (trans_type = 'INV'");
		_sqlFetch = _sqlFetch.append(" OR trans_type = 'RINV')");
		_sqlFetch = _sqlFetch.append(" AND status <> 'C' ");

		if (!_pStartDate.equals("*"))
			_sqlFetch = _sqlFetch.append(" AND timestamp  >= TO_DATE('" + _pStartDate + "', 'MM/DD/YYYY')");
		if (!_pEndDate.equals("*"))
			_sqlFetch = _sqlFetch.append(" AND timestamp  < TO_DATE('" + _pEndDate + "', 'MM/DD/YYYY') + 1");

		_sqlFetch = _sqlFetch.append(" order by account_id,id desc");

		System.out.println("sql fetch --> " + _sqlFetch.toString());

		_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 15);

		 return _vSelected;
	}

		/**
		 * Gets Invoice details
		 * @return   Vector with data from Order_line and Item table
		 * @param    InvoiceId/OrderId one or more comma seperated invoiceId.
		 */

	/* This returns the details of the given Invoice number from Orders
		(Order_Line/Order_Item_Details table..) which we need to figure out.   */

	public Vector getInvoiceDetail(String _pInvoiceID) {

		StringBuffer _sqlFetch= new StringBuffer("");
		Vector _vSelected;

//		_sqlFetch = _sqlFetch.append("SELECT order_id, item_id, Quantity, ");
//		_sqlFetch = _sqlFetch.append(" amount, description, to_char(TIMESTAMP,'dd-MON-yyyy') FROM  ");
//		_sqlFetch = _sqlFetch.append(" order_item_details  WHERE order_id = " + _pInvoiceID);

		_sqlFetch = _sqlFetch.append("SELECT  b.name Description, a.order_id, a.item_id,");
		_sqlFetch = _sqlFetch.append(" a.quantity ,a.total Amount,b.itemgroup_id");
		//_sqlFetch = _sqlFetch.append(" a.total Amount,b.itemgroup_id");
		_sqlFetch = _sqlFetch.append(" FROM order_line a, item b WHERE ");
		//_sqlFetch = _sqlFetch.append("  a.item_id <> 1.000E+09  AND ");
		_sqlFetch = _sqlFetch.append("  a.item_id = b.id AND a.order_id IN (" + _pInvoiceID + ")");

    	_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 6);
    	System.out.println("Soon after executing.. size is " + _vSelected.size());
		return _vSelected;

	}

		/**
		 * Creates the Hot bill. Hot bill is the process of generating upto the minute billing
		 * @return   Vector with details of new invoices.
		 * @param    _pIspvn Isp
		 */

	public Vector createHotBill(String _pIspvn) {
		// dummy
		Vector _vSelected;
		int _resultRows;


		StringBuffer _sqlFetch= new StringBuffer("");
		_sqlFetch = _sqlFetch.append("SELECT Id FROM account WHERE ispvn_id = " + _pIspvn);
		_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 1);
		_resultRows = _vSelected.size();
		System.out.println("size of resultRows = " + _resultRows);

		if (_resultRows > 0)  {

			String[] _accIds = new String[_resultRows];

			for(int i=0; i < _resultRows; i++) {
				String[] tempString = (String[]) (_vSelected.elementAt(i));
				_accIds[i] = tempString[0];
				System.out.println("The value of _accIds[" + i + "] is " + _accIds[i]);
			}
			_vSelected = createHotBill(_accIds);
		}
		return _vSelected;

		}

		/**
		 * Creates the Hot bill. Hot bill is the process of generating upto the minute billing
		 * @return   Vector with details of new invoices.
		 * @param    _pAccounts[]  array of Account
		 */

	public Vector createHotBill(String[] _pAccounts) {

		Vector _vTransaction;
		Vector _vNewTrans;
		StringBuffer _sqlFetch= new StringBuffer("");
		int _resultRows;
		String _transId;


		_sqlFetch = _sqlFetch.append("SELECT t.Id, t.Reference_Id, to_char(t.end_billperiod,'mm/dd/yyyy'), ");
		_sqlFetch = _sqlFetch.append(" t.account_id, t.ispvn_id, nvl(a.prepaid,'N') prepaid FROM Transaction t ," );
		_sqlFetch = _sqlFetch.append(" account a  WHERE t.Status='A'  AND t.trans_type = 'INV'  and t.account_id=a.id " );


		String _listAccountId = _pAccounts[0];
		int _numAccountId = _pAccounts.length;

		for(int i=1; i < _numAccountId; i++) {
			_listAccountId = _listAccountId + "," + _pAccounts[i];
		}

		_sqlFetch = _sqlFetch.append(" AND t.account_id IN(" + _listAccountId + ")" );
		_vTransaction = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 6);
		System.out.println(" \n sql ......... "  + _sqlFetch.toString() );

		System.out.println(" \n doHotBill Begin......... ");

		_vNewTrans =  doHotBill(_vTransaction);

		System.out.println(" \n doHotBill End......... ");

		_resultRows = _vNewTrans.size();
		System.out.println("after hot billing " + _resultRows + " of trans records  created ....");

		if (_resultRows > 0)  {

			_sqlFetch.setLength(0);

			_sqlFetch = _sqlFetch.append("SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0), note, status, reference_id,");
			_sqlFetch = _sqlFetch.append("operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no, ");
			_sqlFetch = _sqlFetch.append(" start_billperiod,end_billperiod ");
			_sqlFetch = _sqlFetch.append("  FROM Transaction  WHERE ");

			_sqlFetch = _sqlFetch.append(" ID IN ( ");

			//_transId = ((String[])(_vNewTrans.elementAt(0)))[0];
			//(_vOutput.elementAt(i)).getClass().getName() )
			_transId = _vNewTrans.elementAt(0).toString();
			System.out.println("value of first _transId -->" + _transId);

			for(int i=1; i < _resultRows; i++)
				{
					_transId = _transId + "," + _vNewTrans.elementAt(i).toString() ;
				}
			_sqlFetch = _sqlFetch.append(_transId + ")");

			System.out.println ("\nThe final sql  is --> " + _sqlFetch.toString());

			_vNewTrans = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 15);

 		}

		return _vNewTrans;
	}

  /* the private function which creates the hotbilling and returns the
     vector with list of newly created Transaction Id(String dataType).
     This function is called from the CreateHotBill(..) public functions.
  */


	private Vector doHotBill(Vector _vTransaction) {

		StringBuffer _sqlFetch= new StringBuffer("");
		Vector _retVector = new Vector(10,10);
		Vector _tempVector = new Vector(10,10);;
		int _noOfTrans;
		String _curRefId="";
		String _curAcc="";
		String _curIspvn="";
		String[] _curInvoiceTotal;
		String _defEndDate="";
		String _newOrderId="";
		String[] _tempSeq ;
		String _newTransId;
		String _curTransId="";
		String _prePaid="";


		_noOfTrans = _vTransaction.size();

		//repeat the following for all the selected orders
		for (int i=0; i<_noOfTrans; i++)
		{
			String[] _currentTrans = (String[]) (_vTransaction.elementAt(i));
			_curTransId = _currentTrans[0];
			_curRefId = _currentTrans[1];
			_defEndDate = _currentTrans[2];
			_curAcc = _currentTrans[3];
			_curIspvn = _currentTrans[4];
			_prePaid = _currentTrans[5];

			//update the orders table
			_sqlFetch.setLength(0);
			_sqlFetch = _sqlFetch.append("UPDATE Orders SET State ='R', BILLING_PERIOD_END = new_time(sysdate,'EST','GMT')");
			_sqlFetch = _sqlFetch.append(" WHERE ID = " + _curRefId );
			System.out.println("\n The sql is --> " + _sqlFetch.toString());


			_myDbUtil.beginTrans();

			    System.out.println("Step 2");

				if (_myDbUtil.ExecuteUpdateQuery(_sqlFetch.toString()) == 0) {
					// update failed..
					_myDbUtil.rollback();
					return _retVector;
				}
				_sqlFetch.setLength(0);

				_sqlFetch = _sqlFetch.append("SELECT order_seq.NEXTVAL FROM dual");
				System.out.println("\n The sql is --> " + _sqlFetch.toString());

				System.out.println("Step 3");
				_tempVector = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 1);
				_tempSeq = (String[]) (_tempVector.elementAt(0));
				System.out.println("\n The next sequence for Orders --> " + _tempSeq[0]);

				_sqlFetch.setLength(0);
				_sqlFetch = _sqlFetch.append("INSERT INTO orders (id,state, billing_period_start,");
				_sqlFetch = _sqlFetch.append("billing_period_end,account_id,");
				_sqlFetch = _sqlFetch.append("sum_vat_tax, sum_prices, sum_total) VALUES ");
				_sqlFetch = _sqlFetch.append("( " + _tempSeq[0] + ",'A',new_time(sysdate,'EST','GMT'),");
				_sqlFetch = _sqlFetch.append("to_date('" + _defEndDate + "','mm/dd/yyyy')," + _curAcc + ", 0,0,0)");

				System.out.println("The sql is --> " + _sqlFetch.toString());

				System.out.println("Step 4");

				if (_myDbUtil.ExecuteUpdateQuery(_sqlFetch.toString()) == 0) {
					// Insert failed..
					_myDbUtil.rollback();
					return _retVector;
				}

				_sqlFetch.setLength(0);
				_sqlFetch = _sqlFetch.append(" SELECT nvl(sum(total),0) total FROM order_line ");
				_sqlFetch = _sqlFetch.append("WHERE order_id=" + _curRefId);
				System.out.println("The sql is --> " + _sqlFetch.toString());

				System.out.println("Step 5");
				_tempVector = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 1);
				_curInvoiceTotal = (String[]) (_tempVector.elementAt(0));

				_sqlFetch.setLength(0);

				if ( _prePaid.equals("Y"))  {

						// Inserting into order_line happens only for prepaid accounts
						 _sqlFetch = _sqlFetch.append("INSERT INTO order_line (order_id, item_id, quantity, total, vat_tax_percentage)");
						 _sqlFetch = _sqlFetch.append(" VALUES (" + _tempSeq[0] + ",1000000000,1, " + _curInvoiceTotal[0] + ", 0)");
						 System.out.println("The sql is --> " + _sqlFetch.toString());
						 System.out.println("Step 6");
						if (_myDbUtil.ExecuteUpdateQuery(_sqlFetch.toString()) == 0) {
							// Insert failed..
							_myDbUtil.rollback();
							return _retVector;
						}
				}

				_sqlFetch.setLength(0);

				 _sqlFetch = _sqlFetch.append("UPDATE Transaction SET end_billperiod=new_time(sysdate,'EST','GMT'),");
				 _sqlFetch = _sqlFetch.append(" status='R' , Amount = " + _curInvoiceTotal[0] +  " WHERE ID = " + _curTransId );
				System.out.println("Step 7");
				if (_myDbUtil.ExecuteUpdateQuery(_sqlFetch.toString()) == 0) {
					// Update failed..
					_myDbUtil.rollback();
					return _retVector;
				}

				//update the billing_balance table to reflect the balance amount..

				 _sqlFetch.setLength(0);

				 //_sqlFetch = _sqlFetch.append("UPDATE billing_balance SET amount = amount + " + _curInvoiceTotal[0]);
				 //_sqlFetch = _sqlFetch.append(" WHERE account_id = " + _curAcc);

				 //System.out.println("The sqlFetch -->" + _sqlFetch);
				 System.out.println("Step 8 in comments");

				//if (_myDbUtil.ExecuteUpdateQuery(_sqlFetch.toString()) == 0) {
					// Update failed..
			//		System.out.println("I have got a problem in Updating billing_balance");
			//		_myDbUtil.rollback();
			//		return _retVector;
			//	}

				try {
					_myTrans.setTransType("INV");
					_myTrans.setAccount(_curAcc);
					_myTrans.setIspvn(_curIspvn);
					_myTrans.setAmount(_curInvoiceTotal[0]);
					_myTrans.setReference(_tempSeq[0]);
					_myTrans.setStartBillPeriod("sysdate");
					_myTrans.setEndBillPeriod(_defEndDate);
					_myDbUtil.commitTrans();
				}
				catch (Exception ex) {
					System.out.println("Error during initialising transaction,HOTBILL.." + ex.toString());
					_myDbUtil.rollback();
				}

				System.out.println("Step 9");
				_newTransId = _myTrans.InsertTransaction();
				System.out.println("\n The Created Transaction ID is --> " + _newTransId);
				_retVector.addElement(_newTransId);
				//_myDbUtil.commitTrans();
				System.out.println("Step 10");
    		}
			  return _retVector;

	}

	/**
	 * Creates the Hot bill. Hot bill is the process of generating upto the minute billing
	 * @return   Vector with details of new invoices.
	 * @param    _pStartAccount start of range of accounts
	 * @param    _pEndAccount end range of accounts
	 */


	public Vector createHotBill(String _pStartAccount, String _pEndAccount) {

		Vector _vTransaction;
		Vector _vNewTrans;
		StringBuffer _sqlFetch= new StringBuffer("");
		int _resultRows;
		String _transId;


		_sqlFetch = _sqlFetch.append("SELECT t.Id, t.Reference_Id, to_char(t.end_billperiod,'mm/dd/yyyy'), ");
		_sqlFetch = _sqlFetch.append(" t.account_id, t.ispvn_id, nvl(a.prepaid,'N') prepaid FROM Transaction t ," );
		_sqlFetch = _sqlFetch.append(" account a  WHERE t.Status='A'  AND t.trans_type = 'INV'  and t.account_id=a.id " );


		_sqlFetch = _sqlFetch.append(" AND t.account_id BETWEEN (" + _pStartAccount );
		_sqlFetch = _sqlFetch.append(" AND " + _pEndAccount  );

		System.out.println("Step 1");

		_vTransaction = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 6);

		System.out.println(" \n sql ......... "  + _sqlFetch.toString() );

		System.out.println(" \n doHotBill Begin......... ");

		_vNewTrans =  doHotBill(_vTransaction);

		System.out.println(" \n doHotBill End......... ");

		_resultRows = _vNewTrans.size();
		System.out.println("after hot billing " + _resultRows + " of trans records  created ....");

		if (_resultRows > 0)  {

			_sqlFetch.setLength(0);

			_sqlFetch = _sqlFetch.append("SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0), note, status, reference_id,");
			_sqlFetch = _sqlFetch.append("operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no, ");
			_sqlFetch = _sqlFetch.append(" start_billperiod,end_billperiod ");
			_sqlFetch = _sqlFetch.append("  FROM Transaction  WHERE ");

			_sqlFetch = _sqlFetch.append(" ID IN ( ");

			//_transId = ((String[])(_vNewTrans.elementAt(0)))[0];
			//(_vOutput.elementAt(i)).getClass().getName() )
			_transId = _vNewTrans.elementAt(0).toString();
			System.out.println("value of first _transId -->" + _transId);

			for(int i=1; i < _resultRows; i++)
				{
					_transId = _transId + "," + _vNewTrans.elementAt(i).toString() ;
				}
			_sqlFetch = _sqlFetch.append(_transId + ")");

			System.out.println ("\nThe final sql  is --> " + _sqlFetch.toString());

			System.out.println("Step n");

			_vNewTrans = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 15);

 		}

		return _vNewTrans;
	}

  /*  reInvoiceByIsp
      HH
  */

  	/**
  	 * This gets invoice data by ispvn_id from transaction table.
       Creates the reinvoice entry in the transaction table with trans_type=RINV,
       and return the vector for just generated reinvoices..
  	 * @return   Vector with details of new invoices.
  	 * @param   Isp(s) one or more comma seperated Isp(s)
  	 * @param   _pStartDate start of date range
  	 * @param   _pEndDate end date range

  	 */

  public Vector reInvoiceByIsp(String _pIspvn, String _pStartDate, String _pEndDate)
  {

      String sqlcmd =  "";
      Vector resultSetV = null;

      /*
       Get invoice data from transaction table
      */

      sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0)," +
               " note, status, reference_id, operator, " +
			   " description, cc_type, timestamp,  check_no, " +
               " trans_terms, cc_num, cc_expmonth,cc_expyear," +
               " check_date, check_bank, START_BILLPERIOD,END_BILLPERIOD " +
               " FROM  transaction " ;

      sqlcmd += " WHERE ispvn_id = '" + _pIspvn +"'";;
      sqlcmd += " AND trans_type = 'INV' "  ;


     if( ! _pStartDate.equals("*") )
	   sqlcmd += " AND timestamp  >= TO_DATE('" + _pStartDate + "', 'MM/DD/YYYY') ";
     if( ! _pEndDate.equals("*") )
	   sqlcmd += " AND timestamp  < TO_DATE('" + _pEndDate + "', 'MM/DD/YYYY') + 1 ";

	 System.out.println(sqlcmd);
	 resultSetV = _myDbUtil.ExecuteSelectQuery(sqlcmd, 21);
     resultSetV = createReinvoiceRecord(resultSetV);
	 return resultSetV;
  }

	/*
	* Method:  Vector reInvoiceByAccounts
	* HH
	*/

  	/**
  	 * This gets invoice data by ispvn_id from transaction table.
       Creates the reinvoice entry in the transaction table with trans_type=RINV,
       and return the vector for just generated reinvoices..
  	 * @return    vector with details of new invoices.
  	 * @param   _pAccounts  array of Account
  	 * @param   _pStartDate start of date range
  	 * @param   _pEndDate end of date range
  	 */

  public Vector reInvoiceByAccounts(String[] _pAccounts, String _pStartDate, String _pEndDate)
  {

      String sqlcmd =  "";
      Vector resultSetV = null;
      int recordNum = 0;
      BillingTransaction trans  = new BillingTransaction();

      int numAccountId = _pAccounts.length;
      String listAccountId = "" ;


       if( numAccountId > 0 ){
          listAccountId = _pAccounts[0];
          for(int i=1; i<numAccountId; i++){
             listAccountId = listAccountId + "," + _pAccounts[i];
          }
       }

      /*
       Get invoice data from transaction table
      */

      sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0)," +
                       " note, status, reference_id, operator, " +
			     " description, cc_type, timestamp,  check_no, " +
                       " trans_terms, cc_num, cc_expmonth,cc_expyear," +
                       " check_date, check_bank, START_BILLPERIOD,END_BILLPERIOD " +
                       " FROM  transaction " ;

      sqlcmd += " WHERE account_id in (" + listAccountId +   ") " ;
      sqlcmd += " AND trans_type = 'INV' "  ;

      if( ! _pStartDate.equals("*") )
	   sqlcmd += " AND timestamp  >= TO_DATE('" + _pStartDate + "', 'MM/DD/YYYY') ";

      if( ! _pEndDate.equals("*") )
	   sqlcmd += " AND timestamp  < TO_DATE('" + _pEndDate + "', 'MM/DD/YYYY') + 1 ";

	 System.out.println(sqlcmd);

	 resultSetV = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 21);

     resultSetV = createReinvoiceRecord(resultSetV);

	 return resultSetV;

  }

/*
  Vector reInvoiceByAccounts ( function overloading )
  HH
 */
   	/**
   	 * This gets invoice data by ispvn_id from transaction table.
        Creates the reinvoice entry in the transaction table with trans_type=RINV,
        and return the vector for just generated reinvoices..
   	 * @return   vector with details of new invoices.
   	 * @param   _pStartAccount start of account range
   	 * @param   _pEndAccounts end of account range
   	 * @param   _pStartDate start of date range
   	 * @param   _pendDate end of date range
  	 */

  public Vector reInvoiceByAccounts(String _pStartAccount, String _pEndAccounts,String _pStartDate, String _pEndDate)
  {

      String sqlcmd =  "";
      Vector resultSetV = null;
      int recordNum = 0;
      BillingTransaction trans = new BillingTransaction();

      // Get invoice data from transaction table
      sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0)," +
                       " note, status, reference_id, operator, " +
			     " description, cc_type, timestamp,  check_no, " +
                       " trans_terms, cc_num, cc_expmonth,cc_expyear," +
                       " check_date, check_bank,START_BILLPERIOD,END_BILLPERIOD " +
                       " FROM  transaction " ;

      sqlcmd += " WHERE account_id >= '" + _pStartAccount +"'";
      sqlcmd += " AND account_id <= '" + _pEndAccounts +"'";
      sqlcmd += " AND trans_type = 'INV' "  ;


      if( ! _pStartDate.equals("*") )
	   sqlcmd += " AND timestamp  >= TO_DATE('" + _pStartDate + "', 'MM/DD/YYYY') ";
      if( ! _pEndDate.equals("*") )
	   sqlcmd += " AND timestamp  < TO_DATE('" + _pEndDate + "', 'MM/DD/YYYY') + 1 ";

	 System.out.println(sqlcmd);
	 resultSetV = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 21);
     resultSetV = createReinvoiceRecord(resultSetV);
     return resultSetV;
  }


/*
  Vector  createReinvoiceRecord(Vector resultSetV)
  HH

  This creates the reinvoice entry in the transaction table with trans_type=RINV,
  and return the vector for just generated reinvoices..
 */

 private Vector createReinvoiceRecord(Vector resultSetV){

      /*
       Insert reinvoice data into transaction table
      */

       BillingTransaction trans = new BillingTransaction();

       int recordNum = resultSetV.size();

       String[] newid = new String[recordNum]  ;

       for(int i=0; i < recordNum; i++) {
	    String[] recordCol = (String[]) ((resultSetV.elementAt(i))) ;

	    try {
            trans.setTransType("RINV");

            if( ! recordCol[2].equals(null) )
              { trans.setAccount(recordCol[2]); }
            if( ! recordCol[3].equals(null) )
	        { trans.setIspvn(recordCol[3]);  }
            if( ! recordCol[4].equals(null) )
		  { trans.setAmount(recordCol[4]); }
            if( ! recordCol[5].equals(null) )
		  { trans.setNote(recordCol[5]);   }
           // if( ! recordCol[6].equals(null) )
		    trans.setStatus("A");
            if( ! recordCol[7].equals(null) )
		  { trans.setReference(recordCol[7]);  }
            if( ! recordCol[8].equals(null) )
		  { trans.setOperator(recordCol[8]); }
            if( ! recordCol[9].equals(null) )
		  { trans.setDescription(recordCol[9]);  }
            if( ! recordCol[10].equals(null) )
		  { trans.setCCType(recordCol[10]);   }
          /*  if( ! recordCol[11].equals(null) )
		    trans.setTimeStamp(recordCol[11]);
            if( ! recordCol[12].equals(null) )
              { trans.setCheckNo(recordCol[12]);    }
            if( ! recordCol[13].equals(null) )
		   { trans.setTransTerms(recordCol[13]); }
            if( ! recordCol[14].equals(null) )
		   { trans.setCcNum(recordCol[14]);  }
            if( ! recordCol[15].equals(null) )
		   { trans.setExpMonth(recordCol[15]);  }
            if( ! recordCol[16].equals(null) )
		   { trans.setExpYear(recordCol[16]);  }
            if( ! recordCol[17].equals(null) )
		   { trans.setCheckDate(recordCol[17]);  }
            if( ! recordCol[18].equals(null) )
		   { trans.setCheckBank(recordCol[18]);	  } */

	    }catch (Exception e) {
	       System.out.println("Exception while setting values for Billing transaction" + e.toString());
	    }
        newid[i] = trans.InsertTransaction();
       }// End for


      /*
          Get records which are just generated (Reinvoice)
          and return the vector which holds this new records.
      */

      String idList  = "" ;
      int numId = newid.length ;

      if( numId>0){
          idList = newid[0];
          for(int i=1; i<numId  ; i++){
             idList = idList  + "," + newid[i];
          }
       }

      String sqlcmd = "";
      sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, nvl(amount,0)," +
               " note, status, reference_id, operator, " +
			   " description, cc_type, timestamp,  check_no, " +
               " trans_terms, cc_num, cc_expmonth,cc_expyear," +
               " check_date, check_bank " +
               " FROM  transaction " ;

      sqlcmd += " WHERE id in (" + idList   +   ") " ;

	 System.out.println(sqlcmd);

	Vector resultSetVector = null;
	resultSetVector = _myDbUtil.ExecuteSelectQuery(sqlcmd, 19);
    return resultSetVector ;
  }
}