package portal.invoice;

import java.io.*;
import java.util.*;

/*--------------------------------------------------------------------
this is the interface for IMS Bean
Author : Amelia Chan
date: 02/25/2001, 3/1/2001

Acronym:
OIDList = OrderID List
AID = AccountID;
AIDList = AccountID List
---------------------------------------------------------------------*/

public interface IMSInvoice
{
    // Table Account
    public Vector getAIDListByISPVN(int ispvnID) throws Exception;
    //returns accountID list by the given IspvnID.

    public Vector getAIDListByISPVNCriteria(int ispvnID, String criteria) throws Exception;
	//returns accountID list by the given IspvnID and criteria.


    public Vector getAccountInformation(int accountID) throws Exception;
    //returns a row of selected account record by the given accountID.


    // Table Orders
    public Vector getOIDListByISPVN(int ispvnID) throws Exception;
    //returns orderID list by the given IspvnID.

    public Vector getOrdersByISPVN(int ispvnID) throws Exception;
    //returns orders by the given IspvnID.


    //public Vector getOIDListByAIDList(Vector vAccoutID) throws Exception;
    //returns orderID list by the given accountId list.
    //this can be replaced by getOIDListByAIDListDates(Vector vAccoutID, "", "")

    //public Vector getOrdersByAIDList(Vector vAccoutID) throws Exception;
    //returns orders by the given accountId list.
    //this can be replaced by getOrdersByAIDListDates(Vector vAccoutID, "", "")


    public Vector getOIDListByAIDListDates(Vector vAccoutID, String bStart, String bEnd) throws Exception;
    //returns orderID list by the given accountId list and date range.

    public Vector getOrdersByAIDListDates(Vector vAccoutID, String bStart, String bEnd) throws Exception;
    //returns orders by the given accountId list and date range.



    //public Vector getOrderDetailsByOIDList(Vector vOrderID) throws Exception;
    //returns order_item_details by the given orderID List.

    public Vector getOrderDetailsByOIDListDates(Vector vOrderID, String bStart, String bEnd) throws Exception;
    //returns order_item_details by the given orderID List and date range.

    // re-invoice
    public void generateInvoice(int orderID) throws Exception;

    // re-invoice
    public Vector reInvoicing(Vector vAccoutID, String bStart, String bEnd) throws Exception;
	//returns order_item_details by the given accountId list and date range.  Make sure
	//the state in Orders table is set to 'E'.

    public void deleteTran(int tranID) throws Exception;

    // hot-billing
    public void hotBilling(int OrderID) throws Exception;


    // reconciliation
    public void Reconciliation (int aID, String bStart, String bEnd) throws Exception;

    //others
    public Vector pagingQResults(int start, int end) throws Exception;
    // returns subset of the QResult between start and end.
}