
/***************************************************************************************/
// File: order.java
// Date: 02/07/2001
//
// Author: Amelia M. Chan
//
// 1899-12-31 - default Date
//
//
/**************************************************************************************/
//package portal;
package portal.invoice;
//package invoice;

import java.util.*;
import java.sql.*;
import java.sql.Date;

public class Order
{
   private int id;
   private String state;
   private Date billing_period_start;
   private Date billing_period_end;
   private Date invoice_generated;
   private int  account_id;
   private double sum_vat_tax;
   private double sum_prices;
   private double sum_total;

   public Order()
   {
//System.out.println("in order() ---");
	   id = 0;
	   state = "";
	   billing_period_start = new Date(0,0,0);
	   billing_period_end = new Date(0,0,0);
	   invoice_generated = new Date(0,0,0);
	   account_id = 0;
	   sum_vat_tax = 0.0;
	   sum_prices = 0.0;
	   sum_total = 0.0;
//System.out.println("out order()  ---");
   }

   public void setID(int num) {
     this.id = num;
   }

   public int getID() {
     return id;
   }

   public void setState(String st) {
        this.state = st;
   }

   public String getState() {
        return state;
   }

   public void setBillingPeriodStart(Date aDay) {
        billing_period_start.setYear(aDay.getYear());
        billing_period_start.setMonth(aDay.getMonth());
        billing_period_start.setDate(aDay.getDate());
  //System.out.print("year ="); System.out.println(billing_period_start.getYear());
  //System.out.print("month="); System.out.println(billing_period_start.getMonth());
  //System.out.print("date ="); System.out.println(billing_period_start.getDate());
   }

   public Date getBillingPeriodStart() {
        return billing_period_start;
   }

   public void setBillingPeriodEnd(Date aDay) {
	    billing_period_end.setYear(aDay.getYear());
	    billing_period_end.setMonth(aDay.getMonth());
	    billing_period_end.setDate(aDay.getDate());
  //System.out.print("year ="); System.out.println(billing_period_end.getYear());
  //System.out.print("month="); System.out.println(billing_period_end.getMonth());
  //System.out.print("date ="); System.out.println(billing_period_end.getDate());

   }

   public Date getBillingPeriodEnd() {
        return billing_period_end;
   }

   // 2/19/2001 invoice_generated is null so can not get. have to set 0 for year, month , date

   public void setInvoiceGenerated(Date aDay) {
 	    invoice_generated.setYear(aDay.getYear());
 	    invoice_generated.setMonth(aDay.getMonth());
 	    invoice_generated.setDate(aDay.getDate());
  //System.out.print("year ="); System.out.println(invoice_generated.getYear());
  //System.out.print("month="); System.out.println(invoice_generated.getMonth());
  //System.out.print("date ="); System.out.println(invoice_generated.getDate());

   }

   public Date getInvoiceGenerated() {
        return invoice_generated;
   }

   public void setAccountID(int num) {
       this.account_id = num;
   }

   public int getAccountID() {
       return account_id;
   }

   public void setSumVatTax(double num) {
       this.sum_vat_tax = num;
   }

   public double getSumVatTax() {
       return sum_vat_tax;
   }

   public void setSumPrices(double num) {
          this.sum_prices = num;
   }

   public double getSumPrices() {
          return sum_prices;
   }

   public void setSumTotal(double num) {
          this.sum_total = num;
   }

   public double getSumTotal() {
          return sum_total;
   }

   public Order setAnOrder(int id, String st, Date sDate, Date eDate, Date gDate, int accountID, double sTax, double sPrices, double sTotal)
   {
//System.out.println("in Order::setAnOrder ----");

	   setID(id);
	   setState(st);
	   setBillingPeriodStart(sDate);
	   setBillingPeriodEnd(eDate);
	   //setInvoiceGenerated(gDate);
	   setAccountID(accountID);
	   setSumVatTax(sTax);
	   setSumPrices(sPrices);
	   setSumTotal(sTotal);
//System.out.println("out Order::setAnOrder --- ");

	   return this;
   }

   public void display()
   {
//System.out.println("in order.display ---- ");
	   System.out.print(this.id);
	   System.out.print(",");
	   System.out.print(this.state);
	   System.out.print(",");
	   System.out.print(this.billing_period_start);
	   System.out.print(",");
	   System.out.print(this.billing_period_end);
	   System.out.print(",");
	   System.out.print(this.invoice_generated);
	   System.out.print(",");
	   System.out.print(this.account_id);
	   System.out.print(",");
	   System.out.print(this.sum_vat_tax);
	   System.out.print(",");
	   System.out.print(this.sum_prices);
	   System.out.print(",");
	   System.out.print(this.sum_total);
//System.out.println("out order.display ----");
   }

}


