

/*
 Program Name: PaymentAdjustment.java
 Author: Nandeesh
 Date  : Feb, 2001
 Purpose: Defines the interfaces of Payment and Adjustment requirements of Billing Portal
*/
package portal.paymentadjustment;


import java.sql.*;
import java.io.*;
import java.util.*;

import portal.base.*;

public interface PaymentAdjustment
{
  // For date ranges, * means no date range and get everything.
  // This returns the list of activities for a given Account  for a given date range.
  // lists all activities or supply the value for specific activity. eg., ADJ for adjustment
  public Vector getAccountActivities(String[] accountId, String transType, String startDate, String endDate);

  // New Requirement
  public Vector getAccountActivitiesRange(String startAccId, String endAccId, String transType, String startDate, String endDate);

  // This returns the list of activities for a given Ispvn for a given date range.
  // lists all activities or supply the value for specific activity. eg., PMT for payment
  public Vector getIspvnActivities(String[] ispvnId, String transType, String startDate, String endDate);

  // This returns the new Transaction Id if the operation is sucessful or 0 if failed.
  public String makePayment(BillingTransaction transObj);

  //This returns the new Transaction Id if the operation is sucessful or 0 if failed.
  public String cancelTransaction(String transId, String transType, String operatorId);

  // This method  returns the record for given  Transaction Id
  public BillingTransaction  getTransactionDetails(String transId);

  //This returns all receipts of non-cancelled payments for a given Ispvn and a date range.
  public Vector getIspvnReceipts(String[] ispvnId, String startDate, String endDate);

  //This retuns all receipts of non-cancelled payments for a given Account and a date range.
  public Vector getAccountReceipts(String[] accountId, String startDate, String endDate);

  //New Requirement
  public Vector getAccountReceiptsRange(String startAccId, String endAccId, String startDate, String endDate);

  //New Requirement
  //This retuns all adjustments of non-cancelled payments for a given Account and a date range.
  public Vector getAccountAdjustments(String[] accountId, String startDate, String endDate);

  //New Requirement
  public Vector getAccountAdjustmentsRange(String startAccId, String endAccId, String startDate, String endDate);

  //New Requirement
  public Vector getPaActivities(String[] accountId, String startDate, String endDate);

  //New Requirement
  public Vector getPaActivitiesRange(String startAccId, String endAccId, String startDate, String endDate);


  //This returns the balance amount for the given account
  public Vector getBalance(String[] accountId);

  //New Requirement
  public Vector getBalanceRange(String startAccId, String endAccId);

  //This returns the new Transaction Id if the operation is sucessful or 0 if failed.
  public String makeAdjustment(BillingTransaction transObj);
}
