
/*
 Program Name: paBean.java
 Author : Nandeesh , Huiqiong
 Date : Feb, 2001
 Purpose:  To implement the functionality of PaymentAdjustment interface
*/

//package ibasis.billingPortal;
//import ibasis.bean.*;

package portal.paymentadjustment;

import java.util.*;
import java.io.*;


import portal.base.*;
import portal.bean.*;
import portal.servletbeans.*;


/**
	* This class facilitates in payment and adjustment related activities
	* like make payment, make dedit or crebit adjustment and retrieving such
	* similar information for given Account(s) and Isp(s).
 */


public class paBean implements PaymentAdjustment {

   		private DbUtil _myDbUtil;

	/* Initialise all necessary steps in the constructor */

		public paBean() {
			_myDbUtil = new DbUtil();
		  }

		/**
		 * Makes the payment against an invoice/order
		 * @return   String new transaction Id will be returned if success or 0 will be returned.
		 * @param    _pTransObj  transaction object with all necessary values set.
		 */

		 public String makePayment(BillingTransaction _pTransObj) {

			/* String accountId, String ispvnId, String amount,
                String operatorId, String referenceId,
				String description, String ccType, String chequeNo */

				String _transId = "0";
				//String _vSelected = "";
				long _$oneQuantity = 0;
				long _oneCentQuantity = 0;
    			Float _oFloat;
    			float _floatValofString ;
    			StringBuffer _sql= new StringBuffer("");
    			Vector _vSelected;


				try {
				_pTransObj.setTransType("PMT");
				_transId = _pTransObj.InsertTransaction();

				// All the payment entries are the credit entries..
				// get the Amount
				System.out.println("Value of transaction Amount = " + _pTransObj.getAmount());
				_oFloat = Float.valueOf(_pTransObj.getAmount());
    	 		_floatValofString = _oFloat.floatValue();
	            _$oneQuantity =  _oFloat.longValue();
	            float _noOfCentsIn$ =  _floatValofString - _$oneQuantity ;
	            _oneCentQuantity = Math.round(_noOfCentsIn$ * 100);
	            System.out.println("  value of _$oneQuantity= " + _$oneQuantity);
	            System.out.println( "value of _noOfCents = " + _noOfCentsIn$);
			  	System.out.println( "value of _oneCentQuantity = " + _oneCentQuantity);

			  	//operation below is generic credit one dollar and/or one cent entries

	            if (_$oneQuantity != 0) {
					_sql = _sql.append("SELECT count(*) from order_line where order_id = " + _pTransObj.getReference());
					_sql = _sql.append("  AND  item_id = 1000000050");
					_vSelected = _myDbUtil.ExecuteSelectQuery(_sql.toString(), 1);
					String[] _returned = (String[]) (_vSelected.firstElement());
					_sql.setLength(0);

					if (!_returned[0].equals("0")) {
					  _sql = _sql.append("UPDATE order_line SET quantity = quantity + " + _$oneQuantity);
					  _sql= _sql.append(" , total = total - " + _$oneQuantity + "  WHERE ");
					  _sql = _sql.append(" order_id = " +  _pTransObj.getReference() + " AND " );
					  _sql = _sql.append(" item_id = 1000000050");
					  if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not update Generic one dollar") ;
					}
					else {
					 _sql = _sql.append("INSERT INTO order_line ( order_id,item_id,quantity,total,");
					 _sql = _sql.append(" vat_tax_percentage) VALUES (" + _pTransObj.getReference());
					 _sql = _sql.append(" , 1000000050," + _$oneQuantity + ", -" + _$oneQuantity + ",0)");
					 if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not insert Generic one dollar") ;
					}
				}

				if (Math.abs(_oneCentQuantity) >= 1) {
					_sql.setLength(0);
					_sql = _sql.append("SELECT count(*) from order_line where order_id = " + _pTransObj.getReference());
					_sql = _sql.append("  AND  item_id = 1000000052");
					_vSelected = _myDbUtil.ExecuteSelectQuery(_sql.toString(), 1);
					String[] _returned = (String[]) (_vSelected.firstElement());
					_sql.setLength(0);

					_sql.setLength(0);
					if (!_returned[0].equals("0")) {
					  _sql = _sql.append("UPDATE order_line SET quantity = quantity + " + _oneCentQuantity);
					  _sql= _sql.append(" , total = total - " + _noOfCentsIn$ + "  WHERE ");
					  _sql = _sql.append(" order_id = " +  _pTransObj.getReference() + " AND " );
					  _sql = _sql.append(" item_id = 1000000052");
					  if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not update Generic one cent") ;
					}
					else {
					 _sql = _sql.append("INSERT INTO order_line ( order_id,item_id,quantity,total,");
					 _sql = _sql.append(" vat_tax_percentage) VALUES (" + _pTransObj.getReference());
					 _sql = _sql.append(" , 1000000052," + _oneCentQuantity + ", -" + _noOfCentsIn$ + ",0)");
					 if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not inset Generic one cent") ;
					}
				}
			   }

				catch (Exception ex) {
					System.out.println("Exception during Payment:    " + ex);
				}
				finally { return _transId; }
	    }

		/**
		 * Makes a debit or credit adjustment
		 * @return   String new transaction Id will be returned if success or 0 will be returned.
		 * @param    _pTransObj transaction object with all necessary values set.
		 */

		public String makeAdjustment(BillingTransaction _pTransObj) {

            String _result =  "";
			long _$oneQuantity = 0;
			long _oneCentQuantity = 0;
			Float _oFloat;
			float _floatValofString ;
			StringBuffer _sql= new StringBuffer("");
			Vector _vSelected;
			boolean _creditFlag = true;

			 try {
				   _pTransObj.setTransType("ADJ");
				   _result = _pTransObj.InsertTransaction();

					System.out.println("Value of transaction Amount = " + _pTransObj.getAmount());
					_oFloat = Float.valueOf(_pTransObj.getAmount());
					_floatValofString = _oFloat.floatValue();
					if (_floatValofString < 0)
					{	_creditFlag = false;   // debit transaction, hence subtract from total..
						_floatValofString = -_floatValofString;
					}

					_$oneQuantity =  _oFloat.longValue();
					float _noOfCentsIn$ =  _floatValofString - _$oneQuantity ;
					_oneCentQuantity = Math.round(_noOfCentsIn$ * 100);
					System.out.println("  value of _$oneQuantity= " + _$oneQuantity);
					System.out.println( "value of _oneCentQuantity = " + _oneCentQuantity);

				   	//operation below is generic credit one dollar and/or one cent entries

	            if (_$oneQuantity != 0) {

					_sql = _sql.append("SELECT count(*) from order_line where order_id = " + _pTransObj.getReference());

					if (_creditFlag)
						_sql = _sql.append("  AND  item_id = 1000000050");  //$1 credit item
					else
						_sql = _sql.append("  AND  item_id = 1000000051"); //$1 debit item

					_vSelected = _myDbUtil.ExecuteSelectQuery(_sql.toString(), 1);  // count always returns one row
					String[] _returned = (String[]) (_vSelected.firstElement());
					_sql.setLength(0);

					if (!_returned[0].equals("0")) {
						if (_creditFlag) {
						  _sql = _sql.append("UPDATE order_line SET quantity = quantity + " + _$oneQuantity);
						  _sql= _sql.append(" , total = total - " + _$oneQuantity + "  WHERE ");
						  _sql = _sql.append(" order_id = " +  _pTransObj.getReference() + " AND " );
						  _sql = _sql.append(" item_id = 1000000050");
					 	}
					 	else
					 	{
						  _sql = _sql.append("UPDATE order_line SET quantity = quantity + " + _$oneQuantity);
						  _sql= _sql.append(" , total = total + " + _$oneQuantity + "  WHERE ");
						  _sql = _sql.append(" order_id = " +  _pTransObj.getReference() + " AND " );
						  _sql = _sql.append(" item_id = 1000000051");
						}

					  if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not update Generic one dollar") ;
					}

				    else {
						if (_creditFlag) {
						 _sql.setLength(0);
						 _sql = _sql.append("INSERT INTO order_line ( order_id,item_id,quantity,total,");
						 _sql = _sql.append(" vat_tax_percentage) VALUES (" + _pTransObj.getReference());
						 _sql = _sql.append(" , 1000000050," + _$oneQuantity + ", -" + _$oneQuantity + ",0)");
					 	}
					 	else
					 	{_sql.setLength(0);
						 _sql = _sql.append("INSERT INTO order_line ( order_id,item_id,quantity,total,");
						 _sql = _sql.append(" vat_tax_percentage) VALUES (" + _pTransObj.getReference());
						 _sql = _sql.append(" , 1000000051," + _$oneQuantity + "," + _$oneQuantity + ",0)");
						}
						 if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not insert Generic one dollar") ;
					}
				}

				if (Math.abs(_oneCentQuantity) >= 1) {
					_sql.setLength(0);
					_sql = _sql.append("SELECT count(*) from order_line where order_id = " + _pTransObj.getReference());

					if (_creditFlag)
						_sql = _sql.append("  AND  item_id = 1000000052");  //one cent credit
					else
						_sql = _sql.append("  AND  item_id = 1000000053");  //one cent debit

					_vSelected = _myDbUtil.ExecuteSelectQuery(_sql.toString(), 1);

					String[] _returned = (String[]) (_vSelected.firstElement());
					_sql.setLength(0);

					if (!_returned[0].equals("0")) {
						if (_creditFlag)  {
						  _sql.setLength(0);
						  _sql = _sql.append("UPDATE order_line SET quantity = quantity + " + _oneCentQuantity);
						  _sql= _sql.append(" , total = total - " + _noOfCentsIn$ + "  WHERE ");
						  _sql = _sql.append(" order_id = " +  _pTransObj.getReference() + " AND " );
						  _sql = _sql.append(" item_id = 1000000052");
					  	}
					  	else
					  	{_sql.setLength(0);
						  _sql = _sql.append("UPDATE order_line SET quantity = quantity + " + _oneCentQuantity);
						  _sql= _sql.append(" , total = total + " + _noOfCentsIn$ + "  WHERE ");
						  _sql = _sql.append(" order_id = " +  _pTransObj.getReference() + " AND " );
						  _sql = _sql.append(" item_id = 1000000053");
						}

					  if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not update Generic one cent") ;
					}

					else {
						_sql.setLength(0);
						if (_creditFlag)  {
							 _sql = _sql.append("INSERT INTO order_line ( order_id,item_id,quantity,total,");
							 _sql = _sql.append(" vat_tax_percentage) VALUES (" + _pTransObj.getReference());
							 _sql = _sql.append(" , 1000000052," + _oneCentQuantity + ", -" + _noOfCentsIn$ + ",0)");
						}
						else
						{
							 _sql = _sql.append("INSERT INTO order_line ( order_id,item_id,quantity,total,");
							 _sql = _sql.append(" vat_tax_percentage) VALUES (" + _pTransObj.getReference());
							 _sql = _sql.append(" , 1000000053," + _oneCentQuantity + "," + _noOfCentsIn$ + ",0)");
						}

					 if (_myDbUtil.ExecuteUpdateQuery(_sql.toString()) == 0) System.out.println("did not insert Generic one cent") ;
					}
				}



				 }
			   catch (Exception ex) {
					System.out.println("Exception during Adjustment:    " + ex);
				}
				finally {  return _result; }
			}

			/**
			 * Makes a transaction to cancel an existing transaction.
			 * @return   String new transaction Id will be returned if success or 0 will be returned.
			 * @param   _pTransId the transaction Id of an existing transaction
			 * @param   _pTransType  like CINV,CADJ and Operator Id.
			 * @param   _pOperatorId Id of the Operator.
			 */

		  //This returns the new Transaction Id if the operation is successful or 0 if failed.
		  public String cancelTransaction(String _pTransId, String _pTransType, String _pOperatorId) {

			/* For cancel operations, make a new entry in the Transaction table with proper
			value for TRANS_TYPE  (eg., CADJ for canceling Adjustments, CINV for
			canceling Invoice etc.,) , REFERENCE_ID will have the ID of transaction to which
			this cancellation applies.
			Amount need not be mentioned. The cancelled Transaction's record will be updated
			with STATUS value set to A */


		   // get account_Id and ispvn_Id for given transaction from table.

				BillingTransaction _transObj;
				String _result="0";

				_transObj = new BillingTransaction();

				try {
				_transObj.setTransId(_pTransId);
				_transObj.setTransType(_pTransType);
				_transObj.setOperator(_pOperatorId);
				_result = _transObj.cancelTransaction();
			       }
			    catch (Exception ex) {
					System.out.println("Exception during rollback/releaseConnection:    " + ex);
					}
				return _result;
		}

			/**
				* gets the Activities for given account(s)
				* @return   Vector having activity details
				* @param    accountId[] arry of account Id
				* @param    transType like CINV,CADJ,PMT etc.,
				* @param    startDate start of date range
				* @param    endDate end of date range
			 */

		public Vector getAccountActivities(String[] accountId, String transType,String startDate, String endDate) {

			/********************************************************************************************
			* Method:  Vector getAccountActivities
			* HH
			* Purpose:
			*    This returns the list of activities for a given Account  for a given date range.
			*    lists all activities or supply the value for specific activity. eg., ADJ for adjustment
			*
			**********************************************************************************************/

				String sqlcmd =  "";
				int numAccountId = accountId.length;
				String listAccountId = "" ;
				Vector _vSelected;


			   listAccountId = accountId[0];
			   for(int i=1; i<numAccountId; i++) {
				  listAccountId = listAccountId + "," + accountId[i];
			   }

			   //String[] headLine = {"id", "trans_type", "account_id", "ispvn_id","amount", "note",
			   //					"status", "reference_id", "operator", "description", "cc_type",
			   //					"timestamp", "check_no"};

			   sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note, status, reference_id," +
						" operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
						" FROM  transaction " ;
			   sqlcmd += " WHERE account_id in (" + listAccountId +   ") " ;

			   if (!transType.equals("*"))
			   		sqlcmd += " AND trans_type = '"+ transType + "' " ;


			   if (!startDate.equals("*"))  //if (startDate != "*")
			   		sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			   if (!endDate.equals("*")) //if (endDate  != "*")
			   		sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
			   		sqlcmd += " order by account_id,id";



			  // System.out.println(sqlcmd);


			  _vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 13);

			  return _vSelected;

    	  }


			/********************************************************************************************
				* Method:  Vector getIspvnActivities
				* HH
				* Purpose:
				*   This returns the list of activities for a given Ispvn for a given date range.
				*   lists all activities or supply the value for specific activity. eg., PMT for payment
				*
			**********************************************************************************************/

			/**
			   * Gets  activities of given Isp(s)
			   * @return   Vector containing the information about Activities
			   * @param    ispvnId[] string array of Isp
			   * @param    transType like PMT,ADJ  Daterange specified by Start and End date.
			   * @param    startDate start of date range
			   * @param    endDate end of date range
 			*/


		  public Vector getIspvnActivities(String[] ispvnId, String transType,String startDate, String endDate) {

				String sqlcmd =  "";
				int numIspvnId = ispvnId.length;
				String listIspvnId = "" ;
				Vector _vSelected;

			  // db_App = new DBApp() ;
			  // fpWrite  = new FilePageWriter() ;

			   listIspvnId = ispvnId[0];

			   for(int i=1; i < numIspvnId ; i++){
				  listIspvnId  = listIspvnId  + "," + ispvnId[i];
			   }

			 /*  String[] headLine = {"id", "trans_type", "account_id","ispvn_id", "amount", "note",
									"status", "reference_id", "operator", "description", "cc_type",
									"timestamp","check_no"};   */

			   sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note, status, reference_id," +
						" operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp, check_no " +
						" FROM  transaction " ;
			   sqlcmd += " WHERE ispvn_id in (" + listIspvnId  +   ") " ;

			   sqlcmd += " AND trans_type = '" + transType + "' " ;

			   if (!startDate.equals("*"))
			   		sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			   if (!endDate.equals("*"))
			   		sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";


    	 	//  System.out.println(sqlcmd);


				_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 13);

				return _vSelected;
		}

		/**
		   * Gets  Transaction details including the balance of the account
		   * @return   BillingTransaction the BillingTransaction object
		   * @param    _pTransId transaction Id
		*/

		  public BillingTransaction  getTransactionDetails(String _pTransId) {

			/* This method  returns the record for given  Transaction Id */

				StringBuffer _sqlFetch= new StringBuffer("");
				Vector _vSelected;
				String _transId;
				String _accountId;
				String _ispvnId;
				BillingTransaction _returnRecord;

			   _sqlFetch = _sqlFetch.append("SELECT a.ID, a.TRANS_TYPE, a.ACCOUNT_ID, a.ISPVN_ID, a.AMOUNT,");
			   _sqlFetch = _sqlFetch.append("a.NOTE, a.STATUS, a.OPERATOR, a.REFERENCE_ID, a.DESCRIPTION,");
			   _sqlFetch = _sqlFetch.append(" a.CC_TYPE, to_char(a.TIMESTAMP,'dd-MON-yyyy') timestamp, a.CHECK_NO,a.TRANS_TERMS,  ");
			   _sqlFetch = _sqlFetch.append(" a.CC_NUM,a.CC_EXPMONTH,a.CC_EXPYEAR,to_char(a.CHECK_DATE,'dd-MON-yyyy'),");
			   _sqlFetch = _sqlFetch.append(" a.CHECK_BANK , b.AMOUNT");

			   _sqlFetch = _sqlFetch.append("  FROM Transaction a , billing_Balance b WHERE ");
			   _sqlFetch = _sqlFetch.append(" (a.ID = " + _pTransId + ")");
			   _sqlFetch = _sqlFetch.append(" AND (a.ACCOUNT_ID = b.ACCOUNT_ID)");


			   System.out.println("sql fetch --> " + _sqlFetch.toString());

			   	_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 20);
				_returnRecord = new BillingTransaction();

				if (_vSelected.size() == 0) {
					_vSelected = null;
					System.out.println("Nothing was returned");
					return _returnRecord;  }  // no such transaction exist

				String[] _returned = (String[]) (_vSelected.firstElement());
				try {
					_returnRecord.setTransId(_returned[0]);
					_returnRecord.setTransType(_returned[1]);
					_returnRecord.setAccount(_returned[2]);
					_returnRecord.setIspvn(_returned[3]);
					_returnRecord.setAmount(_returned[4]);
					_returnRecord.setNote(_returned[5]);
					_returnRecord.setStatus(_returned[6]);
					_returnRecord.setOperator(_returned[7]);
					_returnRecord.setReference(_returned[8]);
					_returnRecord.setDescription(_returned[9]);
					_returnRecord.setCCType(_returned[10]);
					_returnRecord.setTimeStamp(_returned[11]);
					_returnRecord.setCheckNo(_returned[12]);
					_returnRecord.setTransTerms(_returned[13]);
					_returnRecord.setCcNum(_returned[14]);
					_returnRecord.setExpMonth(_returned[15]);
					_returnRecord.setExpYear(_returned[16]);
					_returnRecord.setCheckDate(_returned[17]);
					_returnRecord.setCheckBank(_returned[18]);
					_returnRecord.setBalance(_returned[19]);

			      }


				catch (Exception e) {
							System.out.println("Exception while setting values for Billing transaction" + e.toString());
						}
				finally { _vSelected = null;
						  return _returnRecord;
					}
			  }


		/**
		   * This returns all receipts of non-cancelled payments
		   * @return   Vector containing the information about receipts of non-cancelled payments
		   * @param    _pIspvnId[] array of Isp(s)
		   * @param    _pStartDate  start of date range
		   * @param    _pEndDate end of date range
		*/


		  public Vector getIspvnReceipts(String[] _pIspvnId, String _pStartDate, String _pEndDate) {

		  //This returns all receipts of non-cancelled payments for a given Ispvn and a date range.

			  	StringBuffer _sqlFetch= new StringBuffer("");
			  	int _arrLength;

				Vector _vSelected;
				String _transId;
				String _accountId;
				String _ispvnId;

			   _sqlFetch = _sqlFetch.append("SELECT  ID,  ACCOUNT_ID, ISPVN_ID,AMOUNT,NOTE, ");
			   _sqlFetch = _sqlFetch.append("REFERENCE_ID,OPERATOR,DESCRIPTION,");
			   _sqlFetch = _sqlFetch.append("CC_TYPE,to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,CHECK_NO ");
			   _sqlFetch = _sqlFetch.append("  FROM Transaction WHERE ");

			  if (!_pStartDate.equals("*"))   // if (_pStartDate != "*")
					 _sqlFetch =  _sqlFetch.append(" TimeStamp >= to_date('" + _pStartDate + "' , 'mm/dd/yyyy') AND");

			  if (!_pEndDate.equals("*"))  // if (_pEndDate != "*")
					 _sqlFetch =  _sqlFetch.append(" TimeStamp <= to_date('" + _pStartDate + "' , 'mm/dd/yyyy') AND");

				_sqlFetch = _sqlFetch.append(" trans_type='PMT' AND status='A'");
				_arrLength = _pIspvnId.length;

				if (_arrLength > 0) _sqlFetch = _sqlFetch.append(" AND ispvn_id IN ( ");

				for (int i=0; i < _arrLength; i++) {
					if (i == _arrLength - 1) {
						_sqlFetch = _sqlFetch.append(_pIspvnId[i] + ")");
						break; }

					_sqlFetch = _sqlFetch.append(_pIspvnId[i] + ",");
				  }

				  System.out.println("value of sqlFetch = " + _sqlFetch);

				_vSelected = _myDbUtil.ExecuteSelectQuery(_sqlFetch.toString(), 11);

				return _vSelected;

		}

		/**
		   * This returns all receipts of non-cancelled payments for given Account(s)
		   * @return   Vector containing the information about receipts of non-cancelled payments
		   * @param    accountId[] array of Account(s)
		   * @param    startDate start of date range
		   * @param    endDate  end of date range
		*/


		 // HH

		  public Vector getAccountReceipts(String[] accountId, String startDate, String endDate) {

			String sqlcmd =  "";
			int numAccountId = accountId.length;
			String listAccountId = "" ;
			Vector _vSelected;


		  // db_App = new DBApp() ;
		  // fpWrite  = new FilePageWriter() ;

       		listAccountId = accountId[0];

		   for(int i=1; i<numAccountId; i++){
			  listAccountId = listAccountId + "," + accountId[i];
		   }

      	/* String[] headLine = {"id", "trans_type", "account_id", "ispvn_id","amount", "note",
                            "status", "reference_id", "operator", "description", "cc_type",
                            "timestamp", "check_no"};  */

       		sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note,  reference_id," +
                " operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
                " FROM  transaction " ;
       		sqlcmd += " WHERE account_id IN (" + listAccountId +   ") " ;
       		sqlcmd += " AND  trans_type = 'PMT' ";

       		sqlcmd += " AND status <> 'C' " ;

			if (!startDate.equals("*"))  // if (startDate != "*")
				sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			if (!endDate.equals("*"))   // if (endDate != "*")
			sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
			sqlcmd += " ORDER BY account_id,id ";
			//System.out.println("sqlcmd-->" + sqlcmd);

			_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 12);

			return _vSelected;
	}

		/**
		   * This returns all non-cancelled payments and adjustments
		   * @return   Vector containing the information about non-cancelled payments and adjustments
		   * @param    accountId[] array of Account(s)
		   * @param    startDate  start of date range
		   * @param    endDate end of  date range
		*/


	  public Vector getPaActivities(String[] accountId, String startDate, String endDate) {

			String sqlcmd =  "";
			int numAccountId = accountId.length;
			String listAccountId = "" ;
			Vector _vSelected;


	       	listAccountId = accountId[0];

		   for(int i=1; i<numAccountId; i++){
			  listAccountId = listAccountId + "," + accountId[i];
		   }

      		sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note, reference_id," +
               		 " operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
                	 " FROM  transaction " ;
       		sqlcmd += " WHERE account_id IN (" + listAccountId +   ") " ;
       		sqlcmd += " AND  trans_type IN ('PMT','ADJ') ";

       		sqlcmd += " AND status <> 'C' " ;

			if (!startDate.equals("*"))
				sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			if (!endDate.equals("*"))
			sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
			sqlcmd += " ORDER BY account_id,id ";

			_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 12);

			return _vSelected;
	}

		/**
		   * This returns all non-cancelled payments and adjustments for a given Account and date range
		   * @return   Vector containing the information about non-cancelled payments and adjustments
		   * @param    startAccId beginning of Account range  and a date range specified by Start and End date
		   * @param    endAccId end of Account range
		   * @param    startDate beginning of date range
		   * @param    endDate   end of date range
		*/

		public Vector getPaActivitiesRange(String startAccId, String endAccId, String startDate, String endDate) {

			String sqlcmd =  "";
			String listAccountId = "" ;
			Vector _vSelected;

			sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note, reference_id," +
				" operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
				" FROM  transaction " ;

			sqlcmd += " WHERE account_id BETWEEN " +  startAccId + " AND "  + endAccId ;
			sqlcmd += " AND  trans_type IN ('ADJ', 'PMT')";

			sqlcmd += " AND status <> 'C' " ;

			if (!startDate.equals("*"))
				sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			if (!endDate.equals("*"))
				sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
				sqlcmd += " ORDER BY account_id,id ";

			_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 12);

			return _vSelected;
		}

		/**
		   * This returns all non-cancelled adjustments for a given Account and a date range.
		   * @return   Vector containing the information about non-cancelled adjustments
		   * @param    accountId[]  array of Account(s)
		   * @param    startDate  start of date range
		   * @param    endDate end of date range
		*/

		  public Vector getAccountAdjustments(String[] accountId, String startDate, String endDate) {

			String sqlcmd =  "";
			int numAccountId = accountId.length;
			String listAccountId = "" ;
			Vector _vSelected;

       		listAccountId = accountId[0];

		   for(int i=1; i<numAccountId; i++){
			  listAccountId = listAccountId + "," + accountId[i];
		   }

       		sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note,  reference_id," +
                " operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
                " FROM  transaction " ;
       		sqlcmd += " WHERE account_id IN (" + listAccountId +   ") " ;
       		sqlcmd += " AND  trans_type = 'ADJ' ";

       		sqlcmd += " AND status <> 'C' " ;

			if (!startDate.equals("*"))
				sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			if (!endDate.equals("*"))
			sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
			sqlcmd += " ORDER BY account_id,id ";

			_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 12);

			return _vSelected;
	}

		/**
		   * This returns all non-cancelled adjustments for a given Account range and a date range.
		   * @return   Vector containing the information about non-cancelled adjustments
		   * @param    startAccId beginning of Account range  and a date range specified by Start and End date
		   * @param    endAccId end of Account range
		   * @param    startDate beginning of date range
		   * @param    endDate   end of date range

		*/

		public Vector getAccountAdjustmentsRange(String startAccId, String endAccId, String startDate, String endDate) {

			String sqlcmd =  "";
			String listAccountId = "" ;
			Vector _vSelected;

			sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note, status, reference_id," +
				" operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
				" FROM  transaction " ;

			sqlcmd += " WHERE account_id BETWEEN " +  startAccId + " AND "  + endAccId ;
			sqlcmd += " AND  trans_type = 'ADJ' ";

			sqlcmd += " AND status <> 'C' " ;

			if (!startDate.equals("*"))
				sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
			if (!endDate.equals("*"))
				sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
				sqlcmd += " ORDER BY account_id,id ";

			_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 13);

			return _vSelected;
		}


/********************************************************************************************
		 * Method:  Vector getBalance(String[] accountId)
		 * HH
		 * Purpose:
		 *
		 * This returns the balance amount for the given account
		 *
**********************************************************************************************/

		/**
		   * This returns the balance amount for the given account(s)
		   * @return   Vector containing the information in the billing_balance table
		   * @param    accountId[]  array of Account
		*/


		  public Vector getBalance(String[] accountId) {

			String sqlcmd =  "";
			int numAccountId = accountId.length;
			String listAccountId = "" ;
			Vector _vSelected;


			  // db_App = new DBApp() ;
			  // fpWrite  = new FilePageWriter() ;

			   listAccountId = accountId[0];

			   for(int i=1; i<numAccountId; i++) {

				  listAccountId = listAccountId + "," + accountId[i];
			   }

				// String[] headLine = {"account_id", "order_id", "amount", "save_invoice_details"};

				sqlcmd = "SELECT account_id, order_id, amount, save_invoice_details " +
						" FROM billing_balance " ;

				sqlcmd += " WHERE account_id IN (" + listAccountId +   ") " ;

				_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 4);

				return _vSelected;
			}

			/**
			   * This returns the Activities range from Transaction table for a range of Accounts
			   * @return   Vector containing the information about the Account activities
			   * @param    startAccId beginning of Account range
			   * @param    endAccId end of Account range
			   * @param    transType transaction activity like PMT,ADJ..
			   * @param    startDate beginning of date range
			   * @param    endDate   end of date range

			*/

			  public Vector getAccountActivitiesRange(String startAccId, String endAccId, String transType, String startDate, String endDate) {

					String sqlcmd =  "";
					String listAccountId = "" ;
					Vector _vSelected;

				   sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note, status, reference_id," +
							" operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
							" FROM  transaction " ;

				   sqlcmd += " WHERE account_id BETWEEN " +  startAccId + " AND "  + endAccId ;

				   if ((transType != "") || (transType != "*"))
					 sqlcmd += " AND trans_type = '"+ transType + "' " ;

				   if (!startDate.equals("*")) //if (startDate != "*")
				   		sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
				   if (!endDate.equals("*")) //if (endDate  != "*")
				   		sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
				  		sqlcmd += " order by account_id,id";

				  // System.out.println(sqlcmd);


				  _vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 13);

				  return _vSelected;

				}

			/**
			   * This returns the non-cancelled payment activities range from Transaction table for a range of Accounts
			   * @return   Vector containing the information about the Account activities
			   * @param    startAccId beginning of Account range
			   * @param    endAccId end of Account range
			   * @param    startDate beginning of date range
			   * @param    endDate   end of date range

			*/

				public Vector getAccountReceiptsRange(String startAccId, String endAccId, String startDate, String endDate) {

					String sqlcmd =  "";
					String listAccountId = "" ;
					Vector _vSelected;


				  // db_App = new DBApp() ;
				  // fpWrite  = new FilePageWriter() ;


					sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note,  reference_id," +
						" operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
						" FROM  transaction " ;

					sqlcmd += " WHERE account_id BETWEEN " +  startAccId + " AND "  + endAccId ;
					sqlcmd += " AND  trans_type = 'PMT' ";

					sqlcmd += " AND status <> 'C' " ;

					if (!startDate.equals("*")) // if (startDate != "*")
						sqlcmd += " AND timestamp  >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') ";
					if (!endDate.equals("*"))  //if (endDate != "*")
						sqlcmd += " AND timestamp  < TO_DATE('" + endDate + "', 'MM/DD/YYYY') + 1 ";
						sqlcmd += " ORDER BY account_id,id ";

					_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 13);

					return _vSelected;
			}

			/**
			   * This returns the details of billing_balance table for a range of accounts
			   * @return   Vector containing the information about the billing balance table
			   * @param    startAccId beginning of Account range
			   * @param    endAccId end of Account range
			*/


			public Vector getBalanceRange(String startAccId, String endAccId) {

				String sqlcmd =  "";
				String listAccountId = "" ;
				Vector _vSelected;


			  // db_App = new DBApp() ;
			  // fpWrite  = new FilePageWriter() ;

				sqlcmd = "SELECT account_id, order_id, amount, save_invoice_details " +
						" FROM billing_balance " ;

				sqlcmd += " WHERE account_id BETWEEN " +  startAccId + " AND "  + endAccId ;

				_vSelected = _myDbUtil.ExecuteSelectQuery(sqlcmd.toString(), 4);

				return _vSelected;
			}

     }



