
/***************************************************************************************/
// Program Name: Allcdrs.java
//
// Copyright (c)2001 iBasis.    All rights reserved.
// Author: H. Huang
//
// Date Written: November, 2000
//
//
// Purpose:  To lookup all cdrs data in the database using input
//           from the user via html.
//
// Note:  
//          Defalt Setting:
//             If user doesn't specify  startDate, endDate, it will return the 
//             last 20 calls.
//
//
// Update(s):  1) May,2001
//                Add "Export" option
/**************************************************************************************/

package portal.report;

import portal.bean.*;
import java.util.*;
import java.sql.*;
import java.io.*;

public class Allcdrs 
{
   private DBApp db_App;
   protected DebugWriter writer;
   protected FilePageWriter fpWrite;

   private String sqlcmd ;
   private String action  ;
   private String ISP_Name  ;
   private String startDate ;
   private String startHH ;
   private String startMI ;
   private String startSS ;
   private String endDate  ;
   private String endHH ;
   private String endMI  ;
   private String endSS  ;
   private String sort ;
   private String tableName ;
   private String fileName ;
   private String paramList ;
   private static int fileCounter;
   private Vector resultVector ;
 
   private boolean defaultSetting;
   
  
/********************************************************************
* Method:   Allcdrs()  
*
* Purpose:  Constructor
*********************************************************************/

  public Allcdrs() {
    action = "";      
    ISP_Name= "";
    startDate = "" ;
    endDate = "" ;
    sort = "" ;
    fileName = "";   
    fileCounter = 0;
    resultVector = null;    
    defaultSetting = false;
    
    db_App  = new DBApp();
    writer = new DebugWriter();
    fpWrite = new FilePageWriter();
  }
 
 	
/********************************************************************
* Method:  void getReport()  
*
* Purpose:  This method returns the fileName
*           
*********************************************************************/

 public String getReport() { 
    return ( fpWrite.getXmlDirName()  +  fileName+".xml" );
 }

/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList) {
    doReport(sList);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }



/********************************************************************
* Method:   void doReport(String[] sList )
*
* Purpose:  Start getting report from here.
*********************************************************************/

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;
      saveFile();
      cleanup() ; 
   }

  
/********************************************************************
* Method:   doGet( HttpServletRequest request,
*                   HttpServletResponse response )
*
* Purpose:  
*********************************************************************/ 
/*
   public void doGet( HttpServletRequest request,
                      HttpServletResponse response )
      throws ServletException, IOException
   {
      PrintWriter output;
      response.setContentType( "text/html" );  // content type
      output = response.getWriter();           // get writer

      getFormValues(request) ;
      buildQuery() ;
      executeQuery();
      processData()  ;  
      saveFile();
      printPage(output);  
      
      cleanup() ; 
      if (output != null)
      {  output.close();  }     
   }
*/


/********************************************************************
* Method:  void cleanup()  
*
* Purpose:  This method does cleanup. 
*           Release some resource after susing it.
*           
*********************************************************************/
  private void cleanup() { 
    resultVector = null;    // After using it, clean it.
  }

  
/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
.
*********************************************************************/

 public void setReportParams(String[] sList)  {
 	   action = sList[0];
     ISP_Name = sList[1];   
     startDate = sList[2];  

     startHH = sList[3]; 
     if( startHH.equals("") ) { startHH = "00" ; }

     startMI = sList[4]; 
     if( startMI.equals("") ) { startMI = "00" ; }

     startSS = sList[5]; 
     if( startSS.equals("") ) { startSS = "00" ; }

     endDate = sList[6]; 
     endHH = sList[7]; 
     if( endHH.equals("") ) { endHH = "00" ; }

     endMI = sList[8];  
     if( endMI.equals("") ) { endMI = "00" ; }

     endSS = sList[9];  
     if( endSS.equals("") ) { endSS = "00" ; }

     sort = sList[10];  
     tableName = sList[11];  
         
     setParamList() ;
 }

  

  /********************************************************************
* Method:   void setParamList()
*
* Purpose:  Set the report params header.
*    
*    
*********************************************************************/

 public void setParamList()  {     
     paramList = " action =\"" + action + "\" " +
                  "ISP_Name=\"" + ISP_Name + "\" " +
                  "startDate=\"" + startDate + "\" " +
                  "startHH=\"" + startHH + "\" " +
                  "startMI=\"" + startMI + "\" " +
                  "startSS=\"" + startSS  + "\" " +
                  "endDate =\"" + endDate  + "\" " +
                  "endHH=\"" + endHH + "\" " +
                  "endMI=\"" + endMI + "\" " +
                  "endSS=\"" + endSS + "\" " +
                  "sort=\"" + sort + "\" " +
                  "tableName=\"" + tableName + "\" " ;
 }


  
/********************************************************************
* Method:   void buildQuery()
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery(){
     String sortOrder = "";
     String space = " ";
     String colon = ":";
     defaultSetting = false;

     if (sort.equals("Date")){
          sortOrder = "to_char(v.timestamp, 'mm/dd/yyyy')";
     }
     else if (sort.equals("Account")) {
        sortOrder = " a.username "; 
     }

     else if (sort.equals("Batch_no")) {
        sortOrder = " a.id "; 
     }
     else if (sort.equals("cdr_time")) {
        sortOrder = " to_char(v.timestamp, 'HH24:MI:SS') "; 
     }
     else if (sort.equals("Calling_no")) {
        sortOrder = " v.calling_id "; 
     }
     else if (sort.equals("Called_no")) {
        sortOrder = " v.called_id "; 
     }
     else if (sort.equals("Disconnect_cause")) {
        sortOrder = " v.disconnect_cause "; 
     }
     else if (sort.equals("Destination")) {
        sortOrder = " t.name "; 
     }
     else if (sort.equals("cdr_duration")) {
       // sortOrder = " v.duration "; 
        sortOrder = " round(v.duration/60,2) "; 
     }
     else if (sort.equals("End_user_charge")) {
        sortOrder = " round(v.amount,2) "; 
     }
     else {      // (sort.equals("Provider") )
        sortOrder = "i.name"; 
     }

     if( ISP_Name.equals("ALL") ) {
       sqlcmd =  "select i.name, a.username, a.id, to_char(v.timestamp, 'MM/DD/YY'),";
     }else {
       sqlcmd =  "select a.username, a.id, to_char(v.timestamp, 'MM/DD/YY'),";
     }

     sqlcmd = sqlcmd  + "to_char(v.timestamp, 'HH24:MI:SS'), v.calling_id, v.called_id,";
     sqlcmd = sqlcmd  + "v.disconnect_cause, (v.duration -MOD(v.duration,60))/60||':'||MOD(v.duration,60) " ;
 
     if (!tableName.equals("voip_cdr_failed")){
        sqlcmd = sqlcmd  +  ", t.name, round(v.amount,2)   ";
     }


     sqlcmd = sqlcmd +"from " + tableName + " v, access_ a, ispvn i, product p," +
              "service s, service_access sa, access_type at ";

     if (!tableName.equals("voip_cdr_failed")){
        sqlcmd = sqlcmd  +  ", tele_numplan t ";
     }

    sqlcmd = sqlcmd + "where upper(i.name) = upper('"+ ISP_Name + "') ";


     if( ! startDate.equals("") ){
          sqlcmd = sqlcmd + "and v.timestamp  >= to_date('"
                   + startDate + space+ startHH + colon + startMI + colon + startSS 
                   + "','mm/dd/yyyy HH24:MI:SS') ";
     }
     if( ! endDate.equals("") ){
        sqlcmd = sqlcmd +"   and v.timestamp   <= to_date('"
                 + endDate + space+ endHH + colon + endMI+ colon + endSS 
                 + "','mm/dd/yyyy HH24:MI:SS') ";

        //         + "','mm/dd/yyyy HH24:MI:SS') + 1 ";
       
     }
     
     
  // ////////////////////Default setting //////////////////////////////////////////
     //           If user doesn't specify  startDate, endDate, it will return the 
     //           last 20 calls.
     //////////////////////////////////////////////////////////////////////////////////

    if( startDate.equals("") && endDate.equals("")  )   
    {
    	  // It sets: stmt.setMaxRows(20);    
        db_App.setMaxRowState(true, 20);

    //    sqlcmd = sqlcmd + " and v.timestamp  >= sysdate -1 "   ;  
       // sqlcmd = sqlcmd + " and v.timestamp  >	to_date(sysdate, 'dd-mm-yy') - 1 " ;
       // sqlcmd = sqlcmd + " and v.timestamp  >=  TO_DATE(TO_CHAR(sysdate,'mm/dd/yyyy'),'mm/dd/yyyy') -1 ";
 
        defaultSetting = true;
        sortOrder = "v.timestamp  desc "; 	  
    }


     sqlcmd = sqlcmd +" and i.id = v.ispvn_id and a.account_id  = v.account_id ";
     sqlcmd = sqlcmd + "and v.service_id = s.id and s.product_id = p.id ";
     sqlcmd = sqlcmd + "and v.ispvn_id = p.ispvn_id " +
              " and v.service_id = a.service_id " + 
              " and v.service_id = sa.service_id " +
              " and sa.access_type_id = at.id " +
              " and upper(at.name) = upper('VoIP') ";
     if (!tableName.equals("voip_cdr_failed")){
       // sqlcmd = sqlcmd  +  " and t.id = v.dst_tele_numplan_id ";
       /*  2/27/01   Modification to include CDRs with dst_tele_numplan_id = 0 
                     on moe:  tele_numplan_id=1818 
                     on imsbackup:  tele_numplan_id=1714
       */
       /*     sqlcmd = sqlcmd +
                " and t.id = decode(v.dst_tele_numplan_id,0,1714, v.dst_tele_numplan_id) ";  */
       sqlcmd = sqlcmd +
                " and t.id = decode(v.dst_tele_numplan_id,0,1818, v.dst_tele_numplan_id) ";
     }


     sqlcmd += " order by " + sortOrder;
   
     db_App.setMyQuery( sqlcmd );
    // writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  executeQuery() 
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
     
      try {
         db_App.makeConnection(); 
         db_App.execute_sql(sqlcmd) ; 

      }  catch (Exception ex) {   
            System.out.println("Error Connection:    "+ex);
      }
}


/********************************************************************
* Method:  processData() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0;
  
    try {

     noColumn = db_App.getNoColumn();

     String[] headLine = new String[noColumn];
     if( ISP_Name.equals("ALL") ){
           headLine[0] = "Provider"  ; 
           headLine[1] = "Account"; 
           headLine[2] = "Batch_no" ; 
           headLine[3] = "Date" ; 
           headLine[4] = "Time"; 
           headLine[5] = "Calling_no"; 
           headLine[6] = "Called_no"; 
           headLine[7] = "Disconnect_cause"; 
           headLine[8] = "Min:Sec"; 
         if (!tableName.equals("voip_cdr_failed")){
             headLine[9] = "Destination"; 
             headLine[10] = "Charge"; 
         }
     }else {          
           headLine[0] = "Account"; 
           headLine[1] = "Batch_no" ; 
           headLine[2] = "Date" ; 
           headLine[3] = "Time"; 
           headLine[4] = "Calling_no"; 
           headLine[5] = "Called_no"; 
           headLine[6] = "Disconnect_cause"; 
           headLine[7] = "Min:Sec"; 
        if (!tableName.equals("voip_cdr_failed")){
             headLine[8] = "Destination"; 
             headLine[9] = "Charge"; 
         }
     }
     
     // By defalt, put top 20 records in the vector
     if (defaultSetting ) {
         resultVector = fpWrite.getResultVector(db_App,headLine, 20); 
     }else{
          resultVector = fpWrite.getResultVector(db_App,headLine);       
     }  

    }  catch (Exception ex) {   
            System.out.println("Error in processData:    "+ex);
    }
}


/********************************************************************
* Method:  void saveFile()  
*
* Purpose:  This method writes the query result 
*           to a file.
*********************************************************************/


 private void saveFile()  { 
   try{
     fpWrite.setTitle("allcdrs");
     fpWrite.setParamList(paramList);

     fpWrite.setProvider(ISP_Name);

     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "allCDR_" + fileCounter ;

     fpWrite.setFileName(fileName);
  //   fpWrite.writeFileV(fileName+".csv", resultVector) ;
     fpWrite.writeXMLFileV(fileName+".xml", resultVector) ;
   
  //   System.out.println("fileName = " + fpWrite.getCSVFileName() );
  //   System.out.println("RecordNum = " + fpWrite.getRecordNum());

   }  catch (Exception ex) {   
            System.out.println("Error in saveFile: "+ex);
   }

 }

}