
/***************************************************************************************/
// Program Name: CDRs.java
//
// 
//
// Date Written: May, 2001
//
// Created by:  H. Huang
//
// Purpose:  To lookup CDRs data in the database 
//                     
//
// Note:    1. sort by account, timestemp, destination
//          2. Defalt Setting:
//             If user doesn't specify  startDate, endDate, it will return the 
//             last 20 calls.
//
/*
        paramList ={ " action " ,
                  "ISP_Name" ,
                  "startDate " ,
                  "startHH" ,
                  "startMI " ,
                  "startSS" ,
                  "endDate" ,
                  "endHH=" ,
                  "endMI=" ,
                  "endSS=" ,
                  "startAccount" ,
                  "endAccount" ,
                  "rowNum" }
*/
// Update(s):
//
/**************************************************************************************/

                  
                  
package portal.report;
import portal.bean.*;
//import ibasis.bean.*;

import java.util.*;
import java.sql.*;
import java.io.*;



public class CDRs
{
   private DBApp db_App;
   protected DebugWriter writer;
   protected FilePageWriter fpWrite;

   private String sqlcmd ;

   private String action  ;
   private String ISP_Name  ;
   private String startDate ;
   private String startHH ;
   private String startMI ;
   private String startSS ;
   private String endDate  ;
   private String endHH ;
   private String endMI  ;
   private String endSS  ;
 //  private String sort ;
   private String fileName ;
     private String paramList ;
   private static int fileCounter;
   private Vector resultVector ;
   
   private boolean defaultSetting;
   private String startAccount ;
   private String endAccount ;
   private String rowNum; ;


 
 

  
/********************************************************************
* Method:   CDRs()  
*
* Purpose:  Constructor
*********************************************************************/

  public CDRs() {
    action = "";      
    ISP_Name= "";
    startDate = "" ;
    endDate = "" ;
    fileName = "";
    fileCounter = 0 ;

    defaultSetting = false;
    startAccount = "";
    endAccount = "";
   
    rowNum = "";


    db_App  = new DBApp();
    writer = new DebugWriter();
    fpWrite = new FilePageWriter();
  }
 


/********************************************************************
* Method:  void getReport()  
*
* Purpose:  This method returns the fileName
*           
*********************************************************************/

 public String getReport() { 
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }

   
/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList) {
    doReport(sList);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }
 


/********************************************************************
* Method:   void doReport(String[] sList )               
*
* Purpose:  Start getting report from here.
*********************************************************************/ 

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;  
      saveFile();

   }


  
/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
.
*********************************************************************/

 public void setReportParams(String[] sList)  {
    action = sList[0];
     ISP_Name = sList[1];   
     startDate = sList[2];  
     startHH = sList[3]; 
     if( startHH.equals("") ) { startHH = "00" ; }

     startMI = sList[4]; 
     if( startMI.equals("") ) { startMI = "00" ; }

     startSS = sList[5]; 
     if( startSS.equals("") ) { startSS = "00" ; }

     endDate = sList[6]; 
     endHH = sList[7]; 
     if( endHH.equals("") ) { endHH = "00" ; }

     endMI = sList[8];  
     if( endMI.equals("") ) { endMI = "00" ; }

     endSS = sList[9];  
     if( endSS.equals("") ) { endSS = "00" ; }
         
     startAccount = sList[10] ;
     // replace(char oldChar,char newChar)
     startAccount = startAccount.replace('*', '%');
     
     endAccount = sList[11] ;
     
     rowNum = sList[12] ;
     
     
     paramList = " action =\"" + action + "\" " +
                  "ISP_Name=\"" + ISP_Name + "\" " +
                  "startDate=\"" + startDate + "\" " +
                  "startHH=\"" + startHH + "\" " +
                  "startMI=\"" + startMI + "\" " +
                  "startSS=\"" + startSS  + "\" " +
                  "endDate=\"" + endDate  + "\" " +
                  "endHH=\"" + endHH + "\" " +
                  "endMI=\"" + endMI + "\" " +
                  "endSS=\"" + endSS + "\" " +
                  "startAccount=\"" + startAccount + "\" " +
                  "endAccount=\"" + endAccount + "\" " +                 
                  "rowNum=\"" + rowNum + "\" " ;
 }

  
  
/********************************************************************
* Method:   void buildQuery()
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery(){
  	 defaultSetting = false;
     String sortOrder = "";
     String space = " ";
     String colon = ":";
	// sortOrder = "a.username,to_char(v.timestamp, 'MM/DD/YY') desc, to_char(v.timestamp, 'HH24:MI:SS') desc,  t.name";
     sortOrder = "a.username, v.timestamp  desc,  t.name";
				 
     sqlcmd =  "select a.username, to_char(v.timestamp, 'MM/DD/YY'),";
     sqlcmd = sqlcmd  + "to_char(v.timestamp, 'HH24:MI:SS'), v.called_id, ";
     sqlcmd = sqlcmd  + "(v.duration -MOD(v.duration,60))/60||':'||MOD(v.duration,60), ";  
  //   sqlcmd = sqlcmd  + "round(v.duration/60,0)||':'||MOD(v.duration,60), ";  
     sqlcmd = sqlcmd  +  "t.name, round(v.amount,2)  ";
     sqlcmd = sqlcmd +"from  voip_cdr v, access_ a, ispvn i, product p," +
              "service s, service_access sa, access_type at ";
     sqlcmd = sqlcmd  +  ", tele_numplan t ";
     sqlcmd = sqlcmd + "where upper(i.name) = upper('"+ ISP_Name + "') ";


     if( ! startDate.equals("") ){
        sqlcmd = sqlcmd + "and v.timestamp  >= to_date('"
                   + startDate + space+ startHH + colon + startMI + colon + startSS 
                   + "','mm/dd/yyyy HH24:MI:SS') ";
     }
     if( ! endDate.equals("") ){
        sqlcmd = sqlcmd + " and v.timestamp   <= to_date('"
                 + endDate + space+ endHH + colon + endMI+ colon + endSS 
                 + "','mm/dd/yyyy HH24:MI:SS') ";
        //       + "','mm/dd/yyyy HH24:MI:SS') + 1 ";
     }           
 
 
      if( ! startAccount.equals("") ){   
       // sqlcmd = sqlcmd + " and a.username  >= to_number('" + startAccount +"')" ;
          sqlcmd = sqlcmd + " and a.username like '" + startAccount +"%'" ;
     }	
 /*
     if( ! startAccount.equals("") ){   
        sqlcmd = sqlcmd + " and a.username  >= to_number('" + startAccount +"')" ;
     }	
     if( ! endAccount .equals("") ){   
        sqlcmd = sqlcmd + " and a.username  < to_number('" + endAccount + "')"  ;    	
     }	 
 */ 
     if( ! rowNum.equals("") ){   
        sqlcmd = sqlcmd + " and RowNum  <= " + rowNum  ;
     }	


    
     // ////////////////////Default setting //////////////////////////////////////////
     //           If user doesn't specify  startDate, endDate, it will return the 
     //           last 20 calls.
     //////////////////////////////////////////////////////////////////////////////////
     

    if( startDate.equals("") && endDate.equals("")  )   
    {
    	        // It sets: stmt.setMaxRows(20);    	
    	  db_App.setMaxRowState(true, 20);       
        //sqlcmd = sqlcmd + " and v.timestamp  >= sysdate -1 "   ;  
 
        defaultSetting = true;
        sortOrder = "v.timestamp  desc,  t.name"; 	  
    }

     sqlcmd = sqlcmd +" and i.id = v.ispvn_id and a.account_id  = v.account_id ";
     sqlcmd = sqlcmd + "and v.service_id = s.id and s.product_id = p.id ";
     sqlcmd = sqlcmd + "and v.ispvn_id = p.ispvn_id " +
              " and v.service_id = a.service_id " + 
              " and v.service_id = sa.service_id " +
              " and sa.access_type_id = at.id " +
              " and upper(at.name) = upper('VoIP') ";


        //////////////////////////////////////////////////////////////////////////////
       // sqlcmd = sqlcmd  +  " and t.id = v.dst_tele_numplan_id ";
       //  2/27/01   Modification to include CDRs with dst_tele_numplan_id = 0 
       //              on moe:  tele_numplan_id=1818 
       //              on imsbackup:  tele_numplan_id=1714
       //
       //     sqlcmd = sqlcmd +
       //         " and t.id = decode(v.dst_tele_numplan_id,0,1714, v.dst_tele_numplan_id) ";   //
       ///////////////////////////////////////////////////////////////////////////////////////////
       
     sqlcmd = sqlcmd +
              " and t.id = decode(v.dst_tele_numplan_id,0,1818, v.dst_tele_numplan_id) ";
    	 
     sqlcmd += " order by " + sortOrder ;
   
     db_App.setMyQuery( sqlcmd );
 //    writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  executeQuery() 
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
     
      try {
         db_App.makeConnection(); 
         db_App.execute_sql(sqlcmd) ; 
         
      }  catch (Exception ex) {   
            System.out.println("Error in executeQuery:    "+ex);
      }
}


/********************************************************************
* Method:  processData() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0;
  
    try {

     noColumn = db_App.getNoColumn();

     String[] headLine = new String[noColumn];
   
     //System.out.println("noColumn = " + noColumn);
          
     headLine[0] = "Account"; 
     headLine[1] = "Date" ; 
     headLine[2] = "Time";  
     headLine[3] = "Called_no";   
     headLine[4] = "Min:Sec";  
     headLine[5] = "Destination"; 
     headLine[6] = "Charge";   

     // By defalt, put top 20 records in the vector
     if (defaultSetting ) {
         resultVector = fpWrite.getResultVector(db_App,headLine, 20); 
     }else{
           resultVector = fpWrite.getResultVector(db_App,headLine);     
     }   

    }  catch (Exception ex) {   
            System.out.println("Error in processData:    "+ex);
    }
}



/********************************************************************
* Method:  void saveFile()  
*
* Purpose:  This method writes the query result 
*           to a file.
*********************************************************************/


 private void saveFile()  { 
   try{
     fpWrite.setTitle("cdrInvoice");
     fpWrite.setParamList(paramList);

     fpWrite.setProvider(ISP_Name);

     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "cdrInvoice_" + fileCounter ;

     fpWrite.setFileName(fileName);   
    
     fpWrite.writeXMLFileV(fileName+".xml", resultVector) ;
   
     System.out.println("fileName = " + getReport() );
     System.out.println("RecordNum = " + fpWrite.getRecordNum());
 
   }  catch (Exception ex) {   
           System.out.println("Error in saveFile: "+ex);
   }

 }


}