
// Lot.java
/***************************************************************************************/
// Program Name: Lot.java
//
// 
//
// Date Written: Nov. 2000
//
// Programmer: H. Huang
//
// Purpose:  To retrieves information on    
//           the calling card lots defined within IMS.  
//           Selection Options include:                 
//           - Provider                                 
//           - Activation date range                    
//           - Expiration date range                    
//
//
// Update(s):
/**************************************************************************************/

package portal.report;
import portal.bean.*;


import java.util.*;
import java.text.*;
import java.sql.*;
import java.io.*;


public class Lot
{
   private DBApp db_App;
   protected DebugWriter writer;
   protected FilePageWriter fpWrite;

   private String action  ;
   private  String sqlcmd =  "";
   private  String ISP_Name ;
   private  String lotNo ;
   private  String actstartdate ;
   private  String actenddate ;
   private  String expstartdate ;
   private  String expenddate ;
   private  String sort ;
   private String fileName ;
   
   private String paramList ;
   private static int fileCounter=0;

   private  Vector resultSetV ;

  
/********************************************************************
* Method:   Lot()  
*
* Purpose:  Constructor
*********************************************************************/

  public Lot() {
    action = "";      
    ISP_Name= "";
    actstartdate = "" ;
    actenddate = "" ;
    expstartdate = "";
    expenddate = "";
    sort = "" ;
    fileName = "";

    fpWrite = new FilePageWriter();
    
    db_App  = new DBApp();
    writer = new DebugWriter();
  }
 

      
/********************************************************************
* Method:   void doReport(String[] sList )               
*
* Purpose:  Start getting report from here.
*********************************************************************/ 

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;  
      saveFile();
  
   }




/********************************************************************
* Method:  void getReport()  
*
* Purpose:  This method returns the fileName
*           
*********************************************************************/

 public String getReport() { 
    return ( fpWrite.getXmlDirName()  +  fileName+".xml" );
 }

     
/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList) {
    doReport(sList);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }
 
    
/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
*
*	  action = sList[0];
*     ISP_Name = sList[1]; 
*     lotNo = sList[2]; 
*     actstartdate = sList[3]; 
*     actenddate = sList[4]; 
*     expstartdate = sList[5]; 
*     expenddate = sList[6]; 
*     sort = sList[7]; 
*********************************************************************/

 public void setReportParams(String[] sList)  {
 	 action = sList[0];
     ISP_Name = sList[1];     
     lotNo = sList[2]; 
     actstartdate = sList[3]; 
     actenddate = sList[4]; 
     expstartdate = sList[5]; 
     expenddate = sList[6]; 
     sort = sList[7]; 
     
     paramList = " action =\"" + action + "\" " +
                  "ISP_Name=\"" + ISP_Name + "\" " +
                  "lotNo=\"" + lotNo + "\" " +               
                  "actstartdate =\"" + actstartdate  + "\" " +           
                  "actenddate =\"" + actenddate + "\" " +              
                  "expstartdate =\"" + expstartdate + "\" " +   
                  "expenddate =\"" + expenddate + "\" " +     
                  "sort =\"" + sort + "\" "   ;
       
 }


  
/********************************************************************
* Method:   void buildQuery(  )
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery( ){
      String sortOrder = "";

     if (sort.equals("Lot_No")){
          sortOrder = "ccl.auth_code_prefix";
     }
     else if (sort.equals("Issue_Date")) {
        sortOrder = " ccl.date_created "; 
     }

     else if (sort.equals("Cards_in_Lot")) {
        sortOrder = " ccl.number_of_calling_cards "; 
     }
     else if (sort.equals("Card_Value")) {
        sortOrder = " it.price "; 
     }
     else if (sort.equals("Exp_Date")) {
        sortOrder = " ccl.expire_date "; 
     }
     else if (sort.equals("Cards_in_Use")) {
       // sortOrder = " ccl.expire_date "; 
       sortOrder = " sum(decode(nvl(cc.active, 'N'), 'Y', 1, 0)) "; 
     }
     else if (sort.equals("CardsInUsePct")) {
       // sortOrder = " ccl.expire_date "; 
       sortOrder = " round((sum(decode(nvl(cc.active, 'N'), 'Y', 1, 0)) * 100 / decode(nvl(ccl.number_of_calling_cards, 1), 0, 1, nvl(ccl.number_of_calling_cards, 1))),2) "; 
     }    
     else {      // (sort.equals("Provider") )
        sortOrder = "i.name"; 
     }

     sqlcmd =   "select i.name,";
     sqlcmd +=  " ccl.auth_code_prefix,";
     sqlcmd +=  " ccl.date_created,";
     sqlcmd +=  " ccl.number_of_calling_cards,";
     sqlcmd +=  " it.price, ";
     sqlcmd +=  " ccl.expire_date,";
     sqlcmd +=  " sum(decode(nvl(cc.active, 'N'), 'Y', 1, 0)),";
     sqlcmd +=  " round((sum(decode(nvl(cc.active, 'N'), 'Y', 1, 0)) * 100 / ";
     sqlcmd +=  " decode(nvl(ccl.number_of_calling_cards, 1), 0, 1, nvl(ccl.number_of_calling_cards, 1))),2) lot_row ";
     sqlcmd +=  " from calling_card cc, calling_card_lot ccl, ispvn i, item it, orders o, account a ";
     sqlcmd +=  " where i.id = ccl.ispvn_id and it.id = ccl.prepaid_item ";
     sqlcmd +=  " and ccl.id = cc.lot_id  and o.account_id = ccl.account_id ";
     sqlcmd +=  " and a.id = ccl.account_id and a.order_id = o.id ";

     if( !lotNo.equals("") ){
       sqlcmd +=  " and ccl.auth_code_prefix  like '" + lotNo + "%' ";	 
     }else{
         if( ! ISP_Name.equals("ALL") ){
         sqlcmd +=  " and upper(i.name) = upper('" + ISP_Name  + "') ";	 
         }
     }
     sqlcmd +=  " and ccl.date_created  >= nvl(to_date('"+ actstartdate+"', 'mm/dd/yyyy'), ccl.date_created) ";
     sqlcmd +=  " and ccl.date_created < nvl(to_date('"+actenddate+"', 'mm/dd/yyyy'), ccl.date_created) + 1 ";
     sqlcmd +=  " and nvl(ccl.expire_date, trunc(sysdate)) >= nvl(to_date('"+expstartdate+"', 'mm/dd/yyyy'), nvl(ccl.expire_date, trunc(sysdate))) ";
     sqlcmd +=  " and nvl(ccl.expire_date, trunc(sysdate)) < nvl(to_date('"+expenddate+"', 'mm/dd/yyyy'), nvl(ccl.expire_date, trunc(sysdate))) + 1 ";
     sqlcmd +=  " group by i.name, ccl.auth_code_prefix, ccl.date_created, ccl.number_of_calling_cards, it.price, ";
     sqlcmd +=  " ccl.expire_date ";
     sqlcmd +=  " order by " + sortOrder;
 
//   sqlcmd +=  " order by i.name, ccl.auth_code_prefix, ccl.date_created; ";

     db_App.setMyQuery( sqlcmd );
 //    writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  execute_sql() 
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
   
      try {
         db_App.makeConnection(); 
         db_App.execute_sql(sqlcmd) ; 

      }  catch (Exception ex) {   
            System.out.println("Error Connection:    "+ex);
      }

}


/********************************************************************
* Method:  processData() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0; 
  
    try {

     noColumn = db_App.getNoColumn();

     String[] headLine = new String[noColumn];
    
           headLine[0] = "Provider"  ; 
           headLine[1] = "Lot_No"; 
           headLine[2] = "Issue_Date" ; 
           headLine[3] = "Cards_in_Lot" ; 
           headLine[4] = "Card_Value" ; 
           headLine[5] = "Exp_Date" ; 
           headLine[6] = "Cards_in_Use" ; 
           headLine[7] = "Cards_in_Use_Pct" ; 
   
        putResultInVector(db_App,headLine);           
        fpWrite.setResultSetV( resultSetV);


    }  catch (Exception ex) {   
            System.out.println("Error Process Data:    "+ex);
    }
}


/********************************************************************
* Method:  putResultInVector() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

private void putResultInVector(DBApp db_App, String[] fieldList)  throws Exception {

     int i, beginCol, noColumn, no;
     no = 0;
     noColumn = db_App.getNoColumn();
     resultSetV = new Vector();
     
      int totalCards_in_Lot, totalCards_in_Use ;
      double totalCardsInUsePct = 0.0 ;
      double totalCard_Value = 0.0; 
      totalCards_in_Lot = totalCards_in_Use = no =0 ;

     resultSetV.addElement(fieldList); 
  
  
     if (db_App.loadData()){        
      while (db_App.getNextRecord()){
        no++;
        String PROVIDER  = db_App.getColumn(1);
        String Lot_No = db_App.getColumn(2);
        String Issue_Date = db_App.getColumn(3);

       int Cards_in_Lot = db_App.getColumnInt(4);
       totalCards_in_Lot = totalCards_in_Lot + Cards_in_Lot ;

     
        double  Card_Value = db_App.getColumnDouble(5);
        double  Card_ValueNew = 0 ;
        if (Card_Value < 0 ){ Card_ValueNew = -Card_Value ; }
        totalCard_Value = totalCard_Value + Cards_in_Lot * Card_ValueNew ;

       String Exp_Date = db_App.getColumn(6);
  
       int Cards_in_Use = db_App.getColumnInt(7);
       totalCards_in_Use  = totalCards_in_Use  + Cards_in_Use ;

       String Cards_in_Use_Pct = db_App.getColumn(8);
       
       String[] recordS = new String[8]  ;  
       recordS[0] = new String(PROVIDER);  
 
        
       //  recordS[1] = new String(Lot_No);    It will cause problem if Lot_No==null
       recordS[1] = Lot_No;   
        
       recordS[2] = Issue_Date;   
      
       recordS[3] =  Integer.toString(Cards_in_Lot); 
       recordS[4] = Double.toString(Card_Value);
       recordS[5] = Exp_Date;   
       
       recordS[6] = Integer.toString(Cards_in_Use);   
       recordS[7] = Cards_in_Use_Pct;  
       
       resultSetV.addElement(recordS);
    

       } // end of while
     } //end of if
    
     
             
     fpWrite.setRecordNum(no);
      
     if (totalCards_in_Lot > 0) {
       totalCardsInUsePct = (double)totalCards_in_Use*100 / (double)totalCards_in_Lot;
     }
         
     /*  Format the floating point number.   */    
     NumberFormat nf = NumberFormat.getNumberInstance();
     nf.setMaximumFractionDigits(2);
     String  totalCardsInUsePctS = nf.format(totalCardsInUsePct );

     String[] recordS = 
     {"Total", "", "", Integer.toString(totalCards_in_Lot), Double.toString(-totalCard_Value), "",  Integer.toString(totalCards_in_Use), totalCardsInUsePctS}  ;
 
     resultSetV.addElement(recordS);

}


/********************************************************************
* Method:  void saveFile()  
*
* Purpose:  This method writes the query result 
*           to a file.
*********************************************************************/


 private void saveFile()  { 
   try{
     fpWrite.setTitle("Lot");
     fpWrite.setParamList(paramList);

     fpWrite.setProvider(ISP_Name);

     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "Lot_" + fileCounter ;

     fpWrite.setFileName(fileName);
    // fpWrite.writeFileV(fileName+".csv") ;
     fpWrite.writeXMLFileV(fileName+".xml") ;

   
   }  catch (Exception ex) {   
           System.out.println("Error in saveFile: "+ex);
   }

 }






}