
//  Refreshes .java
/***************************************************************************************/
// Program Name: Refreshes.java
//
// 
//
// Date Written: January, 2001
//
// Programmer: H. Huang
//
// Purpose:  To lookup "number of refreshes" data in the database 
//
//
// Update(s):
/**************************************************************************************/


package portal.report;
import portal.bean.*;

import java.sql.*;
import java.io.*;



public class Refreshes 
{
   private DBApp db_App;
   protected DebugWriter writer;
  
   protected FilePageWriter fpWrite;

   private String sqlcmd ;
   private String action  ;

   private String ISP_Name ="" ;
   private String sort ;
   private String fileName ;

   private String paramList ;
   private static int fileCounter=0;

  
/********************************************************************
* Method:   Refreshes()  
*
* Purpose:  Constructor
*********************************************************************/

  public Refreshes() {
    action = "";      
    ISP_Name= "";
    sort = "" ;
    fileName = "";

    fpWrite = new FilePageWriter();
    
    db_App  = new DBApp();
    writer = new DebugWriter();
  }



/********************************************************************
* Method:   void doReport(String[] sList )               
*
* Purpose:  Start getting report from here.
*********************************************************************/ 

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;  
      saveFile();

   }


 

/********************************************************************
* Method:  void getReport()  
*
* Purpose:  This method returns the fileName
*           
*********************************************************************/

 public String getReport() { 
    return ( fpWrite.getXmlDirName()  +  fileName+".xml" );
 }

       
/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList) {
    doReport(sList);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }
    
/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
*
*	  action = sList[0];
*     ISP_Name = sList[1];     
*     sort = sList[2];  
*********************************************************************/

 public void setReportParams(String[] sList)  {
 	 action = sList[0];
     ISP_Name = sList[1];   
     sort = sList[2];  
     
     paramList = " action =\"" + action + "\" " +
                  "ISP_Name=\"" + ISP_Name + "\" " +         
                  "sort=\"" + sort + "\" " ;   
 	        
 }



  
/********************************************************************
* Method:   void buildQuery()
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery(){

     String sortOrder = "";

     if (sort.equals("Auth_code")){
        sortOrder = " cc.auth_code ";
     }
     else if (sort.equals("Amount")) {
        sortOrder = "sum(ol.total) "; 
     }
     else if (sort.equals("Refreshes")) {
        sortOrder = "count(*) "; 
     }
     else {      // (sort.equals("Provider") )
        sortOrder = " i.name "; 
     }

    if( ISP_Name.equals("ALL") ) {
        sqlcmd =  "select i.name, cc.auth_code,count(*), sum(ol.total) "; 
     
    }else {
    	sqlcmd =  "select cc.auth_code,count(*), sum(ol.total) "; 
       
     }

  //   sqlcmd =  "select i.name, cc.auth_code,count(*), sum(ol.total) ";             
     sqlcmd += " from ispvn i, calling_card_lot ccl, access_ ac, " ; 
     sqlcmd += " calling_card cc, order_line ol, orders o ";
     sqlcmd += " where i.id = ccl.ispvn_id and ac.id = cc.batch ";
     sqlcmd += " and ol.order_id  = o.id and ccl.id  = cc.lot_id  ";
     sqlcmd += " and o.account_id  = ac.account_id ";
     sqlcmd += " /* and ol.item_id <> ccl.prepaid_item */";
     sqlcmd += " and ol.item_id < 1000000 and ol.total < 0 ";

     if( ! ISP_Name.equals("ALL") ){
          sqlcmd = sqlcmd  + " and i.name = '" + ISP_Name  +"'";
     }

     sqlcmd += " group by i.name, ac.account_id , cc.auth_code ";
     sqlcmd += " order by " + sortOrder;
    
     db_App.setMyQuery( sqlcmd );
   //  writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  executeQuery() 
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
     
      try {
         db_App.makeConnection(); 
         db_App.execute_sql(sqlcmd) ; 

      }  catch (Exception ex) {   
            System.out.println("Error Connection:    "+ex);
      }
}



/********************************************************************
* Method:  processData() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0;
  
    try {

     noColumn = db_App.getNoColumn();

//"Provider|Auth_code|Number of refreshes|Amount";

     String[] headLine = new String[noColumn];
     if( ISP_Name.equals("ALL") ){
           headLine[0] = "Provider"  ; 
           headLine[1] = "Auth_code"; 
           headLine[2] = "Number of refreshes" ; 
           headLine[3] = "Amount" ; 
      
     }else {   
     	   headLine[0] = "Auth_code"; 
           headLine[1] = "Number of refreshes" ; 
           headLine[2] = "Amount" ; 
     	       
     }

     fpWrite.putResultInVector(db_App,headLine); 

    }  catch (Exception ex) {   
            System.out.println("Error Connection:    "+ex);
    }
}


/********************************************************************
* Method:  void saveFile()  
*
* Purpose:  This method writes the query result 
*           to a file.
*********************************************************************/


 private void saveFile()  { 
   try{
     fpWrite.setTitle("Number of Refreshes");
     fpWrite.setParamList(paramList);

     fpWrite.setProvider(ISP_Name);

     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "refreshes_" + fileCounter ;

     fpWrite.setFileName(fileName);
  //   fpWrite.writeFileV(fileName+".csv") ;
     fpWrite.writeXMLFileV(fileName+".xml") ;

   
   }  catch (Exception ex) {   
            System.out.println("Error in saveFile: "+ex);
   }

 }



}