
// Termination.java
/***************************************************************************************/
// Program Name: Termination.java
//
// Copyright (c)2001 iBasis.    All rights reserved.
// Author: H. Huang
//
// Date Written: November, 2000
//
//
// Purpose:  To lookup "Top 5 Termination"
//
//
// Update(s):
//
// paramList ={ " action",
//                   "ISP_Name",
//                   "startDat",
//                   "endDate"  }
//
//  Note:  action = "View" or "Export"
//
/**************************************************************************************/

package portal.report;

import portal.bean.*;

import java.util.*;
import java.sql.*;
import java.io.*;
import java.util.Vector;


public class Termination
{
   private DBApp db_App;
   protected DebugWriter writer;
   protected FilePageWriter fpWrite;
   private String sqlcmd ;
   private String action  ;
   private String ISP_Name ="" ;
   private String startDate ;
   private String endDate  ;
   private String sort ;
   private String fileName ;

   private String paramList ;
   private static int fileCounter;
   private  Vector resultSetV ;


/********************************************************************
* Method:   Termination()
*
* Purpose:  Constructor
*********************************************************************/

  public Termination() {
    action = "";
    ISP_Name= "";
    startDate = "" ;
    endDate = "" ;
    sort = "" ;
    fileName = "";
    paramList = "";
    fileCounter = 0;
    resultSetV = null;

    db_App  = new DBApp();
    writer = new DebugWriter();
    fpWrite = new FilePageWriter();
  }

/*
   public void doGet( HttpServletRequest request,
                      HttpServletResponse response )
      throws ServletException, IOException
   {
      PrintWriter output;
      response.setContentType( "text/html" );  // content type
      output = response.getWriter();      // get writer

      getFormValues(request) ;
      buildQuery( ) ;
      executeQuery();
      processData()  ;
      saveFile();
      printPage(output );

      cleanup();
      if (output != null)
      {  output.close();  }
   }
*/


/********************************************************************
* Method:  void cleanup()
*
* Purpose:  This method does cleanup.
*           Release some resource after susing it.
*
*********************************************************************/
  private void cleanup() {
      resultSetV = null;    // After using it, clean it.
  }


/********************************************************************
* Method:  void getReport()
*
* Purpose:  This method returns the fileName
*
*********************************************************************/

 public String getReport() {
    return ( fpWrite.getXmlDirName()  +  fileName+".xml" );
 }



/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/
 public String getReport(String[] sList) {
 	  String fileL = "";
    doReport(sList);
    if(action.equals("View")){
       fileL = fpWrite.getXmlDirName()  + fileName+".xml" ;
       System.out.println("fileName = " + fileL );
     }else {        	  //(action.equals("Export") )
       fileL = fileName+".csv" ;
       System.out.println("fileName = " + fileL );
    }
     return fileL;
 }


/********************************************************************
* Method:   void doReport(String[] sList )
*
* Purpose:  Start getting report from here.
*********************************************************************/

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;
      saveFile();
      cleanup();
   }


/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
*
*	  action = sList[0];
*     startDate = sList[2];
*     endDate = sList[3];
*
*********************************************************************/

 public void setReportParams(String[] sList)  {
 	   action = sList[0];
 	   ISP_Name = sList[1];
     startDate = sList[2];
     endDate = sList[3];

     setParamList();
 }


/********************************************************************
* Method:   void setParamList()
*
* Purpose:  Set the report params header.
*
*
*********************************************************************/

 public void setParamList()  {
     paramList = " action =\"" + action + "\" " +
                 "ISP_Name=\"" + ISP_Name + "\" " +
                 "startDate=\"" + startDate + "\" " +
                 "endDate =\"" + endDate  + "\" " ;
 }



/********************************************************************
* Method:   void getFormValues(HttpServletRequest request)
*
* Purpose:  Read the Web form.
.
*********************************************************************/
/*
  public void getFormValues(HttpServletRequest request) {

     action = request.getParameter("action");
     ISP_Name = request.getParameter("ISP_Name");
     startDate = request.getParameter("startDate");
     endDate = request.getParameter("endDate");

     setParamList();
  }
*/

/********************************************************************
* Method:   void buildQuery(  )
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery( ){
     String sortOrder = "";

     sqlcmd =
        "select i.name,t.name, round(sum(v.duration/60),0) "
        + " from voip_cdr v, ispvn i, product p, service s, tele_numplan t "
        + " where i.id             = v.ispvn_id "
        + " and t.id          = v.dst_tele_numplan_id "
        + " and v.service_id    	= s.id "
        + " and s.product_id = p.id "
        + " and v.ispvn_id       = p.ispvn_id "
        + " and v.duration         > 0 "
        + " and v.disconnect_cause in (16,31) " ;

     if( ! ISP_Name.equals("ALL") ){
           sqlcmd = sqlcmd  + " and i.name = '" + ISP_Name  +"'";
     }

     if( ! startDate.equals("") ){
         sqlcmd = sqlcmd + " and v.timestamp >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') " ;
     }
     if( ! endDate.equals("") ){
          sqlcmd +=  " and v.timestamp < TO_DATE('" + endDate + "', 'MM/DD/YYYY')+1" ;
     }

     sqlcmd = sqlcmd + " group by i.name, t.name ";
     sqlcmd = sqlcmd + " order by i.name, round(sum(v.duration/60),0) DESC " ;

     db_App.setMyQuery( sqlcmd );
   //  writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  executeQuery()
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
      try {
         db_App.makeConnection();
         db_App.execute_sql(sqlcmd) ;

      }  catch (Exception ex) {
            System.out.println("Error Connection:    "+ex);
      }
}



/********************************************************************
* Method:  processData()
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0;

    try {
     noColumn = db_App.getNoColumn();
     String[] headLine = new String[noColumn];   
     headLine[0] = "Provider"  ;
     headLine[1] = "Destination" ;
     headLine[2] = "Number of Minutes";           
     putResultInVector(db_App,headLine);
    }  catch (Exception ex) {
            System.out.println("Error in processData:    "+ex);
    }
}



/********************************************************************
* Method:  putResultInVector()
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

private void putResultInVector(DBApp db_App, String[] fieldList)  throws Exception {
     int i, beginCol, noColumn, no;
     noColumn = no = 0;
     noColumn = db_App.getNoColumn();
     resultSetV = new Vector();
     resultSetV.addElement(fieldList);

     if (db_App.loadData()){
       String prePROVIDER =  "";
       int desCount  = 0;
       while (db_App.getNextRecord()){
        String PROVIDER  = db_App.getColumn(1);
        String DESTINATION = db_App.getColumn(2);
        String  TRAFFIC  = db_App.getColumn(3);
        if ( ! PROVIDER.equals(prePROVIDER) ){ desCount = 0; }
        desCount ++  ;

        if ( desCount <= 5){
           String[] recordS = new String[3]  ;
        //   recordS[0] = new String(PROVIDER);   It will cause problem if PROVIDER=null
           recordS[0] = PROVIDER;
           recordS[1] = DESTINATION;
           recordS[2] = TRAFFIC;
           resultSetV.addElement(recordS);

          no ++ ;
        }//end of if
        prePROVIDER =  PROVIDER;
       } // end of while
      } //end of if

      fpWrite.setRecordNum(no);
      db_App.takeDown();
}


/********************************************************************
* Method:  void saveFile()
*
* Purpose:  This method writes the query result
*           to a file.
*********************************************************************/

 public void saveFile()  {
   try{
     fpWrite.setTitle("Top 5 Terminations ");
     fpWrite.setParamList(paramList);
     fpWrite.setProvider(ISP_Name);
     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "top5Terminations_" + fileCounter ;
     if(action.equals("View")){
     	  fpWrite.writeXMLFileV(fileName+".xml", resultSetV) ;
     }else {   //(action.equals("Export") )
       fpWrite.writeFileV(fileName+".csv", resultSetV) ;
     }
   }  catch (Exception ex) {
            System.out.println("Error in saveFile: "+ex);
   }

 }




/********************************************************************
* Method:  void printPage(PrintWriter out)
*
* Purpose:  This method returns a page to the user
*********************************************************************/

 public void printPage(PrintWriter out)  {
   try{
      if(action.equals("View")   ){
        printView(out);
      }
      else if (action.equals("Export") )   {
         // printExport(out);
        fpWrite.printExport(out, fileName);

      }
      else {
          fpWrite.printError(out);
      }

   }catch (Exception ex) {
            System.out.println("Error Printing page: "+ex);
   }

 }



/********************************************************************
* Method:  void printView(PrintWriter out)
*
* Purpose:  This method returns a page to the user
*********************************************************************/

  public void printView(PrintWriter out)  throws Exception{
      String title = ISP_Name + " Top 5 Terminations Query Result !";
      String header, headLine , link, line, line2 ;


      link = "<a href=/servlet/ibasis.billing.Termination?action=View&ISP_Name=";
      link = link + ISP_Name + "&startDate=" + "" + "&endDate=" + "" ;
      String SortName = link + "&sort=Provider&"+" method='get' target='bottom'> ";
      String SortTraffic = link + "&sort=Traffic&"+" method='get' target='bottom'> ";
      String SortTime = link + "&sort=Date&"+" method='get' target='bottom'> ";


      if( ISP_Name.equals("ALL") ){
         header = "<tr><td><b>" + SortName + "Provider </b></td><td><b>"
                  + "Destination </b></td><td><b>"
                  + SortTime + "Month</b></td><td><b>"
                  + SortTraffic + "Number of Minutes</b></td> " ;
         headLine = "PROVIDER|Destination|Number of Minutes";
      }
      else {
         header = "<tr><td><b>" + SortTime + "MONTH</b></td><td><b>"
                  + "Destination </b></td><td><b>"
                  + SortTraffic + "Number of Minutes</b></td>";
         headLine = "Destination|Number of Minutes";

      }

      header = "<tr><td><b>" + "Provider </b></td><td><b>"
                  + "Destination </b></td><td><b>"
                  + "Number of Minutes</b></td> " ;

      headLine = "PROVIDER|Destination|Number of Minutes";

      fpWrite.setHeader( headLine);

      out.println( "<HTML><HEAD><TITLE></TITLE></HEAD><BODY bgcolor='#c0c0f0'>\n" );
      out.println("<TR><center><A target='bottom' href='/ibasis/logs/"+fileName+".csv'><H2>Export</H2></A><center></TR>");
      out.println( "<P><center><H2>" + title+ "</H2></center></P>" );
      out.println("<P><center><FONT FACE='Arial,Helvetica' SIZE=-2'>" + paramList + "</FONT></center></P>");
      out.println("<table border=1 width=100%> ");
      out.println( header);

   //   fpWrite.writePageTableV( out);
      fpWrite.writePageTableV( out, resultSetV, 1);

      out.println("</table></form></BODY></HTML>") ;
   }


}