
//  TrafficByDay.java
/***************************************************************************************/
// Program Name: TrafficByDay.java
//
// 
//
// Date Written: November, 2000
//
// Programmer: H. Huang
//
// Purpose:  To lookup rafficByDay data in the database using input
//           from the user via html.
//
//
// Update(s):  
/**************************************************************************************/

package portal.report;
import portal.bean.*;

import java.sql.*;
import java.io.*;



public class TrafficByDay
{
   private DBApp db_App;
   protected DebugWriter writer;
   protected FilePageWriter fpWrite;

   private String sqlcmd ;

   private String action  ;
   private String ISP_Name  ;
   private String startDate ;
   private String endDate  ;
   private String sort ;
   private String fileName ;
 
   private String paramList ;
   private static int fileCounter=0;


  
/********************************************************************
* Method:   TrafficByDay()  
*
* Purpose:  Constructor
*********************************************************************/

  public TrafficByDay() {
    action = "";      
    ISP_Name= "";
    startDate = "" ;
    endDate = "" ;
    sort = "" ;
    fileName = "";
    
    db_App  = new DBApp();
    writer = new DebugWriter();
    fpWrite = new FilePageWriter();
  }
 
 

      
      
/********************************************************************
* Method:   void doReport(String[] sList )               
*
* Purpose:  Start getting report from here.
*********************************************************************/ 

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;  
      saveFile();
  
   }


/********************************************************************
* Method:  void getReport()  
*
* Purpose:  This method returns the fileName
*           
*********************************************************************/

 public String getReport() { 
    return ( fpWrite.getXmlDirName()  +  fileName+".xml" );
 }

              
/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList) {
    doReport(sList);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }
    
/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
*
*	  action = sList[0];
*     ISP_Name = sList[1];   
*     startDate = sList[2];  
*     endDate = sList[3];     
*     sort = sList[4];  
*********************************************************************/

 public void setReportParams(String[] sList)  {
 	 action = sList[0];
     ISP_Name = sList[1];   
     startDate = sList[2];  
     endDate = sList[3];     
     sort = sList[4];  
     
     paramList = " action =\"" + action + "\" " +
                  "ISP_Name=\"" + ISP_Name + "\" " +
                  "startDate=\"" + startDate + "\" " +               
                  "endDate =\"" + endDate  + "\" " +           
                  "sort=\"" + sort + "\" " ;   
 }

 

  
/********************************************************************
* Method:   void buildQuery()
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery(){
     String sortOrder = "";

     if (sort.equals("Date")){
        sortOrder = "to_char(v.timestamp,'mm/dd/yyyy')";
     }
     else if (sort.equals("Traffic")) {
        sortOrder = "round(sum(v.duration/60),0)"; 
     }
     else {      // (sort.equals("Provider") )
        sortOrder = "i.name"; 
     }

    // sqlcmd =  "select i.name, to_char(v.timestamp,'mm/yyyy'), round(sum(v.duration/60),0)  " ;
    
     if( ISP_Name.equals("ALL") ) {
       sqlcmd =  "select i.name, round(sum(v.duration/60),0), to_char(v.timestamp,'mm/dd/yyyy') " ; 
   
    }else {
       sqlcmd =  "select round(sum(v.duration/60),0), to_char(v.timestamp,'mm/dd/yyyy') " ;    
       
     }

       
     sqlcmd = sqlcmd  + " from voip_cdr v, ispvn i, product p, service s  " ;
     sqlcmd = sqlcmd  +"  where i.id  = v.ispvn_id    and v.service_id  = s.id    and s.product_id = p.id  ";
     sqlcmd = sqlcmd  + " and v.ispvn_id   = p.ispvn_id  and v.duration > 0  and v.disconnect_cause in (16,31)  ";

     if( ! ISP_Name.equals("ALL") ){
           sqlcmd = sqlcmd  + " and i.name = '" + ISP_Name  +"'";
     }
     if( ! startDate.equals("") ){
           sqlcmd = sqlcmd + " and v.timestamp >= TO_DATE('" + startDate + "', 'MM/DD/YYYY') " ;
     }
     if( ! endDate.equals("") ){
         sqlcmd +=  " and v.timestamp < TO_DATE('" + endDate + "', 'MM/DD/YYYY')+1" ;
        // sqlcmd +=  " and v.timestamp < ADD_MONTHS(TO_DATE('" + endDate + "', 'MM/DD/YYYY'), 1)" ;
     }

     sqlcmd += "  group by i.name, to_char(v.timestamp,'mm/dd/yyyy') ";
     sqlcmd += " order by " + sortOrder;

  
/*
  String sqlcmd = " select i.name, to_char(v.timestamp,'mm/yyyy'),  round(sum(v.duration/60),0)  from voip_cdr v, ispvn i, product p, service s  where i.id             = v.ispvn_id  and v.service_id    	= s.id  and s.product_id = p.id  and v.ispvn_id       = p.ispvn_id and v.duration         > 0  and v.disconnect_cause in (16,31)  and i.name = '1 day billing cycle VN'  and v.timestamp >= TO_DATE('08/2000', 'MM/YYYY')    group by i.name, to_char(v.timestamp,'mm/yyyy') order by i.name,to_char(v.timestamp,'mm/yyyy')  ";
*/

     db_App.setMyQuery( sqlcmd );
  //   writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  execute_sql() 
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
     
      try {
         db_App.makeConnection(); 
         db_App.execute_sql(sqlcmd) ; 

      }  catch (Exception ex) {   
            System.out.println("Error Connection:    "+ex);
      }
}


/********************************************************************
* Method:  processData() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0;
  
    try {

     noColumn = db_App.getNoColumn();

     String[] headLine = new String[noColumn];
     if( ISP_Name.equals("ALL") ){
           headLine[0] = "Provider"  ; 
           headLine[1] = "TRAFFIC"; 
           headLine[2] = "DATE" ; 
      
     }else {          
           headLine[0] = "TRAFFIC"; 
           headLine[1] = "DATE" ; 
 
     }

     fpWrite.putResultInVector(db_App,headLine); 

    }  catch (Exception ex) {   
            System.out.println("Error in processData:    "+ex);
    }
}


/********************************************************************
* Method:  void saveFile()  
*
* Purpose:  This method writes the query result 
*           to a file.
*********************************************************************/


 private void saveFile()  { 
   try{
     fpWrite.setTitle("trafficByDay");
     fpWrite.setParamList(paramList);

     fpWrite.setProvider(ISP_Name);

     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "trafficByDay_" + fileCounter ;

     fpWrite.setFileName(fileName);
   //  fpWrite.writeFileV(fileName+".csv") ;
     fpWrite.writeXMLFileV(fileName+".xml") ;

   
   }  catch (Exception ex) {   
            System.out.println("Error in saveFile: "+ex);
   }

 }


}