
//  TrafficByMonth.java
/***************************************************************************************/
// Program Name: TrafficByMonth.java
//
// 
//
// Date Written: November, 2000
//
// Programmer: H. Huang
//
// Purpose:  To lookup rafficByMonth data in the database using input
//           from the user via html.
//
//
// Update(s):  1. H. Huang,  May,2001  
//                Add "Export" option
/**************************************************************************************/

package portal.report;
import portal.bean.*;

//package ibasis.billing;
//import ibasis.bean.*;

import java.sql.*;
import java.io.*;
//import javax.servlet.*;
//import javax.servlet.http.*;
import java.util.Vector;


//public class TrafficByMonth extends HttpServlet 
public class TrafficByMonth 
{
   private DBApp db_App;
   protected DebugWriter writer;
   protected FilePageWriter fpWrite;

   private String sqlcmd ;

   private String action  ;
   private String ISP_Name  ;
   private String startDate ;
   private String endDate  ;
   private String sort ;
   private String fileName ;
   private String paramList ;
   
   private static int fileCounter;

   private Vector resultVector ;


  
/********************************************************************
* Method:   TrafficByMonth()  
*
* Purpose:  Constructor
*********************************************************************/

  public TrafficByMonth() {
    action = "";      
    ISP_Name= "";
    startDate = "" ;
    endDate = "" ;
    sort = "" ;
    fileName = "";
    
    fileCounter = 0;
    resultVector = null;
    
    db_App  = new DBApp();
    writer = new DebugWriter();
    fpWrite = new FilePageWriter();
  }
 
  
/********************************************************************
* Method:   init()  
*
* Purpose:  
*********************************************************************/
/*
  public void init() throws ServletException {	
    db_App  = new DBApp();
    writer = new DebugWriter();
    fpWrite = new FilePageWriter();   
   }
*/

  
/********************************************************************
* Method:   doGet( HttpServletRequest request,
*                   HttpServletResponse response )
*
* Purpose:  
*********************************************************************/ 
/*
   public void doGet( HttpServletRequest request,
                      HttpServletResponse response )
      throws ServletException, IOException
   {
      PrintWriter output;
      response.setContentType( "text/html" );  // content type
      output = response.getWriter();           // get writer

      getFormValues(request) ;
      buildQuery() ;
      executeQuery();
      processData()  ;  
      saveFile();
 
      printPage(output );
      if (output != null) {  output.close();  } 

   }
*/

/********************************************************************
* Method:  void getReport()  
*
* Purpose:  This method returns the fileName
*           
*********************************************************************/

 public String getReport() { 
    return ( fpWrite.getXmlDirName()  +  fileName+".xml" );
 }

   
/********************************************************************
* Method:  void getReport(String[] sList)
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList) {
    doReport(sList);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }

/********************************************************************
* Method:  void getReport(String[] sList,  PrintWriter output )
*
* Purpose:  This method returns the file name of a report
*
*********************************************************************/

 public String getReport(String[] sList, PrintWriter output) {
    doReport(sList, output);
    return ( fpWrite.getXmlDirName()  + fileName+".xml" );
 }

/********************************************************************
* Method:   void doReport(String[] sList )
*
* Purpose:  Start getting report from here.
*********************************************************************/

   public void doReport(String[] sList )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;
      saveFile();
   }
   

/********************************************************************
* Method:   void doReport(String[] sList )
*
* Purpose:  Start getting report from here.
*********************************************************************/

   public void doReport(String[] sList, PrintWriter output )
   {
      setReportParams(sList);
      buildQuery() ;
      executeQuery();
      processData()  ;
      saveFile();
      
      printPage(output );
      if (output != null) {  output.close();  } 
   }
    
/********************************************************************
* Method:   void setReportParams()
*
* Purpose:  Set the report params.
*
*	  action = sList[0];
*     ISP_Name = sList[1];   
*     startDate = sList[2];  
*     endDate = sList[3];     
*     sort = sList[4];  
*********************************************************************/

 public void setReportParams(String[] sList)  {
 	 action = sList[0];
     ISP_Name = sList[1];   
     startDate = sList[2];  
     endDate = sList[3];     
     sort = sList[4];  
     setParamList() ;
 }

/********************************************************************
* Method:   void setParamList()
*
* Purpose:  Set the report params header.
*    
*    
*********************************************************************/

 public void setParamList()  { 
          paramList = " action =\"" + action + "\" " +
                  "ISP_Name=\"" + ISP_Name + "\" " +
                  "startDate=\"" + startDate + "\" " +               
                  "endDate =\"" + endDate  + "\" " +           
                  "sort=\"" + sort + "\" " ;  
 }

  
/********************************************************************
* Method:   void getFormValues(HttpServletRequest request)
*
* Purpose:  Read the Web form.
.
*********************************************************************/
/*
  public void getFormValues(HttpServletRequest request) {
     action = request.getParameter("action");
     ISP_Name = request.getParameter("ISP_Name");
     startDate = request.getParameter("startDate");
     endDate = request.getParameter("endDate");
     sort = request.getParameter("sort");  
     setParamList() ; 
  }            
*/
  
/********************************************************************
* Method:   void buildQuery()
*
* Purpose:  This method builds sql query.
*********************************************************************/

  private void buildQuery(){
     String sortOrder = "";

     if (sort.equals("Date")){
        sortOrder = "to_char(v.timestamp,'mm/yyyy')";
     }
     else if (sort.equals("Traffic")) {
        sortOrder = "round(sum(v.duration/60),0)"; 
     }
     else {      // (sort.equals("Provider") )
        sortOrder = "i.name"; 
     }

    // sqlcmd =  "select i.name, to_char(v.timestamp,'mm/yyyy'), round(sum(v.duration/60),0)  " ;
    
     if( ISP_Name.equals("ALL") ) {
       sqlcmd =  "select i.name, round(sum(v.duration/60),0), to_char(v.timestamp,'mm/yyyy') " ; 
   
    }else {
       sqlcmd =  "select round(sum(v.duration/60),0), to_char(v.timestamp,'mm/yyyy') " ;    
       
     }

       
     sqlcmd = sqlcmd  + " from voip_cdr v, ispvn i, product p, service s  " ;
     sqlcmd = sqlcmd  +"  where i.id  = v.ispvn_id    and v.service_id  = s.id    and s.product_id = p.id  ";
     sqlcmd = sqlcmd  + " and v.ispvn_id   = p.ispvn_id  and v.duration > 0  and v.disconnect_cause in (16,31)  ";

     if( ! ISP_Name.equals("ALL") ){
           sqlcmd = sqlcmd  + " and i.name = '" + ISP_Name  +"'";
     }
     if( ! startDate.equals("") ){
           sqlcmd = sqlcmd + " and v.timestamp >= TO_DATE('" + startDate + "', 'MM/YYYY') " ;
     }
     if( ! endDate.equals("") ){
      
         sqlcmd +=  " and v.timestamp < ADD_MONTHS(TO_DATE('" + endDate + "', 'MM/YYYY'), 1)" ;
     }

     sqlcmd += "  group by i.name, to_char(v.timestamp,'mm/yyyy') ";
     sqlcmd += " order by " + sortOrder;

  
/*
  String sqlcmd = " select i.name, to_char(v.timestamp,'mm/yyyy'),  round(sum(v.duration/60),0)  from voip_cdr v, ispvn i, product p, service s  where i.id             = v.ispvn_id  and v.service_id    	= s.id  and s.product_id = p.id  and v.ispvn_id       = p.ispvn_id and v.duration         > 0  and v.disconnect_cause in (16,31)  and i.name = '1 day billing cycle VN'  and v.timestamp >= TO_DATE('08/2000', 'MM/YYYY')    group by i.name, to_char(v.timestamp,'mm/yyyy') order by i.name,to_char(v.timestamp,'mm/yyyy')  ";
*/

     db_App.setMyQuery( sqlcmd );
  //   writer.writeDebug(sqlcmd);
     System.out.println(sqlcmd);

  }



/********************************************************************
* Method:  execute_sql() 
*
* Purpose:  execute sql query
*********************************************************************/

private void executeQuery(){
     
      try {
         db_App.makeConnection(); 
         db_App.execute_sql(sqlcmd) ; 

      }  catch (Exception ex) {   
            System.out.println("Error Connection:    "+ex);
      }
}


/********************************************************************
* Method:  processData() 
*
* Purpose:  Put the query result into a vector.
*********************************************************************/

  private void processData()  {
    int  noColumn = 0;
  
    try {

     noColumn = db_App.getNoColumn();

     String[] headLine = new String[noColumn];
     if( ISP_Name.equals("ALL") ){
           headLine[0] = "Provider"  ; 
           headLine[1] = "TRAFFIC"; 
           headLine[2] = "DATE" ; 
      
     }else {          
           headLine[0] = "TRAFFIC"; 
           headLine[1] = "DATE" ; 
 
     }

       resultVector = fpWrite.getResultVector(db_App,headLine);

    }  catch (Exception ex) {   
            System.out.println("Error in processData:    "+ex);
    }
}


/********************************************************************
* Method:  void saveFile()  
*
* Purpose:  This method writes the query result 
*           to a file.
*********************************************************************/


 private void saveFile()  { 
   try{
     fpWrite.setTitle("trafficByMonth");
     fpWrite.setParamList(paramList);

     fpWrite.setProvider(ISP_Name);

     fileCounter++;
     if(fileCounter > 100) fileCounter = 1;
     fileName = "trafficByMonth_" + fileCounter ;

     fpWrite.setFileName(fileName);
     fpWrite.writeFileV(fileName+".csv", resultVector) ;
   //  fpWrite.writeXMLFileV(fileName+".xml", resultVector) ;

   }  catch (Exception ex) {   
            System.out.println("Error in saveFile: "+ex);
   }

 }


 
/********************************************************************
* Method:  void printPage(PrintWriter out)  
*
* Purpose:  This method returns a page to the user
*********************************************************************/

 public void printPage(PrintWriter out)  { 
   try{
   
      if(action.equals("View")   ){     
        printView(out);   
      }else if (action.equals("Export") )   {        
        //  printExport(out);    
        fpWrite.printExport(out, fileName);  
      }
      else {        
          fpWrite.printError(out);    
      }

  
   }catch (Exception ex) {   
            System.out.println("Error Printing page: "+ex);
   }

 }



/********************************************************************
* Method:  void printExport(PrintWriter out)  
*
* Purpose:  This method returns a page to the user
*********************************************************************/
/*
  public void printExport(PrintWriter out)  throws Exception{ 
     int recordNum =  fpWrite.getRecordNum();
     String title = "Click on Export to continue!";
  
     out.println( "<HTML><HEAD><TITLE></TITLE></HEAD><BODY bgcolor='#c0c0f0'>\n" );
   
     out.println("<P><center><font face=geneva,arial size=-1>The total records = " 
                + recordNum + "</font></center></P>");
 
     if(recordNum == 0){
        out.println( "<P><center><H2> The file contains no data. </H2></center></P>");
     }	
     else{
       out.println( "<P><center><H2>" + title+ "</H2></center></P>" );
       out.println("<P><center><A target='bottom' href='/ibasis/logs/"+fileName+".csv'><H2>Export</H2></A><center></P>");     
     }
     out.println( "</BODY></HTML>" );
     out.close();    // close PrintWriter stream
  }
  */



/********************************************************************
* Method:  void printView(PrintWriter out)  
*
* Purpose:  This method returns a page to the user
*********************************************************************/

    public void printView(PrintWriter out)  throws Exception{ 
      String title = ISP_Name+ " TrafficByMonth Query Result!";
      String header, link, line, line2, linkSortName, linkSortTime,linkSortTraffic;

      out.println( "<HTML><HEAD><TITLE></TITLE></HEAD><BODY bgcolor='#c0c0f0'>\n" );
      out.println("<TR><center><A target='bottom' href='/ibasis/logs/"+fileName+".csv'><H2>Export</H2></A><center></TR>");
              
      out.println( "<P><center><H2>" + title+ "</H2></center></P>" );
      out.println("<P><center><FONT FACE='Arial,Helvetica' SIZE=-2'>" + paramList + "</FONT></center></P>");

   //   out.println("<table border=1 width=100%> ");
      out.println("<table border=1 width=400> ");       

      link = "<a href=/servlet/ibasis.billing.TrafficByMonth?action=View&ISP_Name=";
      link = link + ISP_Name + "&startDate=" + startDate + "&endDate=" + endDate ;
      linkSortName = link + "&sort=Provider&"+" method='get' target='bottom'> ";
      linkSortTraffic = link + "&sort=Traffic&"+" method='get' target='bottom'> ";
      linkSortTime = link + "&sort=Date&"+" method='get' target='bottom'> ";

      if( ! ISP_Name.equals("ALL") ){
         header = "<td align=center><b>"+ linkSortTraffic +" Number of Minutes" +"</b></a></td>"
                  +"<td align=center><b>"+ linkSortTime +" Date</b></a></td> ";
      }
      else {
         header = "<tr><td align=center><b>"+linkSortName +" Provider</b></a></td>" +
                  "<td align=center><b>"+linkSortTraffic+" Number of Minutes </b></a></td>"
                  +"<td align=center><b>"+linkSortTime+" Date</b></a></td> ";
      }
      out.println( header);
    
    // fpWrite.setHeader( headLine);
     fpWrite.writePageTableV( out, resultVector, 1);  //Param 1: print from vector index 1

     out.println( "</table></form></BODY></HTML>" );
  
    // out.close();    // close PrintWriter stream
   }
   
}