package portal.servletbeans;

import java.util.Vector;

import portal.bean.*;
import portal.invoice.*;
import portal.base.*;
import portal.report.*;
import Node;
import Document;
import Element;
import NodeList;


public class invoiceRequestHandler {


	public void getInvoicesByIsp(Document inDoc, Document outDoc) {

			/* Signature:-->
					Vector getInvoicesByIsp(String _pIspvn, String _pStartDate,
					                        String _pEndDate);
			*/

			Vector _resultVector;
			int _totalInvoices ;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();


			String _ispvnId = inRoot.getAttribute("IspvnId");
			String _startDate = inRoot.getAttribute("StartDate");
			String _endDate = inRoot.getAttribute("EndDate");

			invoiceBean _oInvoiceBean = new invoiceBean();
			_resultVector = _oInvoiceBean.getInvoicesByIsp(_ispvnId,_startDate,_endDate);


			_totalInvoices = _resultVector.size();

			for(int i = 0; i < _totalInvoices; i++)
				{	String[] invoiceAttr = (String[])(_resultVector.elementAt(i));
					Element te = outDoc.createElement("InvoiceByIsp");
					outRoot.appendChild(te);
					te.setAttribute("Id", invoiceAttr[0]);
					te.setAttribute("TransType", invoiceAttr[1]);
					te.setAttribute("AccountId", invoiceAttr[2]);
					te.setAttribute("IspvnId", invoiceAttr[3]);
					te.setAttribute("Amount", invoiceAttr[4]);
					te.setAttribute("Note", invoiceAttr[5]);
					te.setAttribute("Status", invoiceAttr[6]);
					te.setAttribute("ReferenceId", invoiceAttr[7]);
					te.setAttribute("Operator", invoiceAttr[8]);
					te.setAttribute("Description", invoiceAttr[9]);
					te.setAttribute("CcType", invoiceAttr[10]);
					te.setAttribute("TimeStamp", invoiceAttr[11]);
					te.setAttribute("CheckNo", invoiceAttr[12]);
				}
		}


		public void getInvoicesByAccounts(Document inDoc, Document outDoc, boolean _pByRange) {

			/* Signature:-->
					Vector getInvoicesByAccounts(String[] _pAccounts, String _pStartDate,
														  String _pEndDate);
					Vector getInvoicesByAccounts(String _pStartAccount, String _pEndAccount,
														  String _pStartDate, String _pEndDate);
			*/

			Vector _resultVector;
			int _totalInvoices ;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();

			String _startDate = inRoot.getAttribute("StartDate");
			String _endDate = inRoot.getAttribute("EndDate");

			if (_pByRange == false) {
					NodeList _nList = ((Node)inRoot).getChildNodes();
					int _noOfActs =  _nList.getLength();

					String[] _accIds = new String[_noOfActs];

					for(int i=0; i < _noOfActs; i++)
						_accIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

					invoiceBean _oInvoiceBean = new invoiceBean();
					_resultVector = _oInvoiceBean.getInvoicesByAccounts(_accIds, _startDate, _endDate);
			 }
			 else
				{
					String _startAccId = inRoot.getAttribute("StartAccountId");
					String _endAccId = inRoot.getAttribute("EndAccountId");
					invoiceBean _oInvoiceBean = new invoiceBean();
					_resultVector = _oInvoiceBean.getInvoicesByAccounts(_startAccId,_endAccId,_startDate, _endDate);
				}

			_totalInvoices = _resultVector.size();

			for(int i = 0; i < _totalInvoices; i++)
				{	String[] actAttr = (String[])(_resultVector.elementAt(i));
					Element te = outDoc.createElement("InvoiceByAccounts");
					outRoot.appendChild(te);
					te.setAttribute("Id", actAttr[0]);
					te.setAttribute("TransType", actAttr[1]);
					te.setAttribute("AccountId", actAttr[2]);
					te.setAttribute("IspvnId", actAttr[3]);
					te.setAttribute("Amount", actAttr[4]);
					te.setAttribute("Note", actAttr[5]);
					te.setAttribute("Status", actAttr[6]);
					te.setAttribute("ReferenceId", actAttr[7]);
					te.setAttribute("Operator", actAttr[8]);
					te.setAttribute("Description", actAttr[9]);
					te.setAttribute("CcType", actAttr[10]);
					te.setAttribute("TimeStamp", actAttr[11]);
					te.setAttribute("CheckNo", actAttr[12]);
				}
		}


			// This returns the details of the given Invoice number from Orders (Order_Line/Order_Item_Details
			// table..) which we need to figure out.
			public void getInvoiceDetail(Document inDoc, Document outDoc) {

				/* public Vector getInvoiceDetail(String _pInvoiceID); */

					Vector _resultVector;
					int _totalInvoices ;

					Element inRoot  = inDoc.getDocumentElement();
					Element outRoot = outDoc.getDocumentElement();


					String _invoiceId = inRoot.getAttribute("InvoiceId");

					invoiceBean _oInvoiceBean = new invoiceBean();
					_resultVector = _oInvoiceBean.getInvoiceDetail(_invoiceId);

					_totalInvoices = _resultVector.size();

					for(int i = 0; i < _totalInvoices; i++)
						{	String[] invoiceAttr = (String[])(_resultVector.elementAt(i));
							Element te = outDoc.createElement("InvoiceDetail");
							outRoot.appendChild(te);
							te.setAttribute("Id", invoiceAttr[0]);
							te.setAttribute("TransType", invoiceAttr[1]);
							te.setAttribute("AccountId", invoiceAttr[2]);
							te.setAttribute("IspvnId", invoiceAttr[3]);
							te.setAttribute("Amount", invoiceAttr[4]);
							te.setAttribute("Note", invoiceAttr[5]);
							te.setAttribute("Status", invoiceAttr[6]);
							te.setAttribute("ReferenceId", invoiceAttr[7]);
							te.setAttribute("Operator", invoiceAttr[8]);
							te.setAttribute("Description", invoiceAttr[9]);
							te.setAttribute("CcType", invoiceAttr[10]);
							te.setAttribute("TimeStamp", invoiceAttr[11]);
							te.setAttribute("CheckNo", invoiceAttr[12]);
							te.setAttribute("BillStarted", invoiceAttr[13]);
							te.setAttribute("BillEnded", invoiceAttr[14]);
							te.setAttribute("BillGenerated", invoiceAttr[15]);
							te.setAttribute("Vat_Tax", invoiceAttr[16]);
							te.setAttribute("Sum_Total", invoiceAttr[17]);
						}
				}
}
