package portal.servletbeans;

import java.util.Vector;

import portal.bean.*;
import portal.paymentadjustment.*;
import portal.base.*;
import portal.report.*;
import Node;
import Document;
import Element;
import NodeList;

public class paRequestHandler {


			public void getAccountAdjustments(Document inDoc, Document outDoc, boolean _pByRange) {

				/* Signature:-->
				  getAccountAdjustments(String[] accountId, String startDate, String endDate);
				  getAccountAdjustmentsRange(String startAccId, String endAccId, String startDate,
	                                      String endDate);
				*/
					Vector _resultVector;
					int _totalAccounts ;

					Element inRoot  = inDoc.getDocumentElement();
					Element outRoot = outDoc.getDocumentElement();


					String _startDate = inRoot.getAttribute("StartDate");
					String _endDate = inRoot.getAttribute("EndDate");

					if (_pByRange == false) {
							NodeList _nList = ((Node)inRoot).getChildNodes();
							int _noOfAccts =  _nList.getLength();

							String[] _acctIds = new String[_noOfAccts];

							for(int i=0; i < _noOfAccts; i++)
								//_acctIds[i] = (String) _nList.item(i).getNodeValue();
								_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

							paBean _oPaBean = new paBean();
							_resultVector = _oPaBean.getAccountAdjustments(_acctIds,_startDate,_endDate);
					 }
					 else
						{
							String _startAccId = inRoot.getAttribute("StartAccountId");
							String _endAccId = inRoot.getAttribute("EndAccountId");
							paBean _oPaBean = new paBean();
							_resultVector = _oPaBean.getAccountAdjustmentsRange(_startAccId,_endAccId,_startDate, _endDate);
					}
					_totalAccounts = _resultVector.size();

					/* "SELECT id, trans_type, account_id, ispvn_id, amount, note,  reference_id," +
											" operator, description, cc_type, timestamp,  check_no " +
									" FROM  transaction " ;
					*/

					for(int i = 0; i < _totalAccounts; i++)
						{	String[] actAttr = (String[])(_resultVector.elementAt(i));
							Element te = outDoc.createElement("AccReceipts");
							outRoot.appendChild(te);
							te.setAttribute("Id", actAttr[0]);
							te.setAttribute("AccountId", actAttr[2]);
							te.setAttribute("TimeStamp", actAttr[10]);
							te.setAttribute("Amount", actAttr[4]);
							te.setAttribute("IspvnId", actAttr[3]);
							te.setAttribute("Note", actAttr[5]);
							te.setAttribute("ReferenceId", actAttr[6]);
							te.setAttribute("Operator", actAttr[7]);
							te.setAttribute("Description", actAttr[8]);
							te.setAttribute("CcType", actAttr[9]);
							te.setAttribute("CheckNo", actAttr[11]);
							//Text txVal = outDoc.createTextNode(actAttr[keyIndex]);
							//te.appendChild(txVal);
						}
				}


			public void getPaActivities(Document inDoc, Document outDoc, boolean _pByRange) {
				/* Signature:-->
				  Vector getPaActivities(String[] accountId, String startDate, String endDate);
				  Vector getPaActivitiesRange(String startAccId, String endAccId, String startDate, String endDate);
				*/
					Vector _resultVector;
					int _totalAccounts ;

					Element inRoot  = inDoc.getDocumentElement();
					Element outRoot = outDoc.getDocumentElement();


					String _startDate = inRoot.getAttribute("StartDate");
					String _endDate = inRoot.getAttribute("EndDate");

					if (_pByRange == false) {
							NodeList _nList = ((Node)inRoot).getChildNodes();
							int _noOfAccts =  _nList.getLength();

							String[] _acctIds = new String[_noOfAccts];

							for(int i=0; i < _noOfAccts; i++)
								//_acctIds[i] = (String) _nList.item(i).getNodeValue();
								_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

							paBean _oPaBean = new paBean();
							_resultVector = _oPaBean.getPaActivities(_acctIds,_startDate,_endDate);
					 }
					 else
						{
							String _startAccId = inRoot.getAttribute("StartAccountId");
							String _endAccId = inRoot.getAttribute("EndAccountId");
							paBean _oPaBean = new paBean();
							_resultVector = _oPaBean.getAccountReceiptsRange(_startAccId,_endAccId,_startDate, _endDate);
					}
					_totalAccounts = _resultVector.size();

					/* sqlcmd = "SELECT id, trans_type, account_id, ispvn_id, amount, note,  reference_id," +
					            " operator, description, cc_type, to_char(TIMESTAMP,'dd-MON-yyyy') timestamp,  check_no " +
						    " FROM  transaction " ;
					*/

					for(int i = 0; i < _totalAccounts; i++)
						{	String[] actAttr = (String[])(_resultVector.elementAt(i));
							Element te = outDoc.createElement("AccReceipts");
							outRoot.appendChild(te);
							te.setAttribute("Id", actAttr[0]);
							te.setAttribute("TransType", actAttr[1]);
							te.setAttribute("AccountId", actAttr[2]);
							te.setAttribute("IspvnId", actAttr[3]);
							te.setAttribute("Amount", actAttr[4]);
							te.setAttribute("Note", actAttr[5]);
							te.setAttribute("ReferenceId", actAttr[6]);
							te.setAttribute("Operator", actAttr[7]);
							te.setAttribute("Description", actAttr[8]);
							te.setAttribute("CcType", actAttr[9]);
							te.setAttribute("TimeStamp", actAttr[10]);
							te.setAttribute("CheckNo", actAttr[11]);
						}

			}


		public void getAccountReceipts(Document inDoc, Document outDoc, boolean _pByRange) {
			/* Signature:-->
			  Vector getAccountReceipts(String[] accountId, String startDate, String endDate);
			  Vector getAccountReceiptsRange(String startAccId, String endAccId,
			  								 String startDate, String endDate);
			*/
				Vector _resultVector;
				int _totalAccounts ;

				Element inRoot  = inDoc.getDocumentElement();
				Element outRoot = outDoc.getDocumentElement();


				String _startDate = inRoot.getAttribute("StartDate");
				String _endDate = inRoot.getAttribute("EndDate");

				if (_pByRange == false) {
						NodeList _nList = ((Node)inRoot).getChildNodes();
						int _noOfAccts =  _nList.getLength();

						String[] _acctIds = new String[_noOfAccts];

						for(int i=0; i < _noOfAccts; i++)
							//_acctIds[i] = (String) _nList.item(i).getNodeValue();
							_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

						paBean _oPaBean = new paBean();
						_resultVector = _oPaBean.getAccountReceipts(_acctIds,_startDate,_endDate);
				 }
				 else
					{
						String _startAccId = inRoot.getAttribute("StartAccountId");
						String _endAccId = inRoot.getAttribute("EndAccountId");
						paBean _oPaBean = new paBean();
						_resultVector = _oPaBean.getAccountReceiptsRange(_startAccId,_endAccId,_startDate, _endDate);
				}
				_totalAccounts = _resultVector.size();

				/* "SELECT id, trans_type, account_id, ispvn_id, amount, note,  reference_id," +
										" operator, description, cc_type, timestamp,  check_no " +
								" FROM  transaction " ;
				*/

				for(int i = 0; i < _totalAccounts; i++)
					{	String[] actAttr = (String[])(_resultVector.elementAt(i));
						Element te = outDoc.createElement("AccReceipts");
						outRoot.appendChild(te);
						te.setAttribute("Id", actAttr[0]);
						te.setAttribute("AccountId", actAttr[2]);
						te.setAttribute("TimeStamp", actAttr[10]);
						te.setAttribute("Amount", actAttr[4]);
						te.setAttribute("IspvnId", actAttr[3]);
						te.setAttribute("Note", actAttr[5]);
						te.setAttribute("ReferenceId", actAttr[6]);
						te.setAttribute("Operator", actAttr[7]);
						te.setAttribute("Description", actAttr[8]);
						te.setAttribute("CcType", actAttr[9]);
						te.setAttribute("CheckNo", actAttr[11]);
						//Text txVal = outDoc.createTextNode(actAttr[keyIndex]);
						//te.appendChild(txVal);
					}

		}

			public void getIspvnReceipts(Document inDoc, Document outDoc) {

				Vector _resultVector;
				int _totalAccounts ;

				Element inRoot  = inDoc.getDocumentElement();
				Element outRoot = outDoc.getDocumentElement();


				String _startDate = inRoot.getAttribute("StartDate");
				String _endDate = inRoot.getAttribute("EndDate");


				//NodeList _nList = inRoot.getElementsByTagName("IspvnId");
				NodeList _nList = ((Node)inRoot).getChildNodes();
				int _noOfAccts =  _nList.getLength();

				String[] _acctIds = new String[_noOfAccts];

				for(int i=0; i < _noOfAccts; i++)
					_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

				/* Signature:-->
					Vector getIspvnReceipts(String[] _pIspvnId, String _pStartDate,
										  String _pEndDate)
				*/

				paBean _oPaBean = new paBean();
				_resultVector = _oPaBean.getIspvnReceipts(_acctIds,_startDate,_endDate);


				_totalAccounts = _resultVector.size();

				for(int i = 0; i < _totalAccounts; i++)
					{	String[] actAttr = (String[])(_resultVector.elementAt(i));
						Element te = outDoc.createElement("IspReceipts");
						outRoot.appendChild(te);
						te.setAttribute("Id", actAttr[0]);
						te.setAttribute("AccountId", actAttr[1]);
						te.setAttribute("IspvnId", actAttr[2]);
						te.setAttribute("Amount", actAttr[3]);
						te.setAttribute("Note", actAttr[4]);
						te.setAttribute("ReferenceId", actAttr[5]);
						te.setAttribute("Operator", actAttr[6]);
						te.setAttribute("Description", actAttr[7]);
						te.setAttribute("CcType", actAttr[8]);
						te.setAttribute("TimeStamp", actAttr[9]);
						te.setAttribute("CheckNo", actAttr[10]);
						//Text txVal = outDoc.createTextNode(actAttr[keyIndex]);
						//te.appendChild(txVal);
					}
		}

		public void getAccountActivities(Document inDoc, Document outDoc, boolean _pByRange) {

			/* Signature:-->
				Vector getAccountActivities(String[] accountId, String transType,
											String startDate, String endDate);
				Vector getAccountActivitiesRange(String startAccId, String endAccId,
									String transType, String startDate, String endDate);
			*/

			Vector _resultVector;
			int _totalAccounts ;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();


			String _transType = inRoot.getAttribute("TransType");
			String _startDate = inRoot.getAttribute("StartDate");
			String _endDate = inRoot.getAttribute("EndDate");

			if (_pByRange == false) {
					//NodeList _nList = inRoot.getElementsByTagName("AccountId");
					NodeList _nList = ((Node)inRoot).getChildNodes();
					int _noOfAccts =  _nList.getLength();

					String[] _acctIds = new String[_noOfAccts];

					for(int i=0; i < _noOfAccts; i++)
						//_acctIds[i] = (String) _nList.item(i).getNodeValue();
						_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

					paBean _oPaBean = new paBean();
					_resultVector = _oPaBean.getAccountActivities(_acctIds,_transType,_startDate,_endDate);
			 }
			 else
				{
					String _startAccId = inRoot.getAttribute("StartAccountId");
					String _endAccId = inRoot.getAttribute("EndAccountId");
					paBean _oPaBean = new paBean();
					_resultVector = _oPaBean.getAccountActivitiesRange(_startAccId,_endAccId,_transType,_startDate, _endDate);
				}

			_totalAccounts = _resultVector.size();

			for(int i = 0; i < _totalAccounts; i++)
				{	String[] actAttr = (String[])(_resultVector.elementAt(i));
					Element te = outDoc.createElement("AActivity");
					outRoot.appendChild(te);
					te.setAttribute("Id", actAttr[0]);
					te.setAttribute("TransType", actAttr[1]);
					te.setAttribute("AccountId", actAttr[2]);
					te.setAttribute("IspvnId", actAttr[3]);
					te.setAttribute("Amount", actAttr[4]);
					te.setAttribute("Note", actAttr[5]);
					te.setAttribute("Status", actAttr[6]);
					te.setAttribute("ReferenceId", actAttr[7]);
					te.setAttribute("Operator", actAttr[8]);
					te.setAttribute("Description", actAttr[9]);
					te.setAttribute("CcType", actAttr[10]);
					te.setAttribute("TimeStamp", actAttr[11]);
					te.setAttribute("CheckNo", actAttr[12]);
					//Text txVal = outDoc.createTextNode(actAttr[keyIndex]);
					//te.appendChild(txVal);
				}
		}

		public void getIspvnActivities(Document inDoc, Document outDoc) {

			Vector _resultVector;
			int _totalAccounts ;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();


			String _transType = inRoot.getAttribute("TransType");
			String _startDate = inRoot.getAttribute("StartDate");
			String _endDate = inRoot.getAttribute("EndDate");


			//NodeList _nList = inRoot.getElementsByTagName("AccountId");
			NodeList _nList = ((Node)inRoot).getChildNodes();
			int _noOfAccts =  _nList.getLength();

			String[] _acctIds = new String[_noOfAccts];

			for(int i=0; i < _noOfAccts; i++)
				//_acctIds[i] = (String) _nList.item(i).getNodeValue();
				_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

			/* Signature:-->
					Vector getIspvnActivities(String[] ispvnId, String transType,
					                          String startDate, String endDate);
			*/

			paBean _oPaBean = new paBean();
			_resultVector = _oPaBean.getIspvnActivities(_acctIds,_transType,_startDate,_endDate);

			_totalAccounts = _resultVector.size();

			for(int i = 0; i < _totalAccounts; i++)
				{	String[] actAttr = (String[])(_resultVector.elementAt(i));
					Element te = outDoc.createElement("AActivity");
					outRoot.appendChild(te);
					te.setAttribute("Id", actAttr[0]);
					te.setAttribute("TransType", actAttr[1]);
					te.setAttribute("AccountId", actAttr[2]);
					te.setAttribute("IspvnId", actAttr[3]);
					te.setAttribute("Amount", actAttr[4]);
					te.setAttribute("Note", actAttr[5]);
					te.setAttribute("Status", actAttr[6]);
					te.setAttribute("ReferenceId", actAttr[7]);
					te.setAttribute("Operator", actAttr[8]);
					te.setAttribute("Description", actAttr[9]);
					te.setAttribute("CcType", actAttr[10]);
					te.setAttribute("TimeStamp", actAttr[11]);
					te.setAttribute("CheckNo", actAttr[12]);
				}
		}


		private BillingTransaction setTransValues(String _pId, String _pTransType, String _pAccId,
		          String _pIspId, String _pAmt, String _pNote, String _pStatus, String _pOptr,
		          String _pRef, String _pDesc, String _pCcType, String _pCheckNo, String _pCrType,
		          String _pTransTerms, String _pCcNum, String _pCcExpMonth,String _pCcExpYear,
		          String _pCheckDate,  String _pCheckBank) {

			BillingTransaction _oTrans = new BillingTransaction();
			try {
				_oTrans.setTransId(_pId);
				_oTrans.setTransType(_pTransType);
				_oTrans.setAccount(_pAccId);
				_oTrans.setIspvn(_pIspId);
				_oTrans.setAmount(_pAmt);
				_oTrans.setNote(_pNote);
				_oTrans.setStatus(_pStatus);
				_oTrans.setOperator(_pOptr);
				_oTrans.setReference(_pRef);
				_oTrans.setDescription(_pDesc);
				_oTrans.setCCType(_pCcType);
				_oTrans.setCheckNo(_pCheckNo);
				_oTrans.setCreditType(_pCrType);
				_oTrans.setTransTerms(_pTransTerms);
				_oTrans.setCcNum(_pCcNum);
				_oTrans.setExpMonth(_pCcExpMonth);
				_oTrans.setExpYear(_pCcExpYear);
				_oTrans.setCheckDate(_pCheckDate);
				_oTrans.setCheckBank(_pCheckBank);
			}
			catch(Exception ex) {
				System.out.println("Exception while setting transaction values" + ex);
			  }

			return _oTrans;
		}


		public void makePayment(Document inDoc, Document outDoc) {
			// this gets activities from the AccountInfoBean

			BillingTransaction _oTrans = new BillingTransaction();
			paBean _oPaBean;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();

			//String _id = inRoot.getAttribute("ID");
			String _accountId = inRoot.getAttribute("AccountId");
			String _ispvnId = inRoot.getAttribute("IspvnId");
			String _amount = inRoot.getAttribute("Amount");
			String _note = inRoot.getAttribute("Note");
			String _referenceId = inRoot.getAttribute("ReferenceId");
			String _operator = inRoot.getAttribute("Operator");
			String _description = inRoot.getAttribute("Description");
			String _ccType = inRoot.getAttribute("CcType");
			String _checkNo = inRoot.getAttribute("CheckNo");
			String _transTerms =inRoot.getAttribute("TransTerms");
			String _ccNum =	inRoot.getAttribute("CcNum");
			String _ccExpMonth = inRoot.getAttribute("ExpMonth");
			String _ccExpYear = inRoot.getAttribute("ExpYear");
			String _checkDate =	inRoot.getAttribute("CheckDate");
			String _checkBank =	inRoot.getAttribute("CheckBank");

			/*setTransValues(_pId, _pTransType, _pAccId, _pIspId, _pAmt, _pNote,
					_pStatus, _pOptr, _pRef, _pDesc, _pCcType, _pCheckNo, _pCrType,
		          	_pTransTerms, _pCcNum, _pCcExpMonth,_pCcExpYear,_pCheckDate,
		          	_pCheckBank)     */

			   _oTrans = setTransValues("","",_accountId,_ispvnId,_amount,_note,
				"",_operator,"",_description,_ccType,_checkNo,"",_transTerms,_ccNum,
				_ccExpMonth,_ccExpYear,_checkDate,_checkBank);

			  _oPaBean = new paBean();

			  //Signature:---> String makePayment(BillingTransaction _pTransObj)
			  String _result = _oPaBean.makePayment(_oTrans);

			  Element te = outDoc.createElement("MakePayment");
			  outRoot.appendChild(te);
			  te.setAttribute("Id", _result);
		}

		public void makeAdjustment(Document inDoc, Document outDoc) {

			BillingTransaction _oTrans = new BillingTransaction();
			paBean _oPaBean;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();

			String _accountId = inRoot.getAttribute("AccountId");
			String _ispvnId = inRoot.getAttribute("IspvnId");
			String _amount = inRoot.getAttribute("Amount");
			String _note = inRoot.getAttribute("Note");
			String _referenceId = inRoot.getAttribute("ReferenceId");
			String _operator = inRoot.getAttribute("Operator");
			String _description = inRoot.getAttribute("Description");
			String _ccType = inRoot.getAttribute("CcType");
			String _checkNo = inRoot.getAttribute("CheckNo");
			String _transTerms =inRoot.getAttribute("TransTerms");
			String _ccNum =	inRoot.getAttribute("CcNum");
			String _ccExpMonth = inRoot.getAttribute("ExpMonth");
			String _ccExpYear = inRoot.getAttribute("ExpYear");
			String _checkDate =	inRoot.getAttribute("CheckDate");
			String _checkBank =	inRoot.getAttribute("CheckBank");



		/*setTransValues(_pId, _pTransType, _pAccId, _pIspId, _pAmt, _pNote,
					_pStatus, _pOptr, _pRef, _pDesc, _pCcType, _pCheckNo, _pCrType,
		          	_pTransTerms, _pCcNum, _pCcExpMonth,_pCcExpYear,_pCheckDate,
		          	_pCheckBank)     */

			   _oTrans = setTransValues("","",_accountId,_ispvnId,_amount,_note,
				"",_operator,"",_description,_ccType,_checkNo,"",_transTerms,_ccNum,
				_ccExpMonth,_ccExpYear,_checkDate,_checkBank);

			  _oPaBean = new paBean();

			  //Signature:---> String makeAdjustment(BillingTransaction _pTransObj)

			  String _result = _oPaBean.makeAdjustment(_oTrans);

			  Element te = outDoc.createElement("MakeAdjustment");

			  outRoot.appendChild(te);
			  te.setAttribute("Id", _result);
		}

		public void cancelTransaction(Document inDoc, Document outDoc) {

			paBean _oPaBean;

			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();

			String _transId = inRoot.getAttribute("TransId");
			String _transType = inRoot.getAttribute("TransType");
			String _operator = inRoot.getAttribute("OperatorId");

			/* Signature:  String cancelTransaction(String _pTransId, String _pTransType,
										            String _pOperatorId);
			*/

			 _oPaBean = new paBean();
			String _result = _oPaBean.cancelTransaction(_transId,_transType,_operator);

			Element te = outDoc.createElement("CancelTransaction");

			outRoot.appendChild(te);
			te.setAttribute("Id", _result);
		}

		public void getTransactionDetails(Document inDoc, Document outDoc) {

				BillingTransaction _oTrans;
				paBean _oPaBean;

				Element inRoot  = inDoc.getDocumentElement();
				Element outRoot = outDoc.getDocumentElement();

				String _transId = inRoot.getAttribute("TransId");

				_oPaBean = new paBean();

			   // Signature:  BillingTransaction  getTransactionDetails(String _pTransId);

				_oTrans = _oPaBean.getTransactionDetails(_transId);

	            Element te = outDoc.createElement("TransDetails");
				outRoot.appendChild(te);
			    te.setAttribute("TransType", _oTrans.getTransType());
			    te.setAttribute("AccountId", _oTrans.getAccount());
			    te.setAttribute("IspvnId", _oTrans.getIspvn());
			    te.setAttribute("Amount", _oTrans.getAmount());
			    te.setAttribute("Note", _oTrans.getNote());
			    te.setAttribute("Status", _oTrans.getStatus());
			    te.setAttribute("Operator", _oTrans.getOperator());
			    te.setAttribute("ReferenceId", _oTrans.getReference());
			    te.setAttribute("Description", _oTrans.getDescription());
			    te.setAttribute("CcType", _oTrans.getCCType());
			    te.setAttribute("TimeStamp", _oTrans.getTimeStamp());
			    te.setAttribute("CheckNo", _oTrans.getCheckNo());
				te.setAttribute("TransTerms", _oTrans.getTransTerms());
			    te.setAttribute("CcNum", _oTrans.getCcNum());
				te.setAttribute("CcExpMonth", _oTrans.getExpMonth());
				te.setAttribute("CcExpYear", _oTrans.getExpYear());
				te.setAttribute("CheckDate", _oTrans.getCheckDate());
				te.setAttribute("CheckBank", _oTrans.getCheckBank());
			    te.setAttribute("Balance", _oTrans.getBalance());
		}


			public void getBalance(Document inDoc, Document outDoc, boolean _pByRange) {

				Vector _resultVector;
				int _totalAccounts ;

				Element inRoot  = inDoc.getDocumentElement();
				Element outRoot = outDoc.getDocumentElement();

				if (_pByRange == false) {
					//NodeList _nList = inRoot.getElementsByTagName("AccountId");
					NodeList _nList = ((Node)inRoot).getChildNodes();

					int _noOfAccts =  _nList.getLength();

					String[] _acctIds = new String[_noOfAccts];

					for(int i=0; i < _noOfAccts; i++)
						//_acctIds[i] = (String) _nList.item(i).getNodeValue();
						_acctIds[i] = (String) ((Element)(_nList.item(i))).getAttribute("ID");

					/* Signature:-->
					 Vector getBalance(String[] accountId);
					*/

					paBean _oPaBean = new paBean();
					_resultVector = _oPaBean.getBalance(_acctIds);
				  }
				else
				  {
						String _startAccId = inRoot.getAttribute("StartAccountId");
						String _endAccId = inRoot.getAttribute("EndAccountId");

						/* Signature:-->
						 Vector getBalanceRange(String startAccId, String endAccId);
						*/

						paBean _oPaBean = new paBean();
						_resultVector = _oPaBean.getBalanceRange(_startAccId,_endAccId);
				  }
						_totalAccounts = _resultVector.size();

				for(int i = 0; i < _totalAccounts; i++)
					{	String[] actAttr = (String[])(_resultVector.elementAt(i));
						Element te = outDoc.createElement("AccReceipts");
						outRoot.appendChild(te);
						te.setAttribute("AccId", actAttr[0]);
						te.setAttribute("OrderId", actAttr[1]);
						te.setAttribute("Amount", actAttr[2]);
						te.setAttribute("SaveInvDet", actAttr[3]);
					}

		}

	}
