/*
 * @(#)BillingPortalServlet.java	1.5 1.5
 * Copyright (c) iBasis Inc.
*/

import java.io.*;
import javax.servlet.*;
import java.util.Vector;

import portal.bean.*;
import portal.base.*;
import portal.report.*;
import portal.servletbeans.*;


public class BillingPortalServlet extends GenericServlet
{
	//static int tCount=0;

	public void service(ServletRequest req, ServletResponse res)
							  throws ServletException, java.io.IOException
	{
		//create XML Parser
		XMLParser parser = new XMLParser();
		Document  inDoc,  outDoc=null;  //parser.createDocument("Response");
		Element   inRoot, outRoot;
		paRequestHandler _reqHandler;
		invoiceRequestHandler invHandler;

		//references to servlet streams
		InputStream  sIn;
		OutputStream sOut;

		//create encrypted streams
		EncryptedInputStream  encIn  = new EncryptedInputStream();
		EncryptedOutputStream encOut = new EncryptedOutputStream();

		//Get the output stream
		ServletOutputStream outs = res.getOutputStream();
		res.setContentType("text/html");	//set it to avoid over-intruding proxy servers
		//res.setContentType("application/x-billing");
		encOut.setOutputStream(outs);
		sOut = outs;

		if(req.getContentType() == null)	//Get Request: probably from heartbeat
		{	outs.println("OK Dear");
			return;
		}

		//if(!req.getContentType().equals("application/x-billing"))	//dubious client
		//{ out.close(); return; }

		ServletInputStream ins = req.getInputStream();
		encIn.setInputStream(ins);
		sIn = ins;

		//parse the xml-input
		inDoc  = parser.parseStream(sIn);
		inRoot = inDoc.getDocumentElement();

		//close input stream
		sIn.close();
		System.out.println("Input Data: \n"+parser.getXML(inDoc));


		int reqID = Integer.parseInt(inRoot.getAttribute("ID"));

		//int reqID = ReqDef.LOGIN;

		switch(reqID)
		{

			case ReqDef.LOGIN:	//the only case where an html is returned
				StringBuffer tBuf = new StringBuffer();
				String UserId    = inRoot.getAttribute("UserId");
				String Password  = inRoot.getAttribute("Password");
				//System.out.println("UserID: "+UserId+"  Password: "+Password);
				int groupID = 0, operatorID = 0;
				Vector ispList=null;
				try {
					UserAuthentication tAuth = new UserAuthentication();
					groupID = tAuth.authenticate(UserId, Password);
					operatorID = tAuth.getOperatorID();
					ispList = tAuth.getISPVN_ID_NameList(groupID);
				} catch (Exception e) { }
				//Hack by Ash to avoid login-------*/
				//groupID=1;
				//ispList = new Vector();
				//ispList.addElement(new String[]{"1", "Mimos"});
				if(groupID < 1)
				{	//System.out.println("User Not Found");
					tBuf.append("NOT_FOUND");
					sOut.write((tBuf.toString()).getBytes());
					sOut.close();
					return;
				}
				tBuf.append("OK");
				tBuf.append("<HTML><HEAD><script>\n");
				tBuf.append(" operatorID="+operatorID+";\n userID='';\n");
				tBuf.append(" pwd='';\n tURL = '';\n ispIDList = [");
				int tLen = ispList.size();
				for(int i=0; i < tLen; i++)
					if(i > 0) tBuf.append(",\"").append(((String[])(ispList.elementAt(i)))[0]).append('\"');
					else tBuf.append('\"').append(((String[])(ispList.elementAt(i)))[0]).append('\"');
				tBuf.append(" ];\n ispNameList = [");
				for(int i=0; i < tLen; i++)
					if(i > 0) tBuf.append(",\"").append(((String[])(ispList.elementAt(i)))[1]).append('\"');
					else tBuf.append('\"').append(((String[])(ispList.elementAt(i)))[1]).append('\"');
				tBuf.append(" ];\n function getOperatorID() { return operatorID; }\n");
				tBuf.append(" function setURL(u) { tURL=u; }\n");
				tBuf.append(" function getURL() { return tURL; }\n");
				tBuf.append(" function setUserID(Id) { userID=Id; }\n");
				tBuf.append(" function getUserID() { return userID; }\n");
				tBuf.append(" function setPassword(Pw) { pwd=Pw; }\n");
				tBuf.append(" function getPassword() { return pwd; }\n");
				tBuf.append("</script></HEAD><BODY bgcolor=gray></BODY></HTML>");
				sOut.write((tBuf.toString()).getBytes());
				sOut.close();
				return;

			case ReqDef.ACCOUNTLISTC:
				//outDoc = parser.parseFile("D:/Jws/servlets/AccountList.xml");
				outDoc = parser.createDocument("AccountList");
				getAccountListC(inDoc, outDoc);
				break;

			case ReqDef.BILLINGREPORT:
				int ReportID  = Integer.parseInt(inRoot.getAttribute("ReportID"));
				NodeList pList   = inRoot.getChildNodes();
				String[] rParams = new String[64];	//max params
				int i=0;
				while(true)	//build param list
				{	Node pNode = pList.item(i);
					if(pNode == null) break;
					rParams[i] = ((Element)pNode).getAttribute("Val");
					i++;
				}
				switch (ReportID)
				{
					case 0:	//Traffic by Month
					TrafficByMonth tRep0 = new TrafficByMonth();
					outDoc = parser.parseFile(tRep0.getReport(rParams));
					break;

					case 1:	//Traffic by Day
					TrafficByDay tRep1 = new TrafficByDay();
					outDoc = parser.parseFile(tRep1.getReport(rParams));
					break;

					case 2:	//Traffic by Hour
					TrafficByHour tRep2 = new TrafficByHour();
					outDoc = parser.parseFile(tRep2.getReport(rParams));
					break;

					case 3:	// Lot
					Lot tRep3 = new Lot();
					outDoc = parser.parseFile(tRep3.getReport(rParams));
					break;

					case 4:	//All CDRs
					Allcdrs tRep4 = new Allcdrs();
					outDoc = parser.parseFile(tRep4.getReport(rParams));
					break;

					case 5:	//Top 5 Terminations
					Termination tRep5 = new Termination();
					outDoc = parser.parseFile(tRep5.getReport(rParams));
					break;

					case 6:	// No of Refreshes
					Refreshes tRep6 = new Refreshes();
					outDoc = parser.parseFile(tRep6.getReport(rParams));
					break;

					case 7:	//Denied Service
					Denied tRep7 = new Denied();
					outDoc = parser.parseFile(tRep7.getReport(rParams));
					break;

					case 8:	//Num of Denied Service
					DeniedNum tRep8 = new DeniedNum();
					outDoc = parser.parseFile(tRep8.getReport(rParams));
					break;

					case 9: //Revenue
					Revenue tRep9 = new Revenue();
					outDoc = parser.parseFile(tRep9.getReport(rParams));
					break;

					case 10:	//Revenue Destination Summary
					RevenueDestination tRep10 = new RevenueDestination();
					outDoc = parser.parseFile(tRep10.getReport(rParams));
					break;

					case 11:	//Caling Card Usage
					CardUtilization tRep11 = new CardUtilization();
					outDoc = parser.parseFile(tRep11.getReport(rParams));
					break;
				}
				break;


			case ReqDef.INVOICESBYACCOUNTS:
				outDoc = parser.createDocument("Response");
				invHandler = new invoiceRequestHandler();  // get the request handler
				invHandler.getInvoicesByAccounts(inDoc, outDoc, false);
				break;

			case ReqDef.ACCOUNTACTIVITIES:
			   // transaction activities for given account(s)
				outDoc = parser.createDocument("Response");
				_reqHandler = new paRequestHandler();  // get the request handler
				_reqHandler.getAccountActivities(inDoc, outDoc, false);
				break;

			case  ReqDef.ACCOUNTACTIVITIESBYRANGE:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountActivities(inDoc, outDoc, true);
					break;

			case  ReqDef.ISPVNACTIVITIES:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getIspvnActivities(inDoc, outDoc);
					break;

			case  ReqDef.MAKEPAYMENT:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.makePayment(inDoc, outDoc);
					Element te = outDoc.createElement("MakePayment");
					outDoc.getDocumentElement().appendChild(te);
			  		te.setAttribute("Id", "1405211");
					break;

			case  ReqDef.CANCELTRANSACTION:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.cancelTransaction(inDoc, outDoc);
					break;

			case  ReqDef.TRANSACTIONDETAILS:
					 outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getTransactionDetails(inDoc, outDoc);
					break;

			case  ReqDef.ISPVNRECEIPTS:
					 outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getIspvnReceipts(inDoc, outDoc);
					break;

			case  ReqDef.ACCOUNTRECEIPTS:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountReceipts(inDoc, outDoc, false);
					//outDoc = parser.parseFile("D:/Jws/servlets/AccountActivities.xml");
					break;

			case  ReqDef.ACCOUNTRECEIPTSRANGE :
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountReceipts(inDoc, outDoc, true);
					break;

			case  ReqDef.BALANCE:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getBalance(inDoc, outDoc, false);
					break;

			case  ReqDef.BALANCERANGE:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getBalance(inDoc, outDoc, true);
					break;

			case  ReqDef.MAKEADJUSTMENT:
					outDoc = parser.createDocument("Response");
					 _reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.makeAdjustment(inDoc, outDoc);
					break;

			case  ReqDef.PAACTIVITIES:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getPaActivities(inDoc, outDoc,false);
					//outDoc = parser.parseFile("D:/Jws/servlets/AccountActivities.xml");
					break;

			case  ReqDef.PAACTIVITIESBYRANGE:
					outDoc = parser.createDocument("Response");
					 _reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getPaActivities(inDoc, outDoc,true);
					break;

			case  ReqDef.ACCOUNTADJUSTMENTS:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountAdjustments(inDoc, outDoc,false);
					//outDoc = parser.parseFile("D:/Jws/servlets/AccountActivities.xml");
					break;

			case  ReqDef.ACCOUNTADJUSTMENTSBYRANGE:
					outDoc = parser.createDocument("Response");
					 _reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountAdjustments(inDoc, outDoc,true);
					break;

		}

		//System.out.println("Output Doc: \n"+parser.getXML(outDoc));
		parser.outputXML(outDoc, sOut);
		sOut.close();
	}

	//This method gets the accounts based on a criteria
	private void getAccountListC(Document inDoc, Document outDoc)
	{
		AccountInfo acBean = new AccountInfoBean();
		Element inRoot  = inDoc.getDocumentElement();
		Element outRoot = outDoc.getDocumentElement();

		String Criteria = inRoot.getAttribute("Criteria");
		int sortId = Integer.parseInt(inRoot.getAttribute("SortId"));
		outRoot.setAttribute("SortId", ""+sortId);
		Vector vOutput = acBean.getAccountlistbyCriteria(Criteria);
		int totalAccounts = vOutput.size();
		for(int i = 0; i < totalAccounts; i++)
		{	String[] actAttr = (String[])(vOutput.elementAt(i));
			Element te = outDoc.createElement("Account");
			outRoot.appendChild(te);
			te.setAttribute("ID", actAttr[0]);
			te.setAttribute("FName", actAttr[1]);
			te.setAttribute("LName", actAttr[2]);
			te.setAttribute("Company", actAttr[3]);
			te.setAttribute("Prepaid", actAttr[7]);
			te.setAttribute("Balance", actAttr[8]);
		}
	}

}
