/*
 * @(#)BillingPortalServlet.java	1.5 1.5
 * Copyright (c) iBasis Inc.
*/

import java.io.*;
import javax.servlet.*;
import java.util.Vector;

import portal.bean.*;
import portal.base.*;
import portal.report.*;
import portal.servletbeans.*;


public class BillingPortalServlet extends GenericServlet
{
	//static int tCount=0;

	public void service(ServletRequest req, ServletResponse res)
							  throws ServletException, java.io.IOException
	{
		//create XML Parser
		XMLParser parser = new XMLParser();
		Document  inDoc,  outDoc=null;  //parser.createDocument("Response");
		Element   inRoot, outRoot;
		paRequestHandler _reqHandler;

		//references to servlet streams
		InputStream  sIn;
		OutputStream sOut;

		//create encrypted streams
		EncryptedInputStream  encIn  = new EncryptedInputStream();
		EncryptedOutputStream encOut = new EncryptedOutputStream();

		//Get the output stream
		ServletOutputStream outs = res.getOutputStream();
		res.setContentType("text/html");	//set it to avoid over-intruding proxy servers
		//res.setContentType("application/x-billing");
		encOut.setOutputStream(outs);
		sOut = outs;

		if(req.getContentType() == null)	//Get Request: probably from heartbeat
		{	outs.println("OK Dear");
			return;
		}

		//if(!req.getContentType().equals("application/x-billing"))	//dubious client
		//{ out.close(); return; }

		ServletInputStream ins = req.getInputStream();
		encIn.setInputStream(ins);
		sIn = ins;

		//parse the xml-input
		inDoc  = parser.parseStream(sIn);
		inRoot = inDoc.getDocumentElement();

		//close input stream
		sIn.close();
		System.out.println("Input Data: \n"+parser.getXML(inDoc));


		int reqID = Integer.parseInt(inRoot.getAttribute("ID"));

		//int reqID = ReqDef.LOGIN;

		switch(reqID)
		{

			case ReqDef.LOGIN:	//the only case where an html is returned
				StringBuffer tBuf = new StringBuffer();
				String UserId    = inRoot.getAttribute("UserId");
				String Password  = inRoot.getAttribute("Password");
				//System.out.println("UserID: "+UserId+"  Password: "+Password);
				if(!(UserId.equals("ims") && Password.equals("ims")))
				{
					//System.out.println("User Not Found");
					tBuf.append("NOT_FOUND");
					sOut.write((tBuf.toString()).getBytes());
					sOut.close();
					return;
				}
				String[] ispIDList   = { "1", "10", "9" };	//login success
				String[] ispNameList = { "Balinet", "Himtel", "Mimos" };
				tBuf.append("OK");
				tBuf.append("<HTML><HEAD><script>ispIDList = [");
				int tLen = ispIDList.length;
				for(int i=0; i < tLen; i++)
					if(i > 0) tBuf.append(",\"").append(ispIDList[i]).append('\"');
					else tBuf.append('\"').append(ispIDList[i]).append('\"');
				tBuf.append("];\nispNameList = [");
				for(int i=0; i < tLen; i++)
					if(i > 0) tBuf.append(",\"").append(ispNameList[i]).append('\"');
					else tBuf.append('\"').append(ispNameList[i]).append('\"');
				tBuf.append("];\n");
				tBuf.append("tURL = ''; \nfunction setURL(u) { tURL=u; }\n");
				tBuf.append("function getURL() { return tURL; }\n");
				tBuf.append("</script></HEAD><BODY bgcolor=gray></BODY></HTML>");
				sOut.write((tBuf.toString()).getBytes());
				sOut.close();
				return;

			case ReqDef.ACCOUNTLISTC:
				outDoc = parser.parseFile("D:/Jws/servlets/AccountList.xml");
				//outDoc = parser.createDocument("AccountList");
				//getAccountList(inDoc, outDoc);
				break;

		/*	case ReqDef.TRAFFICBYMONTH:
				TrafficByMonth tRep = new TrafficByMonth();
				String ispName    = inRoot.getAttribute("IspName");
				String startDate  = inRoot.getAttribute("StartDate");
				String endDate = inRoot.getAttribute("EndDate");
				String sort = inRoot.getAttribute("Sort");
				String[] repParam = new String[5];
				repParam[1] = ispName;
				repParam[2] = startDate;
				repParam[3] = endDate;
				repParam[4] = sort;

				outDoc = parser.parseFile(tRep.getReport(repParam));
				//System.out.println("Done Parsing: \n"+parser.getXML(d));
				break; */

			case ReqDef.ACCOUNTACTIVITIES:

			   // transaction activities for given account(s)
				outDoc = parser.createDocument("Response");
				_reqHandler = new paRequestHandler();  // get the request handler
				_reqHandler.getAccountActivities(inDoc, outDoc, false);
				break;

			case  ReqDef.ACCOUNTACTIVITIESBYRANGE:

					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountActivities(inDoc, outDoc, true);
					break;

			case  ReqDef.ISPVNACTIVITIES:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getIspvnActivities(inDoc, outDoc);
					break;

			case  ReqDef.MAKEPAYMENT:

					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.makePayment(inDoc, outDoc);
					Element te = outDoc.createElement("MakePayment");
					outDoc.getDocumentElement().appendChild(te);
			  		te.setAttribute("Id", "1405211");
					break;

			case  ReqDef.CANCELTRANSACTION:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.cancelTransaction(inDoc, outDoc);
					break;

			case  ReqDef.TRANSACTIONDETAILS:

					 outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getTransactionDetails(inDoc, outDoc);
					break;

			case  ReqDef.ISPVNRECEIPTS:

					 outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getIspvnReceipts(inDoc, outDoc);
					break;

			case  ReqDef.ACCOUNTRECEIPTS:

					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountReceipts(inDoc, outDoc, false);
					outDoc = parser.parseFile("D:/Jws/servlets/AccountActivities.xml");
					break;

			case  ReqDef.ACCOUNTRECEIPTSRANGE :

					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountReceipts(inDoc, outDoc, true);
					break;

			case  ReqDef.BALANCE:

					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getBalance(inDoc, outDoc, false);
					break;

			case  ReqDef.BALANCERANGE:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getBalance(inDoc, outDoc, true);
					break;

			case  ReqDef.MAKEADJUSTMENT:
					outDoc = parser.createDocument("Response");
					 _reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.makeAdjustment(inDoc, outDoc);
					break;

			case  ReqDef.PAACTIVITIES:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getPaActivities(inDoc, outDoc,false);
					outDoc = parser.parseFile("D:/Jws/servlets/AccountActivities.xml");
					break;

			case  ReqDef.PAACTIVITIESBYRANGE:
					outDoc = parser.createDocument("Response");
					 _reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getPaActivities(inDoc, outDoc,true);
					break;

			case  ReqDef.ACCOUNTADJUSTMENTS:
					outDoc = parser.createDocument("Response");
					_reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountAdjustments(inDoc, outDoc,false);
					//outDoc = parser.parseFile("D:/Jws/servlets/AccountActivities.xml");
					break;

			case  ReqDef.ACCOUNTADJUSTMENTSBYRANGE:
					outDoc = parser.createDocument("Response");
					 _reqHandler = new paRequestHandler();  // get the request handler
					_reqHandler.getAccountAdjustments(inDoc, outDoc,true);
					break;

		}

		//System.out.println("Output Doc: \n"+parser.getXML(outDoc));
		parser.outputXML(outDoc, sOut);
		sOut.close();
	}


		private void getAccountList(Document inDoc, Document outDoc) {

			AccountInfo acBean = new AccountInfoBean();
			//outDoc = parser.createDocument("AccountList");
			Element inRoot  = inDoc.getDocumentElement();
			Element outRoot = outDoc.getDocumentElement();

			String Criteria = inRoot.getAttribute("Criteria");
			int sortId = Integer.parseInt(inRoot.getAttribute("SortId"));
			int keyIndex, attrIndex1, attrIndex2;
			String attrName1, attrName2;

			if (sortId == 0) // by id
			{	outRoot.setAttribute("SortBy", "Id");
				attrName1 = "FirstName";  attrName2 = "LastName";
				keyIndex=0; attrIndex1=1; attrIndex2=2;
			}
			else if (sortId == 1) // by FirstName
			{	outRoot.setAttribute("SortBy", "FirstName");
				attrName1 = "ID";  attrName2 = "LastName";
				keyIndex=1; attrIndex1=0; attrIndex2=2;
			}
			else //if (sortId == 2) // by LastName
			{	outRoot.setAttribute("SortBy", "LastName");
				attrName1 = "ID";  attrName2 = "FirstName";
				keyIndex=2; attrIndex1=0; attrIndex2=1;
			}

			Vector vOutput = acBean.getAccountlistbyCriteria(Criteria);
			int totalAccounts = vOutput.size();
			for(int i = 0; i < totalAccounts; i++)
			{	String[] actAttr = (String[])(vOutput.elementAt(i));
				Element te = outDoc.createElement("Account");
				outRoot.appendChild(te);
				te.setAttribute(attrName1, actAttr[attrIndex1]);
				te.setAttribute(attrName2, actAttr[attrIndex2]);
	         	Text txVal = outDoc.createTextNode(actAttr[keyIndex]);
				te.appendChild(txVal);
			}
		}


}
