import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Vector;

public class AdjustmentsApp extends Panel implements AppModule, ActionListener, ItemListener, HttpListener
{
	private Color appBtnColor  = new Color(228, 228, 228);
	private Color actvTableColor = new Color(228, 228, 228);

	Panel  appPanel = new Panel();
	XLayout xLayout = new XLayout(appPanel);
	//Results Table
	XGrid actvTable;

	private Document actvDoc=null;

	//payment form Components
	Label appTitleLb, appText1Lb, appText2Lb;
	Label cCodeLb, cCodeValLb, cNameLb, cNameValLb, cTypeLb, cTypeValLb, cBalLb, cBalValLb;
	Label periodLb, sDateLb, eDateLb, pDateLb, pAmtLb, adjTypeLb, descLb, remarkLb;
	TextField sDateTx, eDateTx, pDateTx, pAmtTx, adjTypeTx, descTx, remarkTx;
	Choice periodList, adjTypeList, descCodeList;
	Checkbox accMultiple = new Checkbox("Multiple Accounts");
	Button appBtn;

	//Form Components Array
	Component[] appComponent;

	//Current Module Otpion
	String cAPPOption = "";

	static final int APPBTN    = 99;

	static final int itemStartIndex = 100;	//marks the begining of form Items
	static final int TITLE     = 100;
	static final int TEXT1     = 101;
	static final int TEXT2     = 102;
	static final int ACTVTABLE = 103;
	static final int ACCMULTI     = 104;
	//static final int CCODEVAL  = 105;
	//static final int CNAME     = 106;
	//static final int CNAMEVAL  = 107;
	//static final int CTYPE     = 108;
	//static final int CTYPEVAL  = 109;
	//static final int CBAL      = 110;
	//static final int CBALVAL   = 111;

	static final int labeledItemStartIndex = 112;	//marks the begining of labeled Items
	static final int PERIOD    = 112;
	static final int SDATE     = 114;
	static final int EDATE     = 116;
	static final int PDATE     = 118;
	static final int AMOUNT    = 120;
	static final int ADJTYPE   = 122;
	static final int DESC      = 124;
	static final int REMARK    = 126;

	private static final String[] appOptions = { "Search", "New Adjustment" };

	private static final String[] appButtons = { "Get Adjustments", "OK", "Cancel", "Export",
																"Print", "E-mail" };
	private static final String[] appText    = { "Customer Adjustments", "New Adjustment",
																"Customer Re-Invoices" };
	private static final int[][][] appForms =
	{
		{ // 0 - Search
			{ TITLE, 0, 180 },
			{ XLayout.VGAP, 20 },
			{ XLayout.INDENT, 70 },
			{ XLayout.ROWDEF, 24, 0, 0, 30, 4 },
			{ XLayout.COLDEF, 240, 215 },
			{ XLayout.LDEF, 110, 95 },
			{ PERIOD, ACCMULTI },
			{ SDATE, EDATE },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 0 },
			{ XLayout.COLDEF, 110, 120 },
			{ XLayout.SKIPCOL },
			{ APPBTN, 0 }

		},
		{ // 1 - Search Adjustment Results
			{ TEXT1, 0, 250 },
			{ XLayout.VGAP, 20 },
			{ XLayout.ROWDEF, 180, 0, 0, 0, 0 },
			{ XLayout.COLDEF, 550 },
			{ ACTVTABLE },
			{ XLayout.ROWDEF, 15 },
			{ XLayout.SKIPROW },
			{ XLayout.ROWDEF, 24, 0, 0, 4, 2 },
			{ XLayout.COLDEF, 120, 120, 120 },
			{ APPBTN, 3 },
			{ APPBTN, 4 }
		},
		{ // 2 - New Adjustment
			{ TITLE, 1, 180 },
			{ XLayout.VGAP, 20 },
			{ XLayout.INDENT, 70 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 200 },
			{ XLayout.LDEF, 110, },
			{ AMOUNT, ADJTYPE, DESC  },
			{ XLayout.COLDEF, 400 },
			{ XLayout.LDEF, 110, },
			{ REMARK },
			{ XLayout.ROWDEF, 24, 0, 0, 5, 0 },
			{ XLayout.COLDEF, 110, 120 },
			{ XLayout.VGAP, 5 },
			{ APPBTN, 1 },
			{ APPBTN, 2 }
		},
		{ // 3 - New Adjustment Result
			{ TEXT1, 1, 250 },
			{ XLayout.VGAP, 20 },
			{ XLayout.ROWDEF, 180, 0, 0, 0, 0 },
			{ XLayout.COLDEF, 550 },
			{ ACTVTABLE },
			{ XLayout.ROWDEF, 15 },
			{ XLayout.SKIPROW },
			{ XLayout.ROWDEF, 24, 0, 0, 4, 2 },
			{ XLayout.COLDEF, 120, 120, 120 },
			{ APPBTN, 5 },
			{ APPBTN, 6 },
			{ APPBTN, 7 }
		}
	};


	public AdjustmentsApp()
	{
		this.setLayout(null);
		this.setBounds(AppConfig.ClientIndent, AppConfig.ModuleTop, AppConfig.ClientWidth, AppConfig.TotalHeight);
		this.setBackground(AppConfig.Color_Client);

		int btnTop = 32;
		int btnWidth = 150, btnHeight = 24;
		for(int i=0; i < appOptions.length; i++)
		{
		XButton	btn1 = new XButton(appOptions[i]);
		btn1.setBounds(20+(btnWidth+5)*i, btnTop, btnWidth, btnHeight);
		btn1.setColor(appBtnColor);
		btn1.addActionListener(this);
		btn1.setActionCommand(appOptions[i]);
		this.add(btn1);
		}

		//add appPanel
		appPanel.setBounds(20, AppConfig.DividerTop+15, AppConfig.ClientWidth, 400);
		appPanel.setBackground(AppConfig.Color_Client);
		this.add(appPanel);

		/*actvTable = new XTable();
		actvTable.setBackground(AppConfig.Color_ModuleTitleBar);
		actvTable.setForeground(actvTableColor);
		actvTable.setBounds(20, 40, 500, 200);
		//actvTable.setHeaderWidth(new int[] { 50, 100, 150, 150 });
		//actvTable.setHeaderText(new String[] { "Type", "Trn ID", "Trn Date", "Amount" });
		actvTable.setVisible(false);
		appPanel.add(actvTable);*/

		actvTable = new XGrid();
		actvTable.setBounds(20, AppConfig.DividerTop+40, 500, 200);
		actvTable.setContentBackground(AppConfig.Color_ModuleTitleBar);
		actvTable.setContentForeground(actvTableColor);
		//actvTable.setDataFont(AppConfig.Font_B12);
		actvTable.setPageSize(7);
		actvTable.displayPageTabs(true);
		actvTable.setColumns(new int[]{50, 100, 150, 150});
		actvTable.setHeader(new String[]{ "Type", "Trn ID", "Trn Date", "Amount" });
		actvTable.setColProperty(0, XGrid.PROP_TEXTCOLOR, Color.red);
		actvTable.setColProperty(0, XGrid.PROP_TEXTFONT, AppConfig.Font_B12);
		actvTable.setColProperty(0, XGrid.PROP_DATALINK, "Y");
		actvTable.setLinkListener(this, "LINK_SELECTED");
		actvTable.setVisible(false);
		appPanel.add(actvTable);

		//define gui elements for various payment options
		defineFormElements();
	}

	void defineFormElements()
	{
		appTitleLb = new Label();
		appTitleLb.setFont(AppConfig.Font_ModuleTitle);
		appTitleLb.setBackground(AppConfig.Color_ModuleTitleBar);

		appText1Lb = new Label();
		appText1Lb.setFont(AppConfig.Font_ModuleTitle);
		appText1Lb.setBackground(AppConfig.Color_ModuleTitleBar);
		appText2Lb = new Label();
		appText2Lb.setFont(AppConfig.Font_B12);
		appText2Lb.setForeground(Color.gray);
		//appText2Lb.setBackground(AppConfig.Color_ModuleTitleBar);

		periodLb = new Label("Period : ");
		periodLb.setFont(AppConfig.Font_12);

		sDateLb = new Label("From (mm/dd/yyyy): ");
		sDateLb.setFont(AppConfig.Font_12);
		eDateLb = new Label("To (mm/dd/yyyy): ");
		eDateLb.setFont(AppConfig.Font_12);

		cCodeLb = new Label("Customer Code:");
		cCodeLb.setFont(AppConfig.Font_B12);
		cCodeLb.setBackground(actvTableColor);
		cCodeValLb = new Label("1121");
		cCodeValLb.setFont(AppConfig.Font_B12);
		cCodeValLb.setBackground(actvTableColor);
		cCodeValLb.setForeground(Color.red);
		cNameLb = new Label(" Name:");
		cNameLb.setFont(AppConfig.Font_B12);
		cNameLb.setBackground(actvTableColor);
		cNameValLb = new Label("Joo Lee");
		cNameValLb.setFont(AppConfig.Font_B12);
		cNameValLb.setBackground(actvTableColor);
		cNameValLb.setForeground(Color.red);
		cTypeLb = new Label(" Type:");
		cTypeLb.setFont(AppConfig.Font_B12);
		cTypeLb.setBackground(actvTableColor);
		cTypeValLb = new Label("Prepaid");
		cTypeValLb.setFont(AppConfig.Font_B12);
		cTypeValLb.setBackground(actvTableColor);
		cTypeValLb.setForeground(Color.red);
		cBalLb = new Label(" Balance:");
		cBalLb.setFont(AppConfig.Font_B12);
		cBalLb.setBackground(actvTableColor);
		cBalValLb = new Label("200.00");
		cBalValLb.setFont(AppConfig.Font_B12);
		cBalValLb.setBackground(actvTableColor);
		cBalValLb.setForeground(Color.red);

		pDateLb   = new Label("Date(mm/dd/yyyy): ");
		pAmtLb    = new Label("Amount: ");
		adjTypeLb = new Label("Adjustment Type:");
		descLb    = new Label("Description Code: ");
		remarkLb  = new Label("Note:");

		sDateTx = new TextField();
		eDateTx = new TextField();
		pDateTx = new TextField();
		pAmtTx  = new TextField();
		adjTypeTx = new TextField();
		descTx    = new TextField();
		remarkTx  = new TextField();

		periodList = new Choice();
		periodList.addItemListener(this);
		periodList.add("Specify"); periodList.add("30 Days"); periodList.add("60 Days");
		periodList.add("90 Days"); periodList.add("180 Days");
		adjTypeList = new Choice();
		adjTypeList.add("CREDIT"); adjTypeList.add("DEBIT");
		descCodeList = new Choice();
		descCodeList.add("TEST"); descCodeList.add("ADJ01");

		appBtn = new Button();
		appBtn.setBackground(AppConfig.Color_ModuleTitleBar);
		appBtn.addActionListener(this);

		//fill the form components array
		appComponent = new Component[]
		{	appTitleLb, appText1Lb, appText2Lb, actvTable, accMultiple, cCodeValLb,
			cNameLb, cNameValLb, cTypeLb, cTypeValLb, cBalLb, cBalValLb,
			periodLb, periodList, sDateLb, sDateTx, eDateLb, eDateTx,
			pDateLb, pDateTx, pAmtLb, pAmtTx, adjTypeLb, adjTypeList,
			descLb, descTx, remarkLb, remarkTx
		};
	}

	public void paint(Graphics g)
	{
		g.setColor(AppConfig.Color_ModuleTitleBar);
		g.fillRect(0, 0, AppConfig.ClientWidth, 20);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SOFT3D);
		XToolkit.draw3DBox(g, 0, 0, AppConfig.ClientWidth+1, 21, true);
		g.setColor(Color.white);
		g.setFont(AppConfig.Font_ModuleTitle);
		g.drawString(moduleName[ADJUSTMENTS], 5, 16);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SHARP3D);
		XToolkit.draw3DLineH(g, 0, AppConfig.DividerTop, AppConfig.ClientWidth+1, 1, false);
	}


	//AppModule interface methods
	public short getModuleID() { return AppModule.INVOICES; }

	public Container getModuleContainer() { return this; }

	public void setActive(boolean state)
	{
		if(state)
		{	//CustomerPanel tp = AppConfig.getCustomerPanel();
			//tp.setSelectionMode(false);
			//this.add(tp, 0);
			AppConfig.setActiveModule(this);
			AppConfig.getCustomerPanel().setVisible(true);
			AppConfig.getCustomerPanel().setBounds(AppConfig.ClientIndent, 0, AppConfig.ClientWidth, AppConfig.CustPanelHeight);
		}
		this.setVisible(state);
	}

	//this resets the module and clears the module area
	public void reset()
	{
		xLayout.reset();
	}

	//itemlistener interface
	public void itemStateChanged(ItemEvent e)
	{
		//int newIndex = ISPList.getSelectedIndex();
		String pText = periodList.getSelectedItem();
		if(pText.equals("Specify")) return;
		eDateTx.setText(AppConfig.getDate(true));
		if(pText.equals("30 Days")) AppConfig.adjustDate(false, java.util.Calendar.DATE, -30);
		else if(pText.equals("60 Days")) AppConfig.adjustDate(false, java.util.Calendar.DATE, -60);
		else if(pText.equals("90 Days")) AppConfig.adjustDate(false, java.util.Calendar.DATE, -90);
		else if(pText.equals("180 Days")) AppConfig.adjustDate(false, java.util.Calendar.DATE, -180);
		sDateTx.setText(AppConfig.getDate(false));
	}


	//ActionListener interface
	public void actionPerformed(ActionEvent e)
	{
		String cOption = e.getActionCommand();
		//System.out.println("Button: "+cOption+"  cPMTOption: "+cPMTOption);

		if(cOption.equals("LINK_SELECTED") || cOption.equals("Print"))
		{
			int row, col;
			if(cOption.equals("Print")) row = -1;
			else { row = e.getID()/100;  col = e.getID() % 100; }
			AppConfig.setHtmlData(getAdjustmentDetails(row));
			AppConfig.sendHtmlMessage(AppConfig.SHOW_HTML);
			return;
		}

		if(cOption.equals("Search"))
		{
			if(AppConfig.getCustomerPanel().hasCustomers())
			{	cAPPOption = cOption;
				layoutForm(0);
			}
		}
		else if(cOption.equals("New Adjustment"))
		{
			if(AppConfig.getCustomerPanel().hasCustomers())
			{	if(AppConfig.getCustomerPanel().getSelectedCustomers().length > 1)
					XToolkit.showMessage("More than one Accounts are selected", "Adjustment will be made to first account only !");
				cAPPOption = cOption;
				layoutForm(2);
			}
			//AppConfig.sendHtmlMessage(AppConfig.SHOW_HTML);
			//java.applet.Applet cApp = AppConfig.getBillingApplet().appContext.getApplet("CommApplet");
			//if(cApp == null) System.out.println("Null Applet....");
			//cApp.TriggerComm();
		}
		else if(cOption.equals("Get Adjustments")) getAdjustments();
		else if(cOption.equals("OK")) makeAdjustment();
		else if(cOption.equals("Cancel")) xLayout.reset();
		else if(cOption.equals("Export"))
		{	AppConfig.setHtmlData("paActivities.zip");
			AppConfig.sendHtmlMessage(AppConfig.EXPORT_DATA);
		}
	}

	//handle data from HttpCommunicator
	public void receiveHttpData(Object data, int dataID)
	{
		if(dataID == 101)	//Get Adjustments
		{
			XToolkit.hideProgressMessage();
			Document doc = (Document)data;
			actvDoc = doc;
			if(doc == null) return;
			displayAdjustments(doc);
		}
		else if(dataID == 102)	//Make Adjustment
		{
			XToolkit.hideProgressMessage();
			Document doc = (Document)data;
			xLayout.reset();
		}
	}

	void getAdjustments()
	{
		layoutForm(1);	//adjustments list
		XToolkit.setProgressListener(AppConfig.getCommunicator());
		XToolkit.showProgressMessage("Getting Customer Adjustments. Please wait......");
		XMLParser parser = AppConfig.getParser();
		actvTable.setVisible(false);
		String sDate = sDateTx.getText();
		String eDate = eDateTx.getText();
		if(sDate.length() < 1) sDate = "*";
		if(eDate.length() < 1) eDate = "*";
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		root.setAttribute("ID", ""+ReqDef.ACCOUNTADJUSTMENTS);
		root.setAttribute("StartDate", sDate);
		root.setAttribute("EndDate", eDate);
		if(accMultiple.getState())	//if multiple accounts selected
		{	String[][] cList = AppConfig.getCustomerPanel().getSelectedCustomers();
			int cItems = cList.length;
			for(int i=0; i < cItems; i++)
			{	Element te = reqDoc.createElement("AccountId");
				root.appendChild(te);
				te.setAttribute("ID", cList[i][1]);
			}
		}
		else
		{	Element te = reqDoc.createElement("AccountId");
			root.appendChild(te);
			te.setAttribute("ID", (AppConfig.getCustomerPanel().getCustomerData())[1]);
		}
		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, 101);
	}

	public String getAdjustmentDetails(int rowId)
	{
		StringBuffer htmlBuf = new StringBuffer();
		Element root = actvDoc.getDocumentElement(), tRow;
		NodeList tList = root.getChildNodes();
		int tLen = tList.getLength();

		if(rowId > -1)
		{	tRow  = (Element)(root.getChildNodes().item(rowId));
			htmlBuf.append("<H1>Adjustment No: "+tRow.getAttribute("Id")+"<br><H3>Account No: "+tRow.getAttribute("AccountId")+"</H3><H3>Amount: "+tRow.getAttribute("Amount")+"</H3><br><br>");
			return htmlBuf.toString();
		}

		for(int i=0; i < tLen; i++)
		{	tRow  = (Element)(root.getChildNodes().item(i));
			htmlBuf.append("<H1>Adjustment No: "+tRow.getAttribute("Id")+"<br><H3>Account No: "+tRow.getAttribute("AccountId")+"</H3><H3>Amount: "+tRow.getAttribute("Amount")+"</H3><br><br>");
		}
		return htmlBuf.toString();
	}

	void makeAdjustment()
	{
		//Vector cList = AppConfig.getCustomerPanel().getSelectedCustomers();
		//int cItems = cList.size();
		XToolkit.setProgressListener(AppConfig.getCommunicator());
		XToolkit.showProgressMessage("Processing Adjustment. Please wait......");
		XMLParser parser = AppConfig.getParser();
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		int adjType = 1;
		if(adjTypeList.getSelectedItem().equals("DEBIT")) adjType = 2;
		root.setAttribute("ID", ""+ReqDef.MAKEADJUSTMENT);
		root.setAttribute("AccountId", (AppConfig.getCustomerPanel().getCustomerData())[1]);
		root.setAttribute("IspvnId", AppConfig.ispvnIDList[AppConfig.curIspvnIndex]);
		if(adjType == 1) root.setAttribute("Amount", pAmtTx.getText());
		else root.setAttribute("Amount", "-"+pAmtTx.getText());
		root.setAttribute("Note", remarkTx.getText());
		root.setAttribute("ReferenceId", (AppConfig.getCustomerPanel().getCustomerData())[14]);
		root.setAttribute("Operator", AppConfig.operatorID);
		root.setAttribute("Description", descTx.getText());
		root.setAttribute("CcType", "");
		root.setAttribute("CheckNo", "");
		root.setAttribute("TransTerms", "");
		root.setAttribute("CcNum", "");
		root.setAttribute("ExpMonth", "");
		root.setAttribute("ExpYear", "");
		root.setAttribute("CheckDate", "");
		root.setAttribute("CheckBank", "");

		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, 102);
	}

	void displayAdjustments(Document actvDoc)
	{
		actvTable.setColumns(new int[] { 100, 100, 170, 160 });
		actvTable.setHeader(new String[] { "Adj No", "Account No", "Date", "Amount" });
		actvTable.setColProperty(0, XGrid.PROP_TEXTCOLOR, Color.red);
		actvTable.setColProperty(0, XGrid.PROP_TEXTFONT, AppConfig.Font_B12);
		actvTable.setColProperty(0, XGrid.PROP_DATALINK, "Y");
		actvTable.setLinkListener(this, "LINK_SELECTED");
		actvTable.loadDocument(actvDoc);
		actvTable.setVisible(true);
	}


	void layoutForm(int fID)
	{
		xLayout.reset();

		//layout each item
		int fItems = appForms[fID].length;
		for(int i=0; i < fItems; i++) layoutXItem(appForms[fID][i]);
	}

	void layoutXItem(int[] itemData)
	{
		if(xLayout.handleXItem(itemData)) return;	//if xLayout item

		int itemLen = itemData.length;
		for(int i=0; i < itemLen; i++)
		{
			int itemID  = itemData[i];
			//handle TITLE and TEXT items
			if(itemID == TITLE || itemID == TEXT1)
			{	xLayout.setRowProperties(1, new int[] {20});
				xLayout.setColProperties(1, new int[] { itemData[i+2] });
				appTitleLb.setBounds(xLayout.getXBounds());
				if(itemID == TITLE)
				{	appTitleLb.setBackground(AppConfig.Color_ModuleTitleBar);
					appTitleLb.setText(appOptions[itemData[i+1]]);
				}
				else
				{	appTitleLb.setBackground(AppConfig.Color_Client);
					appTitleLb.setText(appText[itemData[i+1]]);
				}
				appPanel.add(appTitleLb);
				return;
			}
			//handle form buttons
			if(itemID == APPBTN)
			{	appBtn = new Button();
				appBtn.setBackground(AppConfig.Color_ModuleTitleBar);
				appBtn.addActionListener(this);
				appBtn.setLabel(appButtons[itemData[i+1]]);
				appBtn.setActionCommand(appButtons[itemData[i+1]]);
				appBtn.setBounds(xLayout.getXBounds());
				//appBtn.setBounds(200, 200, 120, 22);
				appPanel.add(appBtn);
				return;
			}

			int itemIndex = itemID - itemStartIndex;
			if(itemID < labeledItemStartIndex) //handle non-labeled component
				xLayout.addComponent(appComponent[itemIndex]);
			else
				xLayout.addLabeledComponent(appComponent[itemIndex], appComponent[itemIndex+1]);
			//sDateTx.setCaretPosition(0);
		}
	}

}
