import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Vector;

public class CustomerPanel extends Panel
	   implements ActionListener, ItemListener, KeyListener, HttpListener
{
	private Color cdrTableColor = new Color(228, 228, 228);
	private static final int cIndent=100;
	private static final int pY=29, pW=600, pH=21;

	private Label custTitle;
	private Label legend;
	private TextField idTx, fnameTx, lnameTx;
	private Button btnDetails, btnFind, btnClear;

	private int custDocType = AppConfig.DOC_ACCOUNT_ID;
	private int reqDocType  = AppConfig.DOC_ACCOUNT_ID;

	private Choice custList;
	String[][] selectedCustomers;

 	private Panel pDetails;
	private XGrid actvTable, cdrTable;
	private Label cAcc, cAccVal, cName, cNameVal, cAddr, cAddrVal1, cAddrVal2, cAddrVal3;
	private Label cPhone, cPhoneVal, cEmail, cEmailVal;
	private Label cBal, cBalVal, cActivities, cCDR;

	public CustomerPanel()
	{
		this.setLayout(null);
		this.setBounds(AppConfig.ClientIndent, 0, AppConfig.ClientWidth, AppConfig.CustPanelHeight);
		//this.setBackground(AppConfig.Color_Client);
		this.setBackground(AppConfig.Color_AppBar);

		custTitle = new Label("Customers");
		custTitle.setFont(AppConfig.Font_ModuleTitle);
		custTitle.setBounds(1, 4, 90, 18);
		this.add(custTitle);

		custList = new Choice();
		custList.setFont(new Font("SansSerif", Font.PLAIN, 11));
		custList.setBounds(cIndent, 4, 480, 23);
		custList.addItemListener(this);
		this.add(custList);

		//add search panel
		Panel pSearch = new Panel();
		pSearch.setLayout(null);
		pSearch.setBounds(cIndent, pY, pW, pH);
		//pSearch.setBackground(Color.lightGray);
		//pSearch.setVisible(false);
		this.add(pSearch);
		Label sL = new Label("Search");
		sL.setFont(AppConfig.Font_B12);
		sL.setBounds(0, 0, 50, 20);
		pSearch.add(sL);
		Label idL = new Label("Account No:");
		idL.setBounds(50, 0, 65, 20);
		idL.setFont(AppConfig.Font_11);
		pSearch.add(idL);
		idTx = new TextField();
		idTx.setBounds(115, 0, 90, 21);
		idTx.setFont(AppConfig.Font_11);
		idTx.setBackground(Color.white);
		idTx.addKeyListener(this);
		pSearch.add(idTx);
		Label fnL = new Label("First Name:");
		fnL.setBounds(215, 0, 60, 20);
		fnL.setFont(AppConfig.Font_11);
		pSearch.add(fnL);
		fnameTx = new TextField();
		fnameTx.setBounds(275, 0, 70, 21);
		fnameTx.setFont(AppConfig.Font_11);
		fnameTx.setBackground(Color.white);
		fnameTx.addKeyListener(this);
		pSearch.add(fnameTx);
		Label lnL = new Label("Last Name:");
		lnL.setBounds(355, 0, 55, 20);
		lnL.setFont(AppConfig.Font_11);
		pSearch.add(lnL);
		lnameTx = new TextField();
		lnameTx.setBounds(410, 0, 70, 21);
		lnameTx.setFont(AppConfig.Font_11);
		lnameTx.setBackground(Color.white);
		lnameTx.addKeyListener(this);
		pSearch.add(lnameTx);

		btnFind = new Button("Find");
		btnFind.setBounds(485, 0, 35, 21);
		btnFind.setBackground(AppConfig.Color_ModuleTitleBar);
		btnFind.addActionListener(this);
		btnFind.setActionCommand("FIND");
		pSearch.add(btnFind);

		btnClear = new Button("Clear");
		btnClear.setBounds(525, 0, 35, 21);
		btnClear.setBackground(AppConfig.Color_ModuleTitleBar);
		btnClear.addActionListener(this);
		btnClear.setActionCommand("CLEAR");
		pSearch.add(btnClear);

		btnDetails = new Button("Details");
		btnDetails.setBounds(cIndent+485, 4, 75, 21);
		btnDetails.setBackground(AppConfig.Color_ModuleTitleBar);
		btnDetails.addActionListener(this);
		btnDetails.setActionCommand("DETAILS");
		this.add(btnDetails);

		//add Customer Details Panel
		Panel pDetails = new Panel();
		pDetails.setLayout(null);
		pDetails.setBackground(Color.lightGray);
		pDetails.setBounds(0, AppConfig.CustPanelHeight, AppConfig.ClientWidth, AppConfig.TotalHeight);
		this.add(pDetails);

		Font  cLabelFont=AppConfig.Font_B12, cValFont=AppConfig.Font_B12;
		Color cLabelColor=Color.black, cValColor=Color.red;
		int dIndent=cIndent, dTop=20, dVGap=20, wLabel=80, wVal=500;

		cAcc = new Label("Account :");
		cAcc.setFont(cLabelFont);
		cAcc.setForeground(cLabelColor);
		cAcc.setBounds(dIndent, dTop, wLabel, dVGap);
		pDetails.add(cAcc);
		cName = new Label("Name :");
		cName.setFont(cLabelFont);
		cName.setForeground(cLabelColor);
		cName.setBounds(dIndent, dTop+dVGap, wLabel, dVGap);
		pDetails.add(cName);
		cAddr = new Label("Address :");
		cAddr.setFont(cLabelFont);
		cAddr.setForeground(cLabelColor);
		cAddr.setBounds(dIndent, dTop+2*dVGap, wLabel, dVGap);
		pDetails.add(cAddr);
		cPhone= new Label("Phone :");
		cPhone.setFont(cLabelFont);
		cPhone.setForeground(cLabelColor);
		cPhone.setBounds(dIndent, dTop+5*dVGap, wLabel, dVGap);
		pDetails.add(cPhone);
		cEmail= new Label("E-Mail :");
		cEmail.setFont(cLabelFont);
		cEmail.setForeground(cLabelColor);
		cEmail.setBounds(dIndent, dTop+6*dVGap, wLabel, dVGap);
		pDetails.add(cEmail);
		cBal  = new Label("Balance :");
		cBal.setFont(cLabelFont);
		cBal.setForeground(cLabelColor);
		cBal.setBounds(dIndent, dTop+7*dVGap, wLabel, dVGap);
		pDetails.add(cBal);
		cActivities = new Label("Account Activities :");
		cActivities.setFont(cLabelFont);
		cActivities.setForeground(cLabelColor);
		cActivities.setBounds(dIndent, dTop+dVGap, wLabel, dVGap);
		//pDetails.add(cActivities);
		cCDR = new Label("Latest Call Details :");
		cCDR.setFont(cLabelFont);
		cCDR.setForeground(cLabelColor);
		cCDR.setBounds(dIndent, dTop+8*dVGap+20, 200, dVGap);
		pDetails.add(cCDR);

		cAccVal= new Label();
		cAccVal.setFont(cValFont);
		cAccVal.setForeground(cValColor);
		cAccVal.setBounds(dIndent+wLabel, dTop, wVal, dVGap);
		pDetails.add(cAccVal);
		cNameVal = new Label();
		cNameVal.setFont(cValFont);
		cNameVal.setForeground(cValColor);
		cNameVal.setBounds(dIndent+wLabel, dTop+dVGap, wVal, dVGap);
		pDetails.add(cNameVal);
		cAddrVal1= new Label();
		cAddrVal1.setFont(cValFont);
		cAddrVal1.setForeground(cValColor);
		cAddrVal1.setBounds(dIndent+wLabel, dTop+2*dVGap, wVal, dVGap);
		pDetails.add(cAddrVal1);
		cAddrVal2= new Label();
		cAddrVal2.setFont(cValFont);
		cAddrVal2.setForeground(cValColor);
		cAddrVal2.setBounds(dIndent+wLabel, dTop+3*dVGap, wVal, dVGap);
		pDetails.add(cAddrVal2);
		cAddrVal3= new Label();
		cAddrVal3.setFont(cValFont);
		cAddrVal3.setForeground(cValColor);
		cAddrVal3.setBounds(dIndent+wLabel, dTop+4*dVGap, wVal, dVGap);
		pDetails.add(cAddrVal3);
		cPhoneVal= new Label();
		cPhoneVal.setFont(cValFont);
		cPhoneVal.setForeground(cValColor);
		cPhoneVal.setBounds(dIndent+wLabel, dTop+5*dVGap, wVal, dVGap);
		pDetails.add(cPhoneVal);
		cEmailVal= new Label();
		cEmailVal.setFont(cValFont);
		cEmailVal.setForeground(cValColor);
		cEmailVal.setBounds(dIndent+wLabel, dTop+6*dVGap, wVal, dVGap);
		pDetails.add(cEmailVal);
		cBalVal = new Label();
		cBalVal.setFont(cValFont);
		cBalVal.setForeground(cValColor);
		cBalVal.setBounds(dIndent+wLabel, dTop+7*dVGap, wVal, dVGap);
		pDetails.add(cBalVal);
//	private Label cName, cNameVal, cAddr, cAddrVal1, cAddrVal2, cAddrVal3;
//	private Label cPhocdrTablene, cPhoneVal, cEmail, cEmailVal, cType, cTypeVal;
//	private Label cBal, cBalVal, cActivities, cCDR;

		cdrTable = new XGrid();
		cdrTable.setBounds(dIndent, dTop+9*dVGap+20, 563, 142);
		cdrTable.setContentBackground(AppConfig.Color_ModuleTitleBar);
		cdrTable.setContentForeground(cdrTableColor);
		//cdrTable.setDataFont(AppConfig.Font_B12);
		cdrTable.setPageSize(5);
		cdrTable.displayPageTabs(true);
		cdrTable.setColumns(new int[]{120, 110, 100, 70, 100, 60});
		cdrTable.setHeader(new String[]{ "Date/Time", "Called No", "Calling No", "Disc Cause", "Duration (min:sec)", "Amount" });
		//cdrTable.setColProperty(0, XGrid.PROP_TEXTCOLOR, Color.red);
		//cdrTable.setColProperty(0, XGrid.PROP_TEXTFONT, AppConfig.Font_B12);
		//cdrTable.setColProperty(0, XGrid.PROP_DATALINK, "Y");
		//cdrTable.setLinkListener(this, "LINK_SELECTED");
		//cdrTable.setVisible(false);
		pDetails.add(cdrTable);

		legend = new Label("Disconnect Cause:  16: Normal Call Clearing   1: Unallocated Number  3: No Route to Destination");
		legend.setFont(AppConfig.Font_B11);
		legend.setBounds(dIndent, dTop+9*dVGap+20+152, 563, 40);
		pDetails.add(legend);
		/*cMsg = new Label();
		cMsg.setBounds(cIndent, AppConfig.DividerTop+20, 400, 18);
		cMsg.setForeground(Color.gray);
		cMsg.setFont(AppConfig.Font_B12);
		this.add(cMsg);*/
	}

	public void reset()
	{
		//System.out.println("CustomerPanel reset: "+AppConfig.curIspvnIndex);
		selectedCustomers = null;

		//clear Caches
		AppConfig.DocumentCache[AppConfig.DOC_ACCOUNT_ID] = null;
		AppConfig.DocumentCache[AppConfig.DOC_ACCOUNT_FNAME] = null;
		AppConfig.DocumentCache[AppConfig.DOC_ACCOUNT_LNAME] = null;
	}

	public void paint(Graphics g)
	{
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SOFT3D);
		XToolkit.draw3DBox(g, 0, 0, AppConfig.ClientWidth, AppConfig.CustPanelHeight, true);
	}

	//Event Handler for All Actions
	public void actionPerformed(ActionEvent e)
	{
		Object eventObj = e.getSource();	//e.getActionCommand();

		if(eventObj == btnFind) { findCustomer(); return; }

		if(eventObj == btnClear)
		{
			idTx.setText("");
			fnameTx.setText("");
			lnameTx.setText("");
			custList.removeAll();
			selectedCustomers = null;
			return;
		}

		if(eventObj == btnDetails)
		{
			this.setBounds(AppConfig.ClientIndent, 0, AppConfig.ClientWidth, AppConfig.TotalHeight);
			showCustDetails();
		}
	}

	public void itemStateChanged(ItemEvent e)
	{
		int newIndex = custList.getSelectedIndex();
		//if(newIndex != curISPIndex)
		//{	curISPIndex = newIndex;
		//	AppConfig.getBillingApplet().setIspvn(newIndex);
		//}
	}

	void resetForSelection()
	{
		AppConfig.getActiveModule().reset();
		selectedCustomers = null;
		//custList.reset();
	}

	//Key Listener Interface Implementation
	public void keyTyped(KeyEvent e)
	{
		Object eventObj = e.getSource();
		if(eventObj == idTx)
		{	fnameTx.setText(""); lnameTx.setText("");
			reqDocType = AppConfig.DOC_ACCOUNT_ID;
		}
		else if(eventObj == fnameTx)
		{	idTx.setText(""); lnameTx.setText("");
			reqDocType = AppConfig.DOC_ACCOUNT_FNAME;
		}
		else if(eventObj == lnameTx)
		{	idTx.setText(""); fnameTx.setText("");
			reqDocType = AppConfig.DOC_ACCOUNT_LNAME;
		}
		if(e.getKeyChar() == 10) //if Enter Key Pressed
			findCustomer();
		//XToolkit.showMessage("The key pressed is :"+(int)(e.getKeyChar()));
	}
	public void keyPressed(KeyEvent e)  { }
	public void keyReleased(KeyEvent e) { }


	//Load and Display Customer Data
	void loadCustomerData(String subCriteria)
	{
		long fTime = AppConfig.DocumentFetchTime[custDocType];
		if(System.currentTimeMillis()-fTime > AppConfig.CacheTimeout || AppConfig.DocumentCache[custDocType] == null)
		{
		//show wait message to the poor user
		XToolkit.showProgressMessage("Loading customer data. Please wait......");
		XMLParser parser = AppConfig.getParser();
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		root.setAttribute("ID", ""+ReqDef.ACCOUNTLISTC);
		root.setAttribute("SortId", "0");
		String criteria = " where a.ispvn_id="+AppConfig.ispvnIDList[AppConfig.curIspvnIndex]+
						  " And a.id=b.account_id "+subCriteria+" And rownum between 1 and 200";
		if(custDocType == AppConfig.DOC_ACCOUNT_ID) criteria += " order by b.username";
		else if(custDocType == AppConfig.DOC_ACCOUNT_FNAME) criteria += " order by a.firstname_upper";
		else criteria += " order by a.surname_upper";
		root.setAttribute("Criteria", criteria);
		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, 1);
		}
		//else custTable.loadDocument(AppConfig.DocumentCache[custDocType]);
	}

	//handle data from HttpCommunicator
	public void receiveHttpData(Object data, int dataID)
	{
		XToolkit.hideProgressMessage();
		Document doc = (Document)data;
		if(doc == null) return;

		if(dataID == 2)
		{	cdrTable.loadDocument(doc);
			cBalVal.setText(doc.getDocumentElement().getAttribute("Balance"));
			return;
		}

		AppConfig.DocumentFetchTime[custDocType] = System.currentTimeMillis();
		AppConfig.DocumentCache[custDocType] = doc;
		updateCustList(doc);
	}

	void updateCustList(Document doc)
	{
		custList.removeAll();

		Element  dRoot = doc.getDocumentElement();
		NodeList dRows = dRoot.getChildNodes();
		int gridRowCount = dRows.getLength();
		int i, j, dColumns = 15;
		selectedCustomers = new String[gridRowCount][dColumns];

		for(i=0; i < gridRowCount; i++)
		{	Node cRow = dRows.item(i);
			NamedNodeMap attrMap = cRow.getAttributes();
			String[] custData = new String[dColumns];
			for(j=0; j < dColumns; j++) custData[j] = attrMap.item(j).getNodeValue();
			selectedCustomers[i] = custData;
			String cStr = "Account No: "+custData[0]+"  FirstName: "+custData[2]+"  LastName: "+custData[3]+"  PrePaid: "+custData[13];
			custList.add(cStr);
		}
	}

	public String[][] getSelectedCustomers() { return selectedCustomers; }

	public String[] getCustomerData()
	{
		int cIndex = custList.getSelectedIndex();
		if(cIndex < 0) return null;
		return(selectedCustomers[cIndex]);
	}

	public int getCustomerIndex(String ActId)
	{
		for(int i=0; i < selectedCustomers.length; i++)
			if(selectedCustomers[i][1].equals(ActId)) return i;
		return -1;	//not found
	}

	public boolean hasCustomers()
	{
		if(selectedCustomers == null || selectedCustomers.length < 1)
		{
			XToolkit.showMessage("No Customer(s) selected !", "Please select a customer(s) first");
			return false;
		}
		return true;
	}


	void showCustDetails()
	{
		if(!hasCustomers()) return;
		int cIndex = custList.getSelectedIndex();
		String[] cData = selectedCustomers[cIndex];
		cAccVal.setText(cData[0]+"   ("+(cData[13].equals("Y") ? "PrePaid":"PostPaid")+")");
		String Name = "", Addr1="", Addr2="", Addr3="", Phone="", Email="";
		if(!cData[2].equals("null")) Name = Name+cData[2];
		if(!cData[3].equals("null")) Name = Name+" "+cData[3];
		if(!cData[5].equals("null")) Addr1 = cData[5];
		if(!cData[6].equals("null")) Addr2 = cData[6];
		if(!cData[7].equals("null")) Addr3 = cData[7];
		if(!cData[8].equals("null")) Addr3 = Addr3+" "+cData[8];
		if(!cData[9].equals("null")) Addr3 = Addr3+" "+cData[9];
		if(!cData[10].equals("null")) Addr3 = Addr3+" "+cData[10];
		if(!cData[11].equals("null")) Phone = cData[11];
		if(!cData[12].equals("null")) Email = cData[12];
		cNameVal.setText(Name);
		cAddrVal1.setText(Addr1);
		cAddrVal2.setText(Addr2);
		cAddrVal3.setText(Addr3);
		cPhoneVal.setText(Phone);
		cEmailVal.setText(Email);
		//cBalVal.setText("0.00");

		XToolkit.showProgressMessage("Getting customer details. Please wait......");
		XMLParser parser = AppConfig.getParser();
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		root.setAttribute("ID", ""+ReqDef.ACCOUNTINFO);
		root.setAttribute("AccountId", cData[1]);
		root.setAttribute("OrderId", cData[14]);
		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, 2);
	}

	void findCustomer()
	{
		String ID = idTx.getText().trim();
		String fName = fnameTx.getText().trim();
		String lName = lnameTx.getText().trim();
		String subQtext = "";
		int    found=-1;
		boolean reloadRequired = false;

		custDocType = reqDocType;

		if(AppConfig.DocumentCache[custDocType] == null) reloadRequired = true;
		else
		{
			//custTable.loadDocument(AppConfig.DocumentCache[custDocType]);
			/*if(custDocType == AppConfig.DOC_ACCOUNT_ID)
				found = custTable.findText(ID, 0);
			else if(custDocType == AppConfig.DOC_ACCOUNT_FNAME)
				found = custTable.findText(fName, 1);
			else if(custDocType == AppConfig.DOC_ACCOUNT_LNAME)
				found = custTable.findText(lName, 2);
			*/
			if(found >= 0)
			{	//cMsg.setText("Search Successful !");
				return;
			}
			else reloadRequired = true;
		}

		//cMsg.setText("Search Results :");

		if(custDocType == AppConfig.DOC_ACCOUNT_ID)
		{	int tLen = ID.length();
			if( tLen > 0) subQtext = " And b.username like '"+ID.substring(0, (tLen > 10) ? 10:tLen)+"%'";
		}
		else if(custDocType == AppConfig.DOC_ACCOUNT_FNAME)
		{	if(fName.length() > 0) subQtext = " And a.firstname_upper like '"+fName.toUpperCase()+"%'"; }
		else if(custDocType == AppConfig.DOC_ACCOUNT_LNAME)
		{	if(lName.length() > 0) subQtext = " And a.surname_upper like '"+lName.toUpperCase()+"%'"; }

		AppConfig.DocumentCache[custDocType] = null;
		loadCustomerData(subQtext);
	}
}
