import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class ReportsApp extends Panel implements AppModule, ActionListener, HttpListener
{
	private Color reportBtnColor  = new Color(228, 228, 228);
	Panel xForm = new Panel();
	XLayout xLayout = new XLayout(xForm);
	int cReportID = 0;

	//declare common form components
	Label titleLb, ispvnLb, actLb, sdateLb, edateLb, sortbyLb;
	Label smonthLb, emonthLb, lotnumLb, shourLb, sminuteLb;
	Label ssecondLb, ehourLb, eminuteLb, esecondLb, cdrtableLb;
	Label sdateActivationLb, edateActivationLb, sdateExpirationLb, edateExpirationLb;

	TextField actTx, sdateTx, edateTx, smonthTx, emonthTx, lotnumTx;
	TextField shourTx, sminuteTx, ssecondTx, ehourTx, eminuteTx, esecondTx;
	TextField sdateActivationTx, edateActivationTx, sdateExpirationTx, edateExpirationTx;

	Choice ispvnList, sortbyList, lotsortbyList, cdrsortbyList, cdrtableList;
	Choice refsortbyList, densortbyList, ndnsortbyList, revsortbyList;
	Choice rvdsortbyList, ccusortbyList;

	Button viewreportBtn;

	static final int TITLE   = 101;
	static final int LABELX  = 102;
	static final int ISPLIST = 103;
	static final int SORTBY  = 104;
	static final int SDATE   = 105;
	static final int EDATE   = 106;
	static final int SMONTH  = 107;
	static final int EMONTH  = 108;
	static final int LOTNUM  = 109;
	static final int SDATEACT  = 110;
	static final int EDATEACT  = 111;
	static final int SDATEEXP  = 112;
	static final int EDATEEXP  = 113;
	static final int LOTSORTBY = 114;
	static final int SHOUR   = 115;
	static final int EHOUR   = 116;
	static final int SMINUTE = 117;
	static final int EMINUTE = 118;
	static final int SSECOND = 119;
	static final int ESECOND = 120;
	static final int CDRSORTBY = 121;
	static final int CDRTABLE  = 122;
	static final int REFSORTBY = 123;
	static final int DENSORTBY = 124;
	static final int NDNSORTBY = 125;
	static final int REVSORTBY = 126;
	static final int RVDSORTBY = 127;
	static final int CCUSORTBY = 128;
	static final int ACCOUNTNO = 129;


	private static final String[] reportName =
				{	"Traffic by Month", "Traffic by Day", "Traffic by Hour",
					"Lot", "All CDRs", "Top 5 Terminations", "Number of Refreshes",
					"Denied Service", "Num of Denied Service", "Revenue",
					"Revenue-Destination Summary", "Calling Card Usage", "Account CDRs"
				};

	private static final int[][][] reportForms =
	{
		{ //Traffic by Month
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SMONTH, EMONTH, SORTBY }
		},
		{ //Traffic by Day
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE, SORTBY }
		},
		{ //Traffic by Hour
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE, SORTBY }
		},
		{ //Lot
			{ TITLE, 360 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 340 },
			{ XLayout.LDEF, 190 },
			{ ISPLIST },
			{ XLayout.COLDEF, 270 },
			{ XLayout.LDEF, 190 },
			{ LOTNUM, SDATEACT, EDATEACT },
			{ SDATEEXP, EDATEEXP },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 190 },
			{ LOTSORTBY }
		},
		{ //All CDRs
			{ TITLE, 480 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 320 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230, 90, 70, 70 },
			{ XLayout.LDEF, 150, 50, 30, 30 },
			{ SDATE },
			{ XLayout.ROWDEF, 24, 10, 0, 0, 4 },
			{ SHOUR, SMINUTE, SSECOND },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ EDATE },
			{ XLayout.ROWDEF, 24, 10, 0, 0, 4 },
			{ EHOUR, EMINUTE, ESECOND },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 280 },
			{ XLayout.LDEF, 150 },
			{ CDRSORTBY },
			{ CDRTABLE }
		},
		{ //Top 5 Treminations
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE }
		},
		{ //Number of Refreshes
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE, REFSORTBY }
		},
		{ //Denied Service
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE },
			{ XLayout.COLDEF, 280 },
			{ XLayout.LDEF, 150 },
			{ DENSORTBY, CDRTABLE }
		},
		{ //Num of Denied Service
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE },
			{ XLayout.COLDEF, 280 },
			{ XLayout.LDEF, 150 },
			{ NDNSORTBY, CDRTABLE }
		},
		{ //Revenue
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE, REVSORTBY }
		},
		{ //Revenue-Destination Summary
			{ TITLE, 320 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 300 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230 },
			{ XLayout.LDEF, 150 },
			{ SDATE, EDATE, RVDSORTBY }
		},
		{ //Calling Card Usage
			{ TITLE, 480 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 320 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST },
			{ XLayout.COLDEF, 230, 90, 70, 70 },
			{ XLayout.LDEF, 150, 50, 30, 30 },
			{ SDATE },
			{ XLayout.ROWDEF, 24, 10, 0, 0, 4 },
			{ SHOUR, SMINUTE, SSECOND },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ EDATE },
			{ XLayout.ROWDEF, 24, 10, 0, 0, 4 },
			{ EHOUR, EMINUTE, ESECOND },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 290 },
			{ XLayout.LDEF, 150 },
			{ CCUSORTBY }
		},
		{ //CDRs 2
			{ TITLE, 480 },
			{ XLayout.SKIPROW },
			{ XLayout.INDENT, 20 },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 320 },
			{ XLayout.LDEF, 150 },
			{ ISPLIST, ACCOUNTNO },
			{ XLayout.COLDEF, 230, 90, 70, 70 },
			{ XLayout.LDEF, 150, 50, 30, 30 },
			{ SDATE },
			{ XLayout.ROWDEF, 24, 10, 0, 0, 4 },
			{ SHOUR, SMINUTE, SSECOND },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ EDATE },
			{ XLayout.ROWDEF, 24, 10, 0, 0, 4 },
			{ EHOUR, EMINUTE, ESECOND },
			{ XLayout.ROWDEF, 24, 0, 0, 0, 4 },
			{ XLayout.COLDEF, 280 },
			{ XLayout.LDEF, 150 },
			{ CDRSORTBY }
		}
	};


	public ReportsApp()
	{
		this.setLayout(null);
		this.setBounds(AppConfig.ClientIndent, 0, AppConfig.ClientWidth, AppConfig.TotalHeight);
		this.setBackground(AppConfig.Color_Client);

		for(int i=0; i < 13; i++)
		{
			XButton	btn = new XButton(reportName[i]);
			btn.setBounds(20+(i%3)*200, 40+(i/3)*26,  190, 23);
			btn.setColor(reportBtnColor);
			btn.addActionListener(this);
			btn.setActionCommand(""+(100+i));
			this.add(btn);
		}

		xForm.setLayout(null);
		xForm.setBounds(20, 190, 600, 400);
		this.add(xForm);

		defineFormElements();
	}

	void defineFormElements()
	{
		titleLb = new Label();
		titleLb.setFont(AppConfig.Font_ModuleTitle);
		titleLb.setBackground(AppConfig.Color_ModuleTitleBar);

		ispvnLb = new Label("ISP_VN Provider : ");
		ispvnLb.setFont(AppConfig.Font_12);

		actLb = new Label("Account No : ");
		actLb.setFont(AppConfig.Font_12);

		sdateLb = new Label("Start Date (mm/dd/yyyy) : ");
		sdateLb.setFont(AppConfig.Font_12);

		edateLb = new Label("End Date (mm/dd/yyyy) : ");
		edateLb.setFont(AppConfig.Font_12);

		smonthLb = new Label("Start Month (mm/yyyy) : ");
		smonthLb.setFont(AppConfig.Font_12);

		emonthLb = new Label("End Month (mm/yyyy) : ");
		emonthLb.setFont(AppConfig.Font_12);

		sortbyLb = new Label("Sort By : ");
		sortbyLb.setFont(AppConfig.Font_12);

		lotnumLb = new Label("Lot Number : ");
		lotnumLb.setFont(AppConfig.Font_12);

		sdateActivationLb = new Label("Activation Start Date (mm/dd/yyyy) :");
		sdateActivationLb.setFont(AppConfig.Font_12);

		edateActivationLb = new Label("Activation End Date (mm/dd/yyyy) :");
		edateActivationLb.setFont(AppConfig.Font_12);

		sdateExpirationLb = new Label("Expiration Start Date (mm/dd/yyyy) :");
		sdateExpirationLb.setFont(AppConfig.Font_12);

		edateExpirationLb = new Label("Expiration End Date (mm/dd/yyyy) :");
		edateExpirationLb.setFont(AppConfig.Font_12);

		shourLb = new Label("HH24 :");
		shourLb.setFont(AppConfig.Font_12);
		sminuteLb = new Label("MI :");
		sminuteLb.setFont(AppConfig.Font_12);
		ssecondLb = new Label("SS :");
		ssecondLb.setFont(AppConfig.Font_12);

		ehourLb = new Label("HH24 :");
		ehourLb.setFont(AppConfig.Font_12);
		eminuteLb = new Label("MI :");
		eminuteLb.setFont(AppConfig.Font_12);
		esecondLb = new Label("SS :");
		esecondLb.setFont(AppConfig.Font_12);

		cdrtableLb  = new Label("Select Table :");

		actTx   = new TextField();
		sdateTx = new TextField();
		edateTx = new TextField();
		smonthTx = new TextField();
		emonthTx = new TextField();
		lotnumTx = new TextField();
		sdateActivationTx = new TextField();
		edateActivationTx = new TextField();
		sdateExpirationTx = new TextField();
		edateExpirationTx = new TextField();
		shourTx = new TextField();
		sminuteTx = new TextField();
		ssecondTx = new TextField();
		ehourTx = new TextField();
		eminuteTx = new TextField();
		esecondTx = new TextField();

		ispvnList = new Choice();
		String[] ispList = AppConfig.ispvnNameList;
		for(int i=0; i < ispList.length; i++) ispvnList.add(ispList[i]);

		sortbyList = new Choice();
		sortbyList.add("Date"); sortbyList.add("Traffic"); sortbyList.add("Provider");

		lotsortbyList = new Choice();
		lotsortbyList.add("Provider"); lotsortbyList.add("Lot_No"); lotsortbyList.add("Issue_Date");
		lotsortbyList.add("Cards_in_Lot"); lotsortbyList.add("Card_Value"); lotsortbyList.add("Exp_Date");
		lotsortbyList.add("Cards_in_Use"); lotsortbyList.add("CardsInUsePct");

		cdrsortbyList = new Choice();
		cdrsortbyList.add("Date"); cdrsortbyList.add("Provider"); cdrsortbyList.add("Account");
		cdrsortbyList.add("Batch_no"); cdrsortbyList.add("cdr_time"); cdrsortbyList.add("Calling_no");
		cdrsortbyList.add("Called_no"); cdrsortbyList.add("Disconnect_cause"); cdrsortbyList.add("Destination");
		cdrsortbyList.add("cdr_duration"); cdrsortbyList.add("End_user_charge");

		cdrtableList = new Choice();
		cdrtableList.add("voip_cdr"); cdrtableList.add("voip_cdr_failed");

		refsortbyList = new Choice();
		refsortbyList.add("Auth_code"); refsortbyList.add("Amount");
		refsortbyList.add("Refreshes"); refsortbyList.add("Provider");

		densortbyList = new Choice();
		densortbyList.add("Date"); densortbyList.add("Account_id");
		densortbyList.add("Disconnect Cause"); densortbyList.add("Connection_id");
		densortbyList.add("Duration"); densortbyList.add("Orig_pop_id"); densortbyList.add("Provider");

		ndnsortbyList = new Choice();
		ndnsortbyList.add("Disconnect Cause"); ndnsortbyList.add("Number of Times");
		ndnsortbyList.add("Provider");

		revsortbyList = new Choice();
		revsortbyList.add("Calls"); revsortbyList.add("Minutes");
		revsortbyList.add("Revenue"); revsortbyList.add("Provider");

		rvdsortbyList = new Choice();
		rvdsortbyList.add("Calls"); rvdsortbyList.add("Destination");
		rvdsortbyList.add("Minutes"); rvdsortbyList.add("Revenue"); rvdsortbyList.add("Provider");

		ccusortbyList = new Choice();
		ccusortbyList.add("Provider"); ccusortbyList.add("CallingCardDescription");
		ccusortbyList.add("Minutes");


		viewreportBtn = new Button("View Report");
		viewreportBtn.setBackground(AppConfig.Color_ModuleTitleBar);
		viewreportBtn.addActionListener(this);
		viewreportBtn.setActionCommand("VIEW REPORT");
	}

	public void paint(Graphics g)
	{
		g.setColor(AppConfig.Color_ModuleTitleBar);
		g.fillRect(0, 0, AppConfig.ClientWidth, 20);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SOFT3D);
		XToolkit.draw3DBox(g, 0, 0, AppConfig.ClientWidth+1, 21, true);
		g.setColor(Color.white);
		g.setFont(AppConfig.Font_ModuleTitle);
		g.drawString(moduleName[REPORTS], 5, 16);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SHARP3D);
		//XToolkit.draw3DLineH(g, 0, 158, AppConfig.ClientWidth+1, 2, true);
		XToolkit.draw3DLineH(g, 0, 178, AppConfig.ClientWidth+1, 2, true);
	}


	//AppModule interface methods
	public short getModuleID() { return AppModule.REPORTS; }

	public Container getModuleContainer() { return this; }

	public void setActive(boolean state)
	{
		if(state)
		{	AppConfig.setActiveModule(this);
			AppConfig.getCustomerPanel().setVisible(false);
		}
		this.setVisible(state);
	}

	public void reset() { }

	//ActionListener interface
	public void actionPerformed(ActionEvent e)
	{
		String cmdString = e.getActionCommand();
		if(cmdString.equals("VIEW REPORT")) { loadReport(); return; }

		int repID =  Integer.parseInt(e.getActionCommand()) - 100;
		cReportID = repID;
		layoutForm(repID);
	}

	void layoutForm(int fID)
	{
		//clear existing form
		xForm.removeAll();
		//reset XLayout
		xLayout.reset();

		//layout each item
		int fItems = reportForms[fID].length;
		for(int i=0; i < fItems; i++) layoutXItem(reportForms[fID][i]);

		//add view report button
		java.awt.Rectangle R = xLayout.getXBounds();
		viewreportBtn.setBounds(R.x, R.y+5, 120, 22);
		xForm.add(viewreportBtn);
	}

	void layoutXItem(int[] itemData)
	{
		if(xLayout.handleXItem(itemData)) return;

		int itemID  = itemData[0];
		int itemLen = itemData.length;

		if(itemID == TITLE)
		{
			xLayout.setRowProperties(1, new int[] {20});
			xLayout.setColProperties(1, new int[] { itemData[1] });
			titleLb.setBounds(xLayout.getXBounds());
			titleLb.setText(reportName[cReportID]+" Report");
			xForm.add(titleLb);
			return;
		}

		for(int i=0; i < itemLen; i++)
		switch(itemData[i])
		{
			case ISPLIST:
				xLayout.addLabeledComponent(ispvnLb, ispvnList);
				break;

			case SORTBY:
				xLayout.addLabeledComponent(sortbyLb, sortbyList);
				break;

			case SDATE:
				xLayout.addLabeledComponent(sdateLb, sdateTx);
				sdateTx.setCaretPosition(0);
				break;

			case EDATE:
				xLayout.addLabeledComponent(edateLb, edateTx);
				edateTx.setCaretPosition(0);
				break;

			case SMONTH:
				xLayout.addLabeledComponent(smonthLb, smonthTx);
				smonthTx.setCaretPosition(0);
				break;

			case EMONTH:
				xLayout.addLabeledComponent(emonthLb, emonthTx);
				emonthTx.setCaretPosition(0);
				break;

			case LOTNUM:
				xLayout.addLabeledComponent(lotnumLb, lotnumTx);
				lotnumTx.setCaretPosition(0);
				break;

			case SDATEACT:
				xLayout.addLabeledComponent(sdateActivationLb, sdateActivationTx);
				sdateActivationTx.setCaretPosition(0);
				break;

			case EDATEACT:
				xLayout.addLabeledComponent(edateActivationLb, edateActivationTx);
				edateActivationTx.setCaretPosition(0);
				break;


			case SDATEEXP:
				xLayout.addLabeledComponent(sdateExpirationLb, sdateExpirationTx);
				sdateExpirationTx.setCaretPosition(0);
				break;


			case EDATEEXP:
				xLayout.addLabeledComponent(edateExpirationLb, edateExpirationTx);
				edateExpirationTx.setCaretPosition(0);
				break;


			case LOTSORTBY:
				xLayout.addLabeledComponent(sortbyLb, lotsortbyList);
				break;

			case SHOUR:
				xLayout.addLabeledComponent(shourLb, shourTx);
				shourTx.setCaretPosition(0);
				break;

			case EHOUR:
				xLayout.addLabeledComponent(ehourLb, ehourTx);
				ehourTx.setCaretPosition(0);
				break;

			case SMINUTE:
				xLayout.addLabeledComponent(sminuteLb, sminuteTx);
				sminuteTx.setCaretPosition(0);
				break;

			case EMINUTE:
				xLayout.addLabeledComponent(eminuteLb, eminuteTx);
				eminuteTx.setCaretPosition(0);
				break;

			case SSECOND:
				xLayout.addLabeledComponent(ssecondLb, ssecondTx);
				ssecondTx.setCaretPosition(0);
				break;

			case ESECOND:
				xLayout.addLabeledComponent(esecondLb, esecondTx);
				esecondTx.setCaretPosition(0);
				break;

			case CDRTABLE:
				xLayout.addLabeledComponent(cdrtableLb, cdrtableList);
				break;

			case CDRSORTBY:
				xLayout.addLabeledComponent(sortbyLb, cdrsortbyList);
				break;

			case REFSORTBY:
				xLayout.addLabeledComponent(sortbyLb, refsortbyList);
				break;

			case DENSORTBY:
				xLayout.addLabeledComponent(sortbyLb, densortbyList);
				break;

			case NDNSORTBY:
				xLayout.addLabeledComponent(sortbyLb, ndnsortbyList);
				break;

			case REVSORTBY:
				xLayout.addLabeledComponent(sortbyLb, revsortbyList);
				break;

			case RVDSORTBY:
				xLayout.addLabeledComponent(sortbyLb, rvdsortbyList);
				break;

			case CCUSORTBY:
				xLayout.addLabeledComponent(sortbyLb, ccusortbyList);
				break;

			case ACCOUNTNO:
				xLayout.addLabeledComponent(actLb, actTx);
				actTx.setCaretPosition(0);
				break;
		}
	}

	//load selected report
	void loadReport()
	{
		XToolkit.showProgressMessage("Getting Report. Please wait......");
		XMLParser parser = AppConfig.getParser();
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		root.setAttribute("ID", ""+ReqDef.BILLINGREPORT);
		root.setAttribute("ReportID", ""+cReportID);

		switch(cReportID)
		{
		case 0:	//Traffic by Month
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, smonthTx.getText());
			addParam(root, emonthTx.getText());
			addParam(root, sortbyList.getSelectedItem());
			break;

		case 1:	//Traffic by Day
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, sortbyList.getSelectedItem());
			break;

		case 2:	//Traffic by Hour
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, sortbyList.getSelectedItem());
			break;

		case 3:	//Lot
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, lotnumTx.getText());
			addParam(root, sdateActivationTx.getText());
			addParam(root, edateActivationTx.getText());
			addParam(root, sdateExpirationTx.getText());
			addParam(root, edateExpirationTx.getText());
			addParam(root, lotsortbyList.getSelectedItem());
			break;

		case 4:	//All CDRs
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, shourTx.getText());
			addParam(root, sminuteTx.getText());
			addParam(root, ssecondTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, ehourTx.getText());
			addParam(root, eminuteTx.getText());
			addParam(root, esecondTx.getText());
			addParam(root, cdrsortbyList.getSelectedItem());
			addParam(root, cdrtableList.getSelectedItem());
			break;

		case 5:	//Top 5 Treminations
			addParam(root, "View");
			//addParam(root, "Export");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			break;

		case 6:	//Number of Refreshes
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			//addParam(root, sdateTx.getText());
			//addParam(root, edateTx.getText());
			addParam(root, refsortbyList.getSelectedItem());
			break;

		case 7:	//Denied Service
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, densortbyList.getSelectedItem());
			addParam(root, cdrtableList.getSelectedItem());
			break;

		case 8:	//Num of Denied Service
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, ndnsortbyList.getSelectedItem());
			addParam(root, cdrtableList.getSelectedItem());
			break;

		case 9:	//Revenue
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, revsortbyList.getSelectedItem());
			break;

		case 10:	//Revenue-Destination Summary
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, rvdsortbyList.getSelectedItem());
			break;

		case 11:	//Calling Card Usage
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, sdateTx.getText());
			addParam(root, shourTx.getText());
			addParam(root, sminuteTx.getText());
			addParam(root, ssecondTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, ehourTx.getText());
			addParam(root, eminuteTx.getText());
			addParam(root, esecondTx.getText());
			addParam(root, ccusortbyList.getSelectedItem());
			break;

		case 12:	//CDRs 2
			addParam(root, " ");
			addParam(root, ispvnList.getSelectedItem());
			addParam(root, actTx.getText());
			addParam(root, sdateTx.getText());
			addParam(root, shourTx.getText());
			addParam(root, sminuteTx.getText());
			addParam(root, ssecondTx.getText());
			addParam(root, edateTx.getText());
			addParam(root, ehourTx.getText());
			addParam(root, eminuteTx.getText());
			addParam(root, esecondTx.getText());
			addParam(root, sortbyList.getSelectedItem());
			break;
		}

		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, cReportID);
	}

	void addParam(Element e, String val)
	{
		Element p = e.getOwnerDocument().createElement("Param");
		p.setAttribute("Val", val);
		e.appendChild(p);
	}

	//handle data from HttpCommunicator
	public void receiveHttpData(Object data, int dataID)
	{
		XToolkit.hideProgressMessage();
		Document doc = (Document)data;
		if(doc == null) return;
/*if(dataID == 5) {
	Element root = doc.getDocumentElement();
	String RepUrl = root.getAttribute("ReportURL");
	AppConfig.setHtmlData(RepUrl);
	AppConfig.sendHtmlMessage(AppConfig.EXPORT_DATA);
	return;
}*/
		String rData = AppConfig.getParser().getXML(doc);
		rData = rData.substring(rData.indexOf("<TR>"));
		rData = rData.substring(0, rData.length()-10);
		AppConfig.setHtmlData("<H1>"+reportName[dataID]+" Report</H1><hr><br>"+
									 "<Table bgcolor=#E4E4E4 width=300 HSPACE=0 VSPACE=0 BORDER=1 CELLPADDING=2 CELLSPACING=0>"+
									 rData+"</Table>");
		AppConfig.sendHtmlMessage(AppConfig.SHOW_HTML);
	}
}
