import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class ToolsApp extends Panel implements AppModule, ActionListener
{
	private Color appBtnColor  = new Color(228, 228, 228);
	BillingApplet billingApp = AppConfig.getBillingApplet();

	private static final String[] appOptions = { "Clear Cache", "User Guide", "Technical Docs" };

	public ToolsApp()
	{
		this.setLayout(null);
		this.setBounds(AppConfig.ClientIndent, 0, AppConfig.ClientWidth, AppConfig.TotalHeight);
		this.setBackground(AppConfig.Color_Client);

		int btnTop = 32;
		int btnWidth = 150, btnHeight = 24;
		for(int i=0; i < appOptions.length; i++)
		{
		XButton	btn1 = new XButton(appOptions[i]);
		btn1.setBounds(20+(btnWidth+5)*i, btnTop, btnWidth, btnHeight);
		btn1.setColor(appBtnColor);
		btn1.addActionListener(this);
		btn1.setActionCommand(appOptions[i]);
		this.add(btn1);
		}
	}

	public void paint(Graphics g)
	{
		g.setColor(AppConfig.Color_ModuleTitleBar);
		g.fillRect(0, 0, AppConfig.ClientWidth, 20);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SOFT3D);
		XToolkit.draw3DBox(g, 0, 0, AppConfig.ClientWidth+1, 21, true);
		g.setColor(Color.white);
		g.setFont(AppConfig.Font_ModuleTitle);
		g.drawString(moduleName[TOOLS], 5, 16);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SHARP3D);
		XToolkit.draw3DLineH(g, 0, AppConfig.DividerTop, AppConfig.ClientWidth+1, 1, false);
	}


	//AppModule interface methods
	public short getModuleID() { return AppModule.TOOLS; }

	public Container getModuleContainer() { return this; }

	public void setActive(boolean state)
	{
		if(state)
		{	AppConfig.setActiveModule(this);
			AppConfig.getCustomerPanel().setVisible(false);
		}
		this.setVisible(state);
	}

	public void reset() { }

	//ActionListener interface
	public void actionPerformed(ActionEvent e)
	{
		String cOption = e.getActionCommand();

		if(cOption.equals("User Guide"))
			try {
			billingApp.appContext.showDocument(new URL(billingApp.getDocumentBase(),"docs/user_docs/index.html"), "tmpf0101docs1");
			} catch (Exception ex) { System.out.println("URL Error: "+ex.toString()); }
		else if(cOption.equals("Technical Docs"))
			try {
			billingApp.appContext.showDocument(new URL(billingApp.getDocumentBase(),"docs/tech_docs/index.html"), "tmpf0101docs2");
			} catch (Exception ex) { System.out.println("URL Error: "+ex.toString()); }
	}

}
