import java.awt.*;
import java.awt.event.*;

/**
This class implements the MessageBox to display static or progress
messages.
*/
public class XMsg extends Panel implements ActionListener
{
	Timer xTimer;
	boolean timerEvent=false, timerStarted=false;
	int tick=-1;
	Button btnMsg = new Button();

	public XMsg()
	{
		super();
		//No thanks, we will use our own Layout
		this.setLayout(null);
		btnMsg.setBounds(133, 133, 80, 23);
		btnMsg.addActionListener(this);
		btnMsg.setActionCommand("CLOSE_MSG");
		this.add(btnMsg);
		//Message box is invisible at all times, except when we have to show a message
		this.setVisible(false);
	}

	/**
	This method must be called to display an OK button for static messages
	*/
	public void staticMessage() { btnMsg.setLabel("OK"); }

	/**
	Called by XToolkit to start the clock ticks for progress messages
	*/
	public void startTimer()
	{
		if(timerStarted) return;
		btnMsg.setLabel("Cancel");	//make sure we can stop the progress clock
		xTimer = new Timer(110);
		xTimer.addActionListener(this);
		tick = -1;
		timerStarted=true;
		xTimer.start();	//start the timer thread
	}

	/**
	This interrupts the timer clock
	*/
	public void stopTimer()
	{
		if(timerStarted)
		{	xTimer.interrupt();
			timerStarted=false;
		}
	}

	public void update(Graphics g) { paint(g); }

	public void paint(Graphics g)
	{
		if(timerEvent) { timerEvent=false;  XToolkit.updateMsgClock(g, tick); }
		else XToolkit.drawMsgbox(g);
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equals("CLOSE_MSG"))
		{
			XToolkit.closeMessage();	//XToolkit is the controller here
			return;
		}

		tick++;
		//if(tick > 24) { xTimer.interrupt(); this.setVisible(false); return; }
		timerEvent = true;
		repaint();
	}

}
